// StdEcx.h :     ECX
//


#ifndef __STDECX_H_MAIN_INCLUDE_FILE__
#define __STDECX_H_MAIN_INCLUDE_FILE__
#pragma once
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
#define VERSION_STDECX   "01.09.2020"


/////////////////////////////////////////////////////////////////////////////
// ,   
/////////////////////////////////////////////////////////////////////////////
#define ECX_LIBRARY   ("Ecx Library (" VERSION_STDECX ")")
#pragma message ECX_LIBRARY

//#define USED_PRIMENUMBERSARRAY


/////////////////////////////////////////////////////////////////////////////
//  Windows API  Run-Time Library
/////////////////////////////////////////////////////////////////////////////
#define OEMRESOURCE
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>
#include <crtdbg.h>
#include <typeinfo>



/////////////////////////////////////////////////////////////////////////////
//       
/////////////////////////////////////////////////////////////////////////////
#include "_config\@config.h"


/////////////////////////////////////////////////////////////////////////////
//  API
/////////////////////////////////////////////////////////////////////////////

#ifdef USED_LIB_ECXSTATIC
	#include "api\EcxStatic\__EcxStatic.h"
	#ifndef _DEBUG
		#pragma comment (lib, "EcxStaticD.lib")
	#else
		#pragma comment (lib, "EcxStaticD.lib")
	#endif
#endif

#ifdef USED_LIB_FREETYPE
	#include "api\FreeType\include\ft2build.h"
	#ifndef _DEBUG
		#pragma comment (lib, LIB_FREETYPE)
	#else
		#pragma comment (lib, LIB_FREETYPE_D)
	#endif
#endif

#ifdef USED_LIB_HARUPDF
	#include "api\HaruPDF\hpdf.h"
	#ifndef _DEBUG
		#pragma comment (lib, "HaruPDF.lib")
	#else
		#pragma comment (lib, "HaruPDF_D.lib")
	#endif
#endif

#ifdef USED_LIB_HTMLHELP
	#include "api\HtmlHelp\htmlhelp.h"
	#pragma comment (lib, "htmlhelp.lib")
#endif

#ifdef USED_LIB_ZLIB
	#include "api\zlib\zlib.h"
	#ifndef _DEBUG
		#pragma comment (lib, "ZLib.lib")
	#else
		#pragma comment (lib, "ZLib_D.lib")
	#endif
#endif


/////////////////////////////////////////////////////////////////////////////
//   API
/////////////////////////////////////////////////////////////////////////////
#pragma comment (lib, "msimg32.lib")


/////////////////////////////////////////////////////////////////////////////
//   ,   
/////////////////////////////////////////////////////////////////////////////
#include "_config\@header.h"
#include "_macro\@macro.h"
#include "_types\@types.h"


/////////////////////////////////////////////////////////////////////////////
// crt
/////////////////////////////////////////////////////////////////////////////
#include "crt\Debugging\DebugRoutines\DebugRoutines.h"

#include "crt\BufferManipulation\BufferManipulationFunc.h"
#include "crt\BufferManipulation\BufferManipulationMacro.h"
#include "crt\BufferManipulation\EArray.h"
#include "crt\BufferManipulation\ELineArray.h"
#include "crt\BufferManipulation\EList.h"
#include "crt\BufferManipulation\EMemory.h"
#include "crt\BufferManipulation\ERangeArray.h"
#include "crt\BufferManipulation\Heap.h"
#include "crt\BufferManipulation\Hash.h"
#include "crt\BufferManipulation\ETree.h"
#include "crt\BufferManipulation\ETree_FileSystem.h"
#include "crt\BufferManipulation\EJsonPath.h"
#include "crt\BufferManipulation\EJson.h"

#include "crt\CharacterClassification\CharacterClassification.h"
#include "crt\CharacterClassification\CharacterClassificationFunc.h"
#include "crt\CharacterClassification\CharacterClassificationMacro.h"
#include "crt\CharacterClassification\EBitArray.h"
#include "crt\CharacterClassification\ERandomizeChar.h"

#include "crt\COM\COM.h"
#include "crt\COM\COMFunc.h"
#include "crt\COM\EGuid.h"

#include "crt\DateTimeManagement\DateTimeManagement.h"
#include "crt\DateTimeManagement\DateTimeManagementFunc.h"
#include "crt\DateTimeManagement\DateTimeManagementMacro.h"

#include "crt\DynamicLinkLibraries\DynamicLinkLibrariesFunc.h"
#include "crt\DynamicLinkLibraries\DynamicLinkLibrariesMacro.h"
#include "crt\DynamicLinkLibraries\EDynaLink.h"
#include "crt\DynamicLinkLibraries\UpdatePatch.h"

#include "crt\FF\Dbf.h"

#include "crt\FileInputOutput\FileInputOutput.h"
#include "crt\FileInputOutput\FileInputOutputFunc.h"
#include "crt\FileInputOutput\EPath.h"

#include "crt\FileInstallationLibrary\FileInstallationLibraryFunc.h"

#include "crt\FloatingPointSupport\FloatingPointSupportFunc.h"
#include "crt\FloatingPointSupport\FloatingPointSupportMacro.h"

#include "crt\GDI\EIndicatorLCD.h"

#include "crt\GDI\Bitmaps\ECanvas.h"
#include "crt\GDI\Bitmaps\Bitmap.h"

#include "crt\GDI\Colors\Colors.h"
#include "crt\GDI\Colors\ColorsFunc.h"
#include "crt\GDI\Colors\ColorsMacro.h"
#include "crt\GDI\Colors\ColorDefinition.h"

#include "crt\GDI\FilledShapes\FilledShapesFunc.h"
#include "crt\GDI\PaintingDrawing\PaintingDrawingFunc.h"
#include "crt\GDI\Rectangles\RectanglesMacro.h"
#include "crt\GDI\Rectangles\rectx.h"

#include "crt\Internet\Internet.h"
#include "crt\Internet\InternetFunc.h"

#include "crt\IPC\InterprocessCommunicationsFunc.h"

#include "crt\Shell\ShellFunc.h"
#include "crt\Shell\CommonControls\TreeViewControls\TreeViewControls.h"
#include "crt\Shell\CommonControls\TreeViewControls\TreeViewControlsFunc.h"
#include "crt\Shell\CommonControls\TreeViewControls\TreeViewControlsMacro.h"

#include "crt\StringManipulation\StringManipulationFunc.h"
#include "crt\StringManipulation\StringManipulationMacro.h"

#include "crt\SystemInformation\SystemInformation.h"
#include "crt\SystemInformation\SystemInformationFunc.h"

#include "crt\TextParsing\TextParsing.h"
#include "crt\TextParsing\TextParsingFunc.h"
#include "crt\TextParsing\TextParsingMacro.h"
#include "crt\TextParsing\EConfig.h"

#include "crt\Timers\EHighResolutionTimer.h"

#include "crt\Windowing\Messages\Messages.h"
#include "crt\Windowing\Messages\MessagesFunc.h"
#include "crt\Windowing\Messages\MessagesMacro.h"

#include "crt\Windowing\Windows\WindowsFunc.h"
#include "crt\Windowing\Windows\EWindowPlacement.h"




/*
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
#include ""
*/



/////////////////////////////////////////////////////////////////////////////
#endif // __STDECX_H_MAIN_INCLUDE_FILE__
