// __EStringFormat.h : header file
//

///////////////////////////
//////// ECXSTATIC ////////
///////////////////////////

#ifndef __ESTRINGFORMAT_H__
#define __ESTRINGFORMAT_H__
#pragma once
/////////////////////////////////////////////////////////////////////////////

#include "__EString.h"


/////////////////////////////////////////////////////////////////////////////
//  __EStringFormat.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION___ESTRINGFORMAT   "08.03.2019"


//////////////////////////////////////////////////////////// EStringFormat //
//   EStringFormat : strf
/////////////////////////////////////////////////////////////////////////////
class EStringFormat : public EString
{
public:

	/////////////////////////////////////////////////////////////////
	//   
	/////////////////////////////////////////////////////////////////
	EStringFormat();


	EString ByteSize(DWORD dwLowSize, DWORD dwHighSize = 0, BOOL isRus = TRUE);


	EString GetLanguageName(BOOL isLocale, BOOL isUpper);
	EString GetDayName(int nDay, BOOL isFull, BOOL isUpper);
	EString GetMonthName(int nMonth, BOOL isFull, BOOL isUpper);

	EString Date(LPCSTR lpszDateFormat, SYSTEMTIME* pst = NULL);
	EString Time(LPCSTR lpszTimeFormat, SYSTEMTIME* pst = NULL);

	EString Number(DWORD dwLow, DWORD dwHigh, int nLang, BOOL isBinary);
	EString TrNum(DWORD dwLow, DWORD dwHigh, LPCSTR lpszFiller, BOOL isBinary);


	EString RomanNumber(int nNumber);
	EString HexSequence(BYTE* pBuf, int nCount, BOOL isChars = FALSE, LPCSTR szAdder = NULL);


	EString PercentEncode(LPCSTR lpszSource);


	void SetLanguage(WORD wPrimaryLanguage, WORD wSubLanguage = SUBLANG_DEFAULT);
	LCID GetLanguage();

private:

	EString __call(int function, void* lpv1, void* lpv2, void* lpv3);
	EString _number(DWORD dwLow, int nMode, int nLang);

};


/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
static LCTYPE g_lctDay[][2] = 
{
	LOCALE_SABBREVDAYNAME1, LOCALE_SDAYNAME1,		//   = 0
	LOCALE_SABBREVDAYNAME2, LOCALE_SDAYNAME2,		//       = 1
	LOCALE_SABBREVDAYNAME3, LOCALE_SDAYNAME3,		//         = 2
	LOCALE_SABBREVDAYNAME4, LOCALE_SDAYNAME4,		//       = 3
	LOCALE_SABBREVDAYNAME5, LOCALE_SDAYNAME5,		//       = 4
	LOCALE_SABBREVDAYNAME6, LOCALE_SDAYNAME6,		//       = 5
	LOCALE_SABBREVDAYNAME7, LOCALE_SDAYNAME7		//   = 6
};


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
static LCTYPE g_lctMonth[][2] = 
{
	LOCALE_SABBREVMONTHNAME1,  LOCALE_SMONTHNAME1,	// 
	LOCALE_SABBREVMONTHNAME2,  LOCALE_SMONTHNAME2,	// 
	LOCALE_SABBREVMONTHNAME3,  LOCALE_SMONTHNAME3,	// 
	LOCALE_SABBREVMONTHNAME4,  LOCALE_SMONTHNAME4,	// 
	LOCALE_SABBREVMONTHNAME5,  LOCALE_SMONTHNAME5,	// 
	LOCALE_SABBREVMONTHNAME6,  LOCALE_SMONTHNAME6,	// 
	LOCALE_SABBREVMONTHNAME7,  LOCALE_SMONTHNAME7,	// 
	LOCALE_SABBREVMONTHNAME8,  LOCALE_SMONTHNAME8,	// 
	LOCALE_SABBREVMONTHNAME9,  LOCALE_SMONTHNAME9,	// 
	LOCALE_SABBREVMONTHNAME10, LOCALE_SMONTHNAME10,	// 
	LOCALE_SABBREVMONTHNAME11, LOCALE_SMONTHNAME11,	// 
	LOCALE_SABBREVMONTHNAME12, LOCALE_SMONTHNAME12	// 
};


/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
static char* g_szSeason[][5] =
{
	"",  "",  "Winter", "Winter",   "Hiver",
	"", "", "Spring", "Frhling", "Printemps",
	"",  "˳",  "Summer", "Sommer",   "'Et'e",
	"", "", "Autumn", "Herbst",   "Automne"
};


//////////////////////////////////////////////////////////// EStringFormat //
// Inlines
/////////////////////////////////////////////////////////////////////////////
inline void EStringFormat::SetLanguage(WORD wPrimaryLanguage, WORD wSubLanguage)
	{ *(LCID*)GetData()->sde.nData = MAKELCID(MAKELANGID(wPrimaryLanguage, wSubLanguage), SORT_DEFAULT); }
inline LCID EStringFormat::GetLanguage()
	{ return *(LCID*)GetData()->sde.nData; }


///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
#define TERA_BYTE  1099511627776	// 2^40 
#define GIGA_BYTE  1073741824		// 2^30 
#define MEGA_BYTE  1048576			// 2^20  
#define KILO_BYTE  1024				// 2^10  


///////////////////////////////////////////////////////////////////////////////
#endif // __ESTRINGFORMAT_H__
