// EString.h : source file
//

///////////////////////////
//////// ECXSTATIC ////////
///////////////////////////

#include "..\..\__EcxStatic.h"


/////////////////////////////////////////////////////////////////////////////

#pragma warning(disable : 4035) // no return value



//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
DWORD _EcxHashProc(LPCSTR lpszSrc, int nMode)
{
	char* tmp = (char*)lpszSrc;
	DWORD nHash = 0;
	while(*tmp) nHash += (nHash << 5) + *tmp++;
	return nHash;
}

//////////////////////////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////////////////////////
EString _EcxStringFromCLSID(GUID guid)
{
	char szGuid[256];
	wsprintf(szGuid, "{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
		guid.Data1, guid.Data2, guid.Data3,
		guid.Data4[0], guid.Data4[1], guid.Data4[2], guid.Data4[3],
		guid.Data4[4], guid.Data4[5], guid.Data4[6], guid.Data4[7]);
	return szGuid;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////

//  
EString::EString()
{
	m_pBuffer = NULL;
//	Init();
	mem_alloc(0);
	str_release(0);
}

//   count,    ch
EString::EString(char ch, int count)
{
	m_pBuffer = NULL;
//	Init();
	str_set(ch, count);
}

//    EString&
EString::EString(const EString& src)
{
	m_pBuffer = NULL;
//	Init();
	str_ncpy(src.m_pBuffer, src.GetData()->nStringLength);
}

//    EString*
EString::EString(const EString* src)
{
	if(src == NULL)
	{
		Empty();
		return;
	}

	m_pBuffer = NULL;
//	Init();
	str_ncpy(src->m_pBuffer, src->GetData()->nStringLength);
}

//   src
EString::EString(LPCSTR src)
{
	m_pBuffer = NULL;
//	Init();
	str_cpy((void*)src);
}

//  ID   String Table
EString::EString(int nID)
{
	LoadString(nID);
}

/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
EString::~EString()
{
	mem_free(m_pBuffer);
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
EString* EString::SetString(LPCSTR src, int nNull)
{
	mem_free(m_pBuffer);
	m_pBuffer = NULL;
//	Init();
	if(src == NULL)
	{
		switch(nNull)
		{
			case 1: *this = "<null>"; break;
			case 2: *this = "NULL"; break;
			case 3: *this = "null"; break;
			default: break;
		}
	}
	else
		str_cpy((void*)src);
	return this;
}

/////////////////////////////////////////////////////////////////////////////+++
//   
/////////////////////////////////////////////////////////////////////////////
int& EString::operator[](int nIndex)
{
	ic_normalize_index(nIndex);
	return (int&)m_pBuffer[nIndex];
}

/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
const EString& EString::operator=(const EString& src)
{
	str_ncpy(src.m_pBuffer, src.GetData()->nStringLength);
	return *this;
}

const EString& EString::operator=(const EString* src)
{
	str_ncpy(src->m_pBuffer, src->GetData()->nStringLength);
	return *this;
}

const EString& EString::operator=(char ch)
{
	str_ncpy(&ch, 1);
	return *this;
}

const EString& EString::operator=(LPCSTR src)
{
	str_cpy((void*)src);
	return *this;
}

//////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
EString __stdcall operator+(const EString& str1, const EString& str2)
{
	EString tmp;
	tmp.str_ncpy(str1.m_pBuffer, str1.GetData()->nStringLength);
	tmp.str_ncat(str2.m_pBuffer, str2.GetData()->nStringLength);
	return tmp;
}

EString __stdcall operator+(const EString& str1, char ch)
{
	EString tmp;
	tmp.str_ncpy(str1.m_pBuffer, str1.GetData()->nStringLength);
	tmp.str_ncat(&ch, 1);
	return tmp;
}

EString __stdcall operator+(char ch, const EString& str2)
{
	EString tmp;
	tmp.str_ncpy(&ch, 1);
	tmp.str_ncat(str2.m_pBuffer, str2.GetData()->nStringLength);
	return tmp;
}

EString __stdcall operator+(const EString& str1, wchar_t ch)
{
	EString tmp;
	tmp.str_ncpy(str1.m_pBuffer, str1.GetData()->nStringLength);
	tmp.str_ncat(&ch, 1);
	return tmp;
}

EString __stdcall operator+(wchar_t ch, const EString& str2)
{
	EString tmp;
	tmp.str_ncpy(&ch, 1);
	tmp.str_ncat(str2.m_pBuffer, str2.GetData()->nStringLength);
	return tmp;
}

EString __stdcall operator+(const EString& str1, LPCSTR str2)
{
	EString tmp;
	tmp.str_ncpy(str1.m_pBuffer, str1.GetData()->nStringLength);
	tmp.str_cat((void*)str2);
	return tmp;
}

EString __stdcall operator+(LPCSTR str1, const EString& str2)
{
	EString tmp;
	tmp.str_cpy((void*)str1);
	tmp.str_ncat(str2.m_pBuffer, str2.GetData()->nStringLength);
	return tmp;
}

EString __stdcall operator+(const EString& str1, LPCWSTR str2)
{
	EString tmp;
	tmp.str_ncpy(str1.m_pBuffer, str1.GetData()->nStringLength);
	tmp.str_cat((void*)str2);
	return tmp;
}

EString __stdcall operator+(LPCWSTR str1, const EString& str2)
{
	EString tmp;
	tmp.str_cpy((void*)str1);
	tmp.str_ncat(str2.m_pBuffer, str2.GetData()->nStringLength);
	return tmp;
}

//////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
const EString& EString::operator+=(char ch)
{
	str_ncat(&ch, 1);
	return *this;
}

const EString& EString::operator+=(LPCSTR src)
{
	str_cat((void*)src);
	return *this;
}

const EString& EString::operator+=(const EString& src)
{
	str_ncat(src.m_pBuffer, src.GetData()->nStringLength);
	return *this;
}

const EString& EString::operator+=(const EString* src)
{
	str_ncat(src->m_pBuffer, src->GetData()->nStringLength);
	return *this;
}

//////////////////////////////////////////////////////////////////////////////+++
//  
/////////////////////////////////////////////////////////////////////////////
EString __stdcall operator*(const EString& str, int count)
{
	EString tmp;
	tmp.str_set(str.m_pBuffer, count);
	return tmp;
}

EString __stdcall operator*(int count, const EString& str)
{
	EString tmp;
	tmp.str_set(str.m_pBuffer, count);
	return tmp;
}

//////////////////////////////////////////////////////////////////////////////+++
//    
/////////////////////////////////////////////////////////////////////////////
const EString& EString::operator*=(int count)
{
	EString tmp;
	tmp.str_set(m_pBuffer, count);
	*this = tmp;
	return *this;
}

//////////////////////////////////////////////////////////////////////////////+++
//     nIndex1  nIndex2 
/////////////////////////////////////////////////////////////////////////////
const EString EString::operator()(int nIndex1, int nIndex2)
{
	ic_normalize_index(nIndex1);
	ic_normalize_index(nIndex2);

	int nCount = nIndex2 - nIndex1 + 1;
	if(nCount < 0) nCount = 0;
	if(nIndex2 > GetData()->nStringLength) nCount = GetData()->nStringLength - nIndex1;
	if(nIndex1 > GetData()->nStringLength) nCount = 0;

	if(nIndex1 == 0 && nIndex1 + nCount == GetData()->nStringLength) return *this;

	EString tmp;
	tmp.mem_copy(0, get_buffer_offset(nIndex1), nCount);
	tmp.str_release(nCount);
	return tmp;
}

//////////////////////////////////////////////////////////////////////////////+++
//    (  - NULL)
//////////////////////////////////////////////////////////////////////////////
EString* EString::Concat(LPCSTR str1, ...)
{
	str_cat((void*)str1);
	va_list marker;
	va_start(marker, str1);
	LPCSTR tmp;
	while(1)
	{
		tmp = va_arg(marker, LPCSTR);
		if(!tmp) break;
		str_cat((void*)tmp);
	}
	va_end(marker);
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//       
//////////////////////////////////////////////////////////////////////////////
int EString::LoadString(int nID)
{
	mem_alloc(256);
	int length = ::LoadString(::GetModuleHandle(NULL), nID, m_pBuffer, 256);
	str_release(length);
	return length;
}

//////////////////////////////////////////////////////////////////////////////+++
//    nCount   (nCount > 0) 
//  nCount   (nCount < 0)
//////////////////////////////////////////////////////////////////////////////
EString EString::Right(int nCount)
{
	if(nCount < 0)
	{
		return Left(GetData()->nStringLength + nCount);
	}
	ic_normalize_count(nCount);
	EString tmp;
	tmp.mem_copy(0, get_buffer_offset(GetData()->nStringLength - nCount), nCount);
	tmp.str_release(nCount);
	return tmp;
}
EString* EString::_Right(int nCount)
{
	*this = Right(nCount);
	return this;
}

//////////////////////////////////////////////////////////////////////////////+++
//    nCount   (nCount > 0) 
//  nCount   (nCount < 0)
//////////////////////////////////////////////////////////////////////////////
EString EString::Left(int nCount)
{
	if(nCount < 0)
	{
		return Right(GetData()->nStringLength + nCount);
	}
	ic_normalize_count(nCount);
	EString tmp;
	tmp.mem_copy(0, get_buffer_offset(0), nCount);
	tmp.str_release(nCount);
	return tmp;
}
EString* EString::_Left(int nCount)
{
	*this = Left(nCount);
	return this;
}

//////////////////////////////////////////////////////////////////////////////+++
//     nIndex  nCount  (nIndex > 0) 
//   nIndex - 1  nCount   (nIndex < 0) 
//  nCount  (nCount < 0)
//////////////////////////////////////////////////////////////////////////////
EString EString::Mid(int nIndex, int nCount)
{
	if(nIndex < 0)
	{
		nIndex = -nIndex - abs(nCount);
	}
	if(nCount < 0)
	{
		EString tmp(this);
		tmp.Delete(nIndex, -nCount);
		return tmp;
	}
	ic_normalize_index_count(nIndex, nCount);
	EString tmp;
	tmp.mem_copy(0, get_buffer_offset(nIndex), nCount);
	tmp.str_release(nCount);
	return tmp;
}
EString* EString::_Mid(int nIndex, int nCount)
{
	*this = Mid(nIndex, nCount);
	return this;
}


//////////////////////////////////////////////////////////////////////////////+++
//     nIndex    (nIndex > 0) 
//   nIndex - 1    (nIndex < 0)
//////////////////////////////////////////////////////////////////////////////
EString EString::Mid(int nIndex)
{
	if(nIndex < 0)
	{
		return Left(-nIndex);
	}
	int nLength = GetData()->nStringLength;
	int nCount = (nIndex < 0) ? nLength + nIndex + 1 : nLength - nIndex;
	return Mid(nIndex, nCount);
}
EString* EString::_Mid(int nIndex)
{
	*this = Mid(nIndex);
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//     - chFind c  nFindNum
//////////////////////////////////////////////////////////////////////////////
EString EString::LeftTo(char chFind, int nFindNum)
{
	int p2, p1 = 0;
	while(1)
	{
		p2 = Find(chFind, p1);
		nFindNum--;
		if(p2 == -1 || nFindNum == 0) break;
		p1 = p2 + 1;
	}
	if(p2 != -1 && nFindNum == 0) return Left(p2);
	return "";
}




//////////////////////////////////////////////////////////////////////////////
//    FormatV
//////////////////////////////////////////////////////////////////////////////
#define FORCE_ANSI      0x10000
#define FORCE_UNICODE   0x20000
#define FORCE_INT64     0x40000

//////////////////////////////////////////////////////////////////////////////
//     lpszFormat    argList
//////////////////////////////////////////////////////////////////////////////
void EString::FormatV(LPCSTR lpszFormat, va_list argList)
{
	va_list argListSave = argList;

	//   
	int nMaxLen = 0;
	LPCSTR str = lpszFormat;

	while(*str)
	{
		//   '%',     '%%'
		if(*str != '%' || *(++str) == '%')
		{
			str++;
			nMaxLen += 1;
			continue;
		}

		int nItemLen = 0;

		//   '%'   
		int nWidth = 0;
		for(; *str != '\0'; str++)
		{
			//    
			if(*str == '#')
			{
				nMaxLen += 2;   //  '0x'
			}
			else
				if(*str == '*')
				{
					nWidth = va_arg(argList, int);
				}
			else
				if(*str == '-' || *str == '+' || *str == '0' || *str == ' ')
				{
				}
				else //   
					break;
		}

		//   
		if(nWidth == 0)
		{
			nWidth = atoi(str);
			for(; *str != '\0' && isdigit(*str); str++);
		}

		int nPrecision = 0;
		if(*str == '.')
		{
			//   '.' (width.precision)
			str++;

			//  precision   
			if(*str == '*')
			{
				nPrecision = va_arg(argList, int);
				str++;
			}
			else
			{
				nPrecision = atoi(str);
				for(; *str != '\0' && isdigit(*str); str++);
			}
		}

		//    
		int nModifier = 0;
		if(strncmp(str, "I64", 3) == 0)
		{
			str += 3;
			nModifier = FORCE_INT64;
		}
		else
		{
			// 
			switch(*str)
			{
				case 'h':
				{
					nModifier = FORCE_ANSI;
					str++;
					break;
				}

				case 'l':
				{
					nModifier = FORCE_UNICODE;
					str++;
					break;
				}

				//   
				case 'F':
				case 'N':
				case 'L':
				{
					str++;
					break;
				}
			}
		}

		//   
		switch(*str | nModifier)
		{
			//  
			case 'c':
			case 'C':
			{
				nItemLen = 2;
				va_arg(argList, char);
				break;
			}

			case 'c'|FORCE_ANSI:
			case 'C'|FORCE_ANSI:
			{
				nItemLen = 2;
				va_arg(argList, char);
				break;
			}

			case 'c'|FORCE_UNICODE:
			case 'C'|FORCE_UNICODE:
			{
				nItemLen = 2;
				va_arg(argList, unsigned short);
				break;
			}

			// 
			case 's':
			{
				LPCSTR pstrNextArg = va_arg(argList, LPCSTR);
				if(pstrNextArg == NULL)
				{
				   nItemLen = 6;  // "(null)"
				}
				else
				{
				   nItemLen = strlen(pstrNextArg);
				   nItemLen = max(1, nItemLen);
				}
				break;
			}

			case 'S':
			{
				LPWSTR pstrNextArg = va_arg(argList, LPWSTR);
				if(pstrNextArg == NULL)
				{
				   nItemLen = 6;  // "(null)"
				}
				else
				{
				   nItemLen = wcslen(pstrNextArg);
				   nItemLen = max(1, nItemLen);
				}
				break;
			}

			case 's'|FORCE_ANSI:
			case 'S'|FORCE_ANSI:
			{
				LPCSTR pstrNextArg = va_arg(argList, LPCSTR);
				if (pstrNextArg == NULL)
				{
				   nItemLen = 6; // "(null)"
				}
				else
				{
				   nItemLen = lstrlenA(pstrNextArg);
				   nItemLen = max(1, nItemLen);
				}
				break;
			}

			case 's'|FORCE_UNICODE:
			case 'S'|FORCE_UNICODE:
			{
				LPWSTR pstrNextArg = va_arg(argList, LPWSTR);
				if(pstrNextArg == NULL)
				{
				   nItemLen = 6; // "(null)"
				}
				else
				{
				   nItemLen = wcslen(pstrNextArg);
				   nItemLen = max(1, nItemLen);
				}
				break;
			}
		}

		//  nItemLen  
		if(nItemLen != 0)
		{
			if(nPrecision != 0)
			{
				nItemLen = min(nItemLen, nPrecision);
			}
			nItemLen = max(nItemLen, nWidth);
		}
		else
		{
			switch(*str)
			{
				//  
				case 'd':
				case 'i':
				case 'u':
				case 'x':
				case 'X':
				case 'o':
				{
					if(nModifier & FORCE_INT64)
					{
						va_arg(argList, __int64);
					}
					else
					{
						va_arg(argList, int);
					}
					nItemLen = 32;
					nItemLen = max(nItemLen, nWidth + nPrecision);
					break;
				}

				case 'e':
				case 'g':
				case 'G':
				{
					va_arg(argList, double);
					nItemLen = 128;
					nItemLen = max(nItemLen, nWidth + nPrecision);
					break;
				}

				case 'f':
				{
					va_arg(argList, double);
					nItemLen = 128; // width isn't truncated
					// 312 == strlen("-1+(309 zeroes).")
					// 309 zeroes == max precision of a double
					nItemLen = max(nItemLen, 312 + nPrecision);
					break;
				}

				case 'p':
				{
					va_arg(argList, void*);
					nItemLen = 32;
					nItemLen = max(nItemLen, nWidth + nPrecision);
					break;
				}

				//  
				case 'n':
				{
					va_arg(argList, int*);
					break;
				}

				default:
					break;
			}
		}

		//   nMaxLen  nItemLen
		nMaxLen += nItemLen;
	}

	mem_change(nMaxLen);
	int length = vsprintf(m_pBuffer, lpszFormat, argListSave);
	str_release(length);

	va_end(argListSave);
}

//////////////////////////////////////////////////////////////////////////////
//     lpszFormat   
//////////////////////////////////////////////////////////////////////////////
void EString::Format(LPCSTR lpszFormat, ...)
{
	va_list argList;
	va_start(argList, lpszFormat);
	FormatV(lpszFormat, argList);
	va_end(argList);
}

//////////////////////////////////////////////////////////////////////////////
//      nFormatID   
//////////////////////////////////////////////////////////////////////////////
void EString::Format(int nFormatID, ...)
{
	EString strFormat;
	if(strFormat.LoadString(nFormatID) == 0) return;

	va_list argList;
	va_start(argList, nFormatID);
	FormatV(strFormat, argList);
	va_end(argList);
}

//////////////////////////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////////////////////////
int EString::ScanV(LPCSTR lpszFormat, va_list argList)
{
	return _EcxScanV(m_pBuffer, lpszFormat, argList);
}

//////////////////////////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////////////////////////
int EString::Scan(LPCSTR lpszFormat, ...)
{
	va_list argList;
	va_start(argList, lpszFormat);
	int nAssigned = ScanV(lpszFormat, argList);
	va_end(argList);
	return nAssigned;
}

//////////////////////////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////////////////////////
int EString::Scan(int nFormatID, ...)
{
	EString strFormat;
	if(strFormat.LoadString(nFormatID) == 0) return 0;

	va_list argList;
	va_start(argList, nFormatID);
	int nAssigned = ScanV(strFormat, argList);
	va_end(argList);
	return nAssigned;
}

//////////////////////////////////////////////////////////////////////////////
//   ch   nIndex
//////////////////////////////////////////////////////////////////////////////
int EString::Find(char ch, int nIndex)
{
	if(nIndex < 0) nIndex = 0;
	if(nIndex >= GetData()->nStringLength) return -1;
	LPSTR tmp = strchr(m_pBuffer + nIndex, (int)ch);
	return (tmp == NULL) ? -1 : (int)(tmp - m_pBuffer);
}

//////////////////////////////////////////////////////////////////////////////
//    ch
//////////////////////////////////////////////////////////////////////////////
int EString::FindRev(char ch)
{
	LPSTR tmp = strrchr(m_pBuffer, (int)ch);
	return (tmp == NULL) ? -1 : (int)(tmp - m_pBuffer);
}

//////////////////////////////////////////////////////////////////////////////
//    dwMask   nIndex
//////////////////////////////////////////////////////////////////////////////
int EString::FindClass(DWORD dwMask, int nIndex)
{
	if(nIndex < 0) nIndex = 0;
	if(nIndex >= GetData()->nStringLength) return -1;
	LPSTR tmp = _EcxStrClass(m_pBuffer + nIndex, dwMask);
	return (tmp == NULL) ? -1 : (int)(tmp - m_pBuffer);
}

//////////////////////////////////////////////////////////////////////////////
//     dwMask
//////////////////////////////////////////////////////////////////////////////
int EString::FindClassRev(DWORD dwMask)
{
	int pos1, pos = 0;
	while((pos1 = FindClass(dwMask, pos)) != -1) pos = pos1 + 1;
	return pos - 1;
}

//////////////////////////////////////////////////////////////////////////////
//   str   nIndex
//////////////////////////////////////////////////////////////////////////////
int EString::Find(LPCSTR str, int nIndex)
{
	if(nIndex < 0) nIndex = 0;
	if(nIndex > GetData()->nStringLength) return -1;
	LPSTR tmp = strstr(m_pBuffer + nIndex, str);
	return (tmp == NULL) ? -1 : (int)(tmp - m_pBuffer);
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
int EString::FindRev(LPCSTR str)
{
	int pos1, pos = 0;
	while((pos1 = Find(str, pos)) != -1) pos = pos1 + 1;
	return pos - 1;
}

//////////////////////////////////////////////////////////////////////////////
//       lpszCharSet
//////////////////////////////////////////////////////////////////////////////
int EString::FindOneOf(LPCSTR lpszCharSet)
{
	LPSTR tmp = strpbrk(m_pBuffer, lpszCharSet);
	return (tmp == NULL) ? -1 : (int)(tmp - m_pBuffer);
}

//////////////////////////////////////////////////////////////////////////////+++
//  nCount    nIndex
//////////////////////////////////////////////////////////////////////////////
EString* EString::Delete(int nIndex, int nCount)
{
	int nLength = GetData()->nStringLength;
	ic_normalize_index_count(nIndex, nCount);
	mem_cpy(NULL, nIndex, m_pBuffer, nIndex + nCount, nLength - nIndex - nCount);
	str_release(nLength - nCount);
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
EString* EString::Empty()
{
	mem_alloc(0);
	str_release(0);
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//   ch   nIndex
//////////////////////////////////////////////////////////////////////////////
EString* EString::Insert(int nMode, int nIndex, char ch)
{
	char tmp[] = { ch, '\0' };
	return Insert(nMode, nIndex, tmp);
}

//////////////////////////////////////////////////////////////////////////////+++
//   src   nIndex
//////////////////////////////////////////////////////////////////////////////
EString* EString::Insert(int nMode, int nIndex, LPCSTR src)
{
	ic_normalize_index(nIndex);
	if(nMode == INSERT_AFTER) nIndex++;
	EString tmp;
	int len = str_len((void*)src);
	void* buf = (void*)src;
	tmp.mem_change(GetData()->nStringLength + len);
	mem_cpy(tmp.m_pBuffer, 0, m_pBuffer, 0, nIndex);
	mem_cpy(tmp.m_pBuffer, nIndex, buf, 0, len);
	mem_cpy(tmp.m_pBuffer, nIndex + len, m_pBuffer, nIndex, GetData()->nStringLength - nIndex);
	tmp.str_release(GetData()->nStringLength + len);
	*this = tmp;
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//    ch
//////////////////////////////////////////////////////////////////////////////
EString* EString::Remove(char ch)
{
	int count = tmpRemove(ch, &m_pBuffer);
	str_release(count);
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//     lpszTargets
//////////////////////////////////////////////////////////////////////////////
EString* EString::Remove(LPCSTR lpszTargets)
{
	if(str_len((void*)lpszTargets) > 0)
	{
		int count = 0;
		char *tmp0 = m_pBuffer, *tmp1 = m_pBuffer;
		while(*tmp0)
		{
			if(strchr(lpszTargets, *tmp0))
			{
				tmp0++;
				continue;
			}
			count++;
			*tmp1 = *tmp0;
			tmp0++;
			tmp1++;
		}
		str_release(count);
	}
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//    dwMask
//////////////////////////////////////////////////////////////////////////////
EString* EString::RemoveClass(DWORD dwMask)
{
	int count = 0;
	char *tmp0 = m_pBuffer, *tmp1 = m_pBuffer;
	while(*tmp0)
	{
		if(is_char(*tmp0, dwMask))
		{
			tmp0++;
			continue;
		}
		count++;
		*tmp1 = *tmp0;
		tmp0++;
		tmp1++;
	}
	str_release(count);
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//   chOld   chNew.   nMaxCount.
//////////////////////////////////////////////////////////////////////////////
int EString::Replace(char chOld, char chNew, int nMaxCount)
{
	if(nMaxCount == 0) return 0;
	if(strchr(m_pBuffer, chOld) == NULL) return 0;

	int count = 0;
	char *tmp = m_pBuffer;

	while(*tmp)
	{
		if(*tmp == chOld)
		{
			if(nMaxCount > 0 && nMaxCount == count) break;

			*tmp = chNew;
			count++;
		}
		tmp++;
	}
	return count;
}

//////////////////////////////////////////////////////////////////////////////
//    dwMask   chNew.   nMaxCount.
//////////////////////////////////////////////////////////////////////////////
int EString::ReplaceClass(DWORD dwMask, char chNew, int nMaxCount)
{
	if(nMaxCount == 0) return 0;
	if(_EcxStrClass(m_pBuffer, dwMask) == NULL) return 0;

	int count = 0;
	char *tmp = m_pBuffer;

	while(*tmp)
	{
		if(is_char(*tmp, dwMask))
		{
			if(nMaxCount > 0 && nMaxCount == count) break;

			*tmp = chNew;
			count++;
		}
		tmp++;
	}
	return count;
}

//////////////////////////////////////////////////////////////////////////////
//   lpszOld   lpszNew.   nMaxCount.
//////////////////////////////////////////////////////////////////////////////
int EString::Replace(LPCSTR lpszOld, LPCSTR lpszNew, int nMaxCount)
{
	if(nMaxCount == 0) return 0;
	if(lpszOld == NULL || lpszNew == NULL) return 0;
	if(strstr(m_pBuffer, lpszOld) == NULL) return 0;

	EString str;
	char *pos, *tmp = m_pBuffer;
	int count = 0;
	int lenOld = str_len((void*)lpszOld);
	int lenNew = str_len((void*)lpszNew);

	while(pos = strstr(tmp, lpszOld))
	{
		if(nMaxCount > 0 && nMaxCount == count) break;
		str.str_ncat(tmp, pos - tmp);
		str.str_ncat((void*)lpszNew, lenNew);
		tmp = pos + lenOld;
		count++;
	}
	str.str_ncat(tmp, m_pBuffer + GetData()->nStringLength - tmp);

	*this = str;
	return count;
}

//////////////////////////////////////////////////////////////////////////////
//   lpszOld   lpszNew   nSalt .
//////////////////////////////////////////////////////////////////////////////
int EString::ReplaceSalt(LPCSTR lpszOld, LPCSTR lpszNew, int nSalt)
{
	if(lpszOld == NULL || lpszNew == NULL) return 0;
	if(strstr(m_pBuffer, lpszOld) == NULL) return 0;

	EString str;
	char *pos, *tmp = m_pBuffer;
	int count = 0;
	int lenOld = str_len((void*)lpszOld);
	int lenNew = str_len((void*)lpszNew);

	while(pos = strstr(tmp, lpszOld))
	{
		str.str_ncat(tmp, pos - tmp);
		str.str_ncat((void*)lpszNew, lenNew);
		tmp = pos + lenOld + nSalt;
		count++;
	}
	str.str_ncat(tmp, m_pBuffer + GetData()->nStringLength - tmp);

	*this = str;
	return count;
}

//////////////////////////////////////////////////////////////////////////////
//   lpszOld    nNew
//////////////////////////////////////////////////////////////////////////////
int EString::Replace(LPCSTR lpszOld, int nNew)
{
	EString str;
	str.Format("%d", nNew);
	return Replace(lpszOld, (LPCSTR)str, -1);
}

//////////////////////////////////////////////////////////////////////////////
//   lpszOld    dNew
//////////////////////////////////////////////////////////////////////////////
int EString::Replace(LPCSTR lpszOld, double dNew, int nPrecision)
{
	EString str, form;
	form.Format("%%.%df", nPrecision);
	str.Format(form, dNew);
	return Replace(lpszOld, (LPCSTR)str, -1);
}

//////////////////////////////////////////////////////////////////////////////
//       
//////////////////////////////////////////////////////////////////////////////
int EString::ExpandTabs(int nTabs)
{
	EString spaces('+', nTabs);
	return Replace("\t", spaces);
}

//////////////////////////////////////////////////////////////////////////////
//    lpszTable1     lpszTable2
//////////////////////////////////////////////////////////////////////////////
int EString::Translate(LPCSTR lpszTable1, LPCSTR lpszTable2)
{
	if(str_len((void*)lpszTable1) == 0) return 0;
	int len2 = str_len((void*)lpszTable2);

	int i, count = 0;
	char *pos, *tmp0 = m_pBuffer, *tmp1 = m_pBuffer;
	char ch;

	while(*tmp0)
	{
		ch = *tmp0;
		if(pos = strchr(lpszTable1, *tmp0))
		{
			i = pos - lpszTable1;

			if(i >= len2)
			{
				tmp0++;
				continue;
			}
			ch = lpszTable2[i];
		}
		count++;
		*tmp1 = ch;
		tmp0++;
		tmp1++;
	}

	str_release(count);
	return GetData()->nStringLength;
}

//////////////////////////////////////////////////////////////////////////////
//     ch
//////////////////////////////////////////////////////////////////////////////
int EString::Count(char ch)
{
	if(strchr(m_pBuffer, ch) == NULL) return 0;

	int count = 0;
	char *tmp = m_pBuffer;

	while(*tmp)
	{
		if(*tmp == ch) count++;
		tmp++;
	}
	return count;
}

//////////////////////////////////////////////////////////////////////////////
//     lpsz
//////////////////////////////////////////////////////////////////////////////
int EString::Count(LPCSTR lpsz)
{
	if(lpsz == NULL) return 0;
	if(strstr(m_pBuffer, lpsz) == NULL) return 0;

	EString str;
	char *pos, *tmp = m_pBuffer;
	int count = 0;
	int len = str_len((void*)lpsz);

	while(pos = strstr(tmp, lpsz))
	{
		count++;
		tmp = pos + len;
	}
	return count;
}

//////////////////////////////////////////////////////////////////////////////
//    lpszFileName     m_pBuffer
//////////////////////////////////////////////////////////////////////////////
BOOL EString::Read(LPCSTR lpszFileName)
{
	char* tmp;
	int nLength = _EcxReadTextFile(lpszFileName, &tmp);
	if(nLength == INVALID_FILE_SIZE) return FALSE;
	ToBuffer(nLength);
	memcpy(m_pBuffer, tmp, nLength);
	delete [] tmp;
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//    lpszFileName     m_pBuffer
//////////////////////////////////////////////////////////////////////////////
BOOL EString::Write(LPCSTR lpszFileName)
{
	return _EcxWriteBufferToFile(lpszFileName, (BYTE*)m_pBuffer, GetData()->nStringLength) != INVALID_FILE_SIZE;
}

//////////////////////////////////////////////////////////////////////////////
//    count     m_pBuffer
//////////////////////////////////////////////////////////////////////////////
void* EString::ToBuffer(int count)
{
	mem_change(count);
	str_release(count);
	return m_pBuffer;
}

//////////////////////////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////////////////////////
EString* EString::ToStrW()
{
//	void* buf = get_bufferW();
//	str_cpy(buf);
	return this;
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
char EString::GetLastChar()
{
	return *(m_pBuffer + GetData()->nStringLength - 1);
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
int EString::GetLength()
{
	return GetData()->nStringLength;
}

//////////////////////////////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////////////////////////////
void EString::FormatChar(BOOL isUpper, int nOffset)
{
	if(nOffset >= GetData()->nStringLength) nOffset = GetData()->nStringLength - 1;
	if(nOffset < 0) nOffset = 0;

	if(isUpper)
		::CharUpperBuff(m_pBuffer + nOffset, 1);
	else
		::CharLowerBuff(m_pBuffer + nOffset, 1);
}

//////////////////////////////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////////////////////////////
void EString::TrimLeft(LPCSTR lpszTargets)
{
	if(str_len((void*)lpszTargets) == 0) return;
	char* tmp = m_pBuffer;

	while(*tmp)
	{
		if(strchr(lpszTargets, *tmp) == NULL) break;
		tmp++;
	}

	if(tmp != m_pBuffer)
	{
		int len = GetData()->nStringLength - (tmp - m_pBuffer);
		memmove(m_pBuffer, tmp, len + 1);
		str_release(len);
	}
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
void EString::TrimLeft(char chTarget)
{
	char tmp[] = { chTarget, '\0' };
	TrimLeft(tmp);
}

//////////////////////////////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////////////////////////////
void EString::TrimRight(LPCSTR lpszTargets)
{
	LPTSTR tmp = m_pBuffer;
	LPTSTR lpszLast = NULL;

	while(*tmp)
	{
		if(strchr(lpszTargets, *tmp) != NULL)
		{
			if(lpszLast == NULL) lpszLast = tmp;
		}
		else
			lpszLast = NULL;
		tmp++;
	}

	if(lpszLast != NULL)
	{
		GetData()->nStringLength = lpszLast - m_pBuffer;
		*lpszLast = '\0';
	}
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
void EString::TrimRight(char chTarget)
{
	char tmp[] = { chTarget, '\0' };
	TrimRight(tmp);
}

//////////////////////////////////////////////////////////////////////////////
//       
//////////////////////////////////////////////////////////////////////////////
void EString::Trim(LPCSTR lpszTargets)
{
	TrimLeft(lpszTargets);
	TrimRight(lpszTargets);
}

//////////////////////////////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////////////////////////////
void EString::Trim(char chTarget)
{
	TrimLeft(chTarget);
	TrimRight(chTarget);
}

//////////////////////////////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////////////////////////////
void EString::Trim()
{
	TrimLeft();
	TrimRight();
}

//////////////////////////////////////////////////////////////////////////////
//    lpszQt1, lpszQt2   
//////////////////////////////////////////////////////////////////////////////
void EString::Quote(BOOL isQuote, LPCSTR lpszQt1, LPCSTR lpszQt2)
{
	EString s1, s2, tmp = *this;
	BOOL is1 = TRUE, is2 = TRUE;

	int n1 = str_len((void*)lpszQt1);
	int n2 = str_len((void*)lpszQt2);
	if(tmp.Left(n1) != lpszQt1)
	{
		is1 = FALSE;
		s1 = lpszQt1;
	}
	if(tmp.Right(n2) != lpszQt2)
	{
		is2 = FALSE;
		s2 = lpszQt2;
	}

	if(isQuote)
	{
		*this = s1 + tmp + s2;
	}
	else
	{
		if(is1) Delete(0, n1);
		if(is2) Delete(-1, n2);
	}
}

//////////////////////////////////////////////////////////////////////////////
//    nQt1, nQt2   
//////////////////////////////////////////////////////////////////////////////
void EString::Quote(BOOL isQuote, char chQt1, char chQt2)
{
	char tmp1[] = { chQt1, '\0' };
	char tmp2[] = { chQt2, '\0' };
	Quote(isQuote, tmp1, tmp2);
}

//////////////////////////////////////////////////////////////////////////////
//    ","   
//////////////////////////////////////////////////////////////////////////////
void EString::Quote(BOOL isQuote)
{
	Quote(isQuote, 0x22, 0x22);
}

//////////////////////////////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////////////////////////////
BOOL EString::IsPrefix(LPCSTR lpszPrefix, BOOL isCase)
{
	return Left(str_len((void*)lpszPrefix)).CompareCase(lpszPrefix, isCase) == 0;
}

//////////////////////////////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////////////////////////////
BOOL EString::IsSuffix(LPCSTR lpszSuffix, BOOL isCase)
{
	return Right(str_len((void*)lpszSuffix)).CompareCase(lpszSuffix, isCase) == 0;
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
void EString::AddPrefix(LPCSTR lpszPrefix)
{
	*this = lpszPrefix + *this;
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
void EString::AddSuffix(LPCSTR lpszSuffix)
{
	*this += lpszSuffix;
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
BOOL EString::DeletePrefix(LPCSTR lpszPrefix, BOOL isCase)
{
	if(IsPrefix(lpszPrefix, isCase))
	{
		Delete(0, str_len((void*)lpszPrefix));
		return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
BOOL EString::DeleteSuffix(LPCSTR lpszSuffix, BOOL isCase)
{
	if(IsSuffix(lpszSuffix, isCase))
	{
		Delete(-1, str_len((void*)lpszSuffix));
		return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//          
//////////////////////////////////////////////////////////////////////////////
int EString::CompareCase(LPCSTR src, BOOL isCase)
{
	if(isCase)
		return strcmp(m_pBuffer, src);
	else
		return _stricmp(m_pBuffer, src);
}

//////////////////////////////////////////////////////////////////////////////
//    
//////////////////////////////////////////////////////////////////////////////
BOOL EString::ic_is_invalid_index(int nIndex)
{
	int nLength = GetData()->nStringLength;
	if(nIndex >= nLength) return TRUE;
	if(nIndex + nLength < 0) return TRUE;
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//    
//////////////////////////////////////////////////////////////////////////////
BOOL EString::ic_normalize_index(int& nIndex)
{
	BOOL res = FALSE;
	int nLength = GetData()->nStringLength;

	//   
	if(nIndex < 0)
	{
		//  
		nIndex += nLength;
		res = TRUE;
	}

	//  
	if(nIndex >= nLength) nIndex = nLength - 1;
	if(nIndex < 0) nIndex = 0;

	// TRUE -  
	return res;
}

//////////////////////////////////////////////////////////////////////////////
//       
//////////////////////////////////////////////////////////////////////////////
void EString::ic_normalize_index_count(int& nIndex, int& nCount)
{
	int nLength = GetData()->nStringLength;
	if(ic_normalize_index(nIndex)) nCount = -nCount;

	if(nCount < 0)
	{
		nCount = -nCount;
		nIndex = nIndex - nCount + 1;
		if(nIndex < 0)
		{
			nCount += nIndex;
			nIndex = 0;
		}
	}

	if(nIndex + nCount >= nLength) nCount = nLength - nIndex;
}

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
void EString::ic_normalize_count(int& nCount)
{
	int nLength = GetData()->nStringLength;
	if(nCount < 0) nCount = 0;
	if(nCount > nLength) nCount = nLength;
}

//////////////////////////////////////////////////////////////////////////////+++
//  
//////////////////////////////////////////////////////////////////////////////
int EString::str_len(void* src)
{
	if(src == NULL) return 0;
	return strlen((char*)src);
}

//////////////////////////////////////////////////////////////////////////////+++
//     ch   count
//////////////////////////////////////////////////////////////////////////////
void EString::str_set(int ch, int count)
{
	mem_change(count);
	_strnset(m_pBuffer, ch, count);
	str_release(count);
}

//////////////////////////////////////////////////////////////////////////////+++
//     src   count
//////////////////////////////////////////////////////////////////////////////
void EString::str_set(void* src, int count)
{
	int length = str_len((void*)src);
	if(length == 0) return;
	mem_change(length * count);
	for(int i=0; i<count; i++)
		mem_cpy(NULL, i * length, src, 0, length);
	str_release(length * count);
}

//////////////////////////////////////////////////////////////////////////////+++
//      src
//////////////////////////////////////////////////////////////////////////////
void EString::str_cpy(void* src)
{
	str_ncpy(src, str_len((void*)src));
}

//////////////////////////////////////////////////////////////////////////////+++
//      src  length
//////////////////////////////////////////////////////////////////////////////
void EString::str_ncpy(void* src, int length)
{
	if(src == NULL || length == 0)
	{
		Empty();
		return;
	}

	mem_change(length);
	mem_cpy(NULL, 0, src, 0, length);
	str_release(length);
}

//////////////////////////////////////////////////////////////////////////////+++
//      src
//////////////////////////////////////////////////////////////////////////////
EString* EString::str_cat(void* src)
{
	str_ncat(src, str_len((void*)src));
	return this;
}

//////////////////////////////////////////////////////////////////////////////+++
//      src  length
//////////////////////////////////////////////////////////////////////////////
void EString::str_ncat(void* src, int length)
{
	if(src == NULL || length == 0)
	{
		return;
	}

	void* buf = src;
	int nStringLength = GetData()->nStringLength;
	mem_append(length);
	mem_cpy(NULL, nStringLength, buf, 0, length);
	str_release(nStringLength + length);
}

//////////////////////////////////////////////////////////////////////////////+++
//   
//////////////////////////////////////////////////////////////////////////////
void EString::str_release(int length)
{
	GetData()->nStringLength = length;
	m_pBuffer[length] = '\0';
}


//////////////////////////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////////////////////////
EString EString::info(char* var)
{
	EString tmp;
	EStringData* pData = GetData();
	tmp.Format(" var: %s = '%s';\r\n nStringLength = %d;\r\n nBufferLength = %d;\r\n\r\n",
		var, m_pBuffer, pData->nStringLength, pData->nBufferLength);
	return tmp;
}


//////////////////////////////////////////////////////////////////////////////
//         4 
//////////////////////////////////////////////////////////////////////////////
BOOL EString::mem_alloc(int nLength, BOOL isFree)
{
	if(isFree) mem_free(m_pBuffer);
	int nBufferLength = _even4(nLength + 2);
	EStringData* pData = (EStringData*)new BYTE[nBufferLength + sizeof(EStringData)];
	if(pData == NULL) return FALSE;
	memset(pData, 0, sizeof(EStringData));
	m_pBuffer = (char*)(pData + 1);
	pData->nBufferLength = nBufferLength;
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//      (  )
//////////////////////////////////////////////////////////////////////////////
BOOL EString::mem_append(int nLength)
{
	int len = GetData()->nStringLength + nLength + 1;
	if(len > GetData()->nBufferLength)
	{
		char* tmp = m_pBuffer;
		if(mem_alloc(2 * (GetData()->nStringLength + nLength), FALSE) && tmp != NULL)
		{
			mem_cpy(NULL, 0, tmp, 0, GetData(tmp)->nStringLength);
			data_copy(tmp);
			mem_free(tmp);
			return TRUE;
		}
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//     (  )
//////////////////////////////////////////////////////////////////////////////
BOOL EString::mem_change(int nLength)
{
	char* tmp = m_pBuffer;
	if(mem_alloc(nLength, FALSE) && tmp != NULL)
	{
		data_copy(tmp);
		mem_free(tmp);
		return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////////////////////////
void EString::mem_free(char* pBuf)
{
	if(pBuf != NULL)
	{
		EStringData* pData = (EStringData*)pBuf - 1;
		delete [] pData;
	}
}

//////////////////////////////////////////////////////////////////////////////
//       nOffset  pSrc  nLength
//////////////////////////////////////////////////////////////////////////////
BOOL EString::mem_copy(int nOffset, const void* pSrc, int nLength)
{
	if(pSrc == NULL) return FALSE;
	char* tmp = m_pBuffer;
	if(mem_alloc(nLength, FALSE))
	{
		mem_cpy(NULL, nOffset, pSrc, 0, nLength);
		mem_free(tmp);
		return TRUE;
	}
	return FALSE;
}
void EString::mem_cpy(void* pBuf, int nOffset, const void* pSrc, int nSrcOffset, int nLength)
{
	memcpy(((!pBuf) ? m_pBuffer : (char*)pBuf) + nOffset, (char*)pSrc + nSrcOffset, nLength);
}

//////////////////////////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////////////////////////
void EString::data_copy(char* pSrc)
{
	memcpy(&GetData()->sde, &GetData(pSrc)->sde, sizeof(ESTRINGDATAEX));
//	GetData()->nData = GetData(pSrc)->nData;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
/*
wchar_t* EString::get_bufferW(char* src)
{
	int len;
	mem_tmp(FALSE);
	if(!src)
		len = GetData()->nStringLength;
	else
		len = str_len(src);
	len++;
		m_pTempW = new wchar_t[len];
		int count = ::MultiByteToWideChar(CP_ACP, 0, (!src) ? m_pBuffer : src, -1, m_pTempW, 2 * len);
		m_pTempW[count - 1] = 0;
		return m_pTempW;
}
*/
/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
void* EString::get_buffer_offset(int offset)
{
	return (void*)(m_pBuffer + offset);
}