// EStringFormat.cpp : source file
//

///////////////////////////
//////// ECXSTATIC ////////
///////////////////////////

#include "..\..\__EcxStatic.h"


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
EStringFormat::EStringFormat()
{
	Empty();
	SetLanguage(LANG_RUSSIAN, SUBLANG_DEFAULT);
}


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::ByteSize(DWORD dwLowSize, DWORD dwHighSize, BOOL isRus)
{
	int nIndex;
	char szFormat[8];
	static char szPrefix[][4] = { "Tb","Gb","Mb","Kb","","","","" };
	__int64 lnBase, lnSize = (__int64)4294967296 * (__int64)dwHighSize + (__int64)dwLowSize;

	if(lnSize < KILO_BYTE)
	{
		Format((isRus) ? "%d " : "%d bytes", dwLowSize);
		return *this;
	}

	if(lnSize >= TERA_BYTE)
	{
		nIndex = 0; 
		lnBase = TERA_BYTE;
		goto end;
	}

	if(lnSize >= GIGA_BYTE)
	{
		nIndex = 1;
		lnBase = GIGA_BYTE;
		goto end;
	}

	if(lnSize >= MEGA_BYTE)
	{
		nIndex = 2;
		lnBase = MEGA_BYTE;
		goto end;
	}

	if(lnSize >= KILO_BYTE)
	{
		nIndex = 3;
		lnBase = KILO_BYTE;
	}

end:
	wsprintf(szFormat, "%%.2f %s", szPrefix[4 * isRus + nIndex]);
	Format(szFormat, (double)lnSize / (double)lnBase);
	return *this;
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::GetLanguageName(BOOL isLocale, BOOL isUpper)
{
	LCTYPE lct = (isLocale) ? LOCALE_SLANGUAGE : LOCALE_SENGLANGUAGE;
	return __call(1, (void*)&lct, (void*)&isUpper, NULL);
}


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::GetDayName(int nDay, BOOL isFull, BOOL isUpper)
{
	return __call(1, (void*)&g_lctDay[nDay % 7][isFull], (void*)&isUpper, NULL);
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::GetMonthName(int nMonth, BOOL isFull, BOOL isUpper)
{
	return __call(1, (void*)&g_lctMonth[nMonth % 12][isFull], (void*)&isUpper, NULL);
}


/////////////////////////////////////////////////////////////////////////////
//       
/////////////////////////////////////////////////////////////////////////////
//
//			d		      ;
//			dd		      ;
//			ddd		  ;
//			dddd	  ;
//			M		     ;
//			MM		     ;
//			MMM		  ;
//			MMMM	  ;
//			y		       ;
//			yy		       ;
//			yyyy	  
//			gg		/
//
//		     . 
//
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::Date(LPCSTR lpszDateFormat, SYSTEMTIME* pst)
{
	return __call(2, (void*)lpszDateFormat, (void*)pst, NULL);
}


/////////////////////////////////////////////////////////////////////////////
//       
/////////////////////////////////////////////////////////////////////////////
//
//			h	    ;
//			hh	    ;
//			m	    ;
//			mm	    ;
//			s	    ;
//			ss	    ;
//
//		     .
//
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::Time(LPCSTR lpszTimeFormat, SYSTEMTIME* pst)
{
	return __call(3, (void*)lpszTimeFormat, (void*)pst, NULL);
}


/*
//
BOOL EString::ErrorMessage(int id)
{
	return call(1, (void*)&id);
}
*/

/*    .

int EString::call(int function, void* lpv1, void* lpv2, void* lpv3)
{
		case 1: nLen = ::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, *(DWORD*)lpv1, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), dest, MAX_PATH, NULL); break;

		case 5: nLen = str_len(season[*(int*)lpv1][lang]); mem_copy(season[*(int*)lpv1][lang]); break;
*/



/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::__call(int function, void* lpv1, void* lpv2, void* lpv3)
{
	int nLen;
	ToBuffer(256);

	switch(function)
	{
		// GetMonthName, GetDayName, GetLanguageName
		case 1:
			nLen = ::GetLocaleInfo(GetLanguage(), *(LCTYPE*)lpv1, m_pBuffer, 256) - 1;
			FormatChar(*(BOOL*)lpv2);
			break;

		// Date
		case 2:
			nLen = ::GetDateFormat(GetLanguage(), DATE_USE_ALT_CALENDAR, (SYSTEMTIME*)lpv2, (LPCSTR)lpv1, m_pBuffer, 256) - 1;
			break;

		// Time
		case 3:
			nLen = ::GetTimeFormat(GetLanguage(), TIME_FORCE24HOURFORMAT, (SYSTEMTIME*)lpv2, (LPCSTR)lpv1, m_pBuffer, 256) - 1;
			break;

	}

	if(nLen == -1)
	{
		Empty();
		return *this;
	}

	str_release(nLen);
	return *this;
}


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
static char* szNL[] = { "", "", "zero" };

static char* szES[][3] =
{
	"",       "",        "",
	"",   "",    "one",
	"",    "",     "two",
	"",    "",     "three",
	"", "",  "four",
	"",   "'",   "five",
	"",  "",   "six",
	"",   "",     "seven",
	"", "",   "eight",
	"", "'", "nine",
	"",   "",    "",
	"",    "",     ""
};

static char* szMS[][3] =
{
	"",       "",        "ten",
	"",  "",    "eleven",
	"",   "",    "twelve",
	"",   "",    "thirteen",
	"", "",  "fourteen",
	"",   "'",   "fifteen",
	"",  "",   "sixteen",
	"",   "",    "seventeen",
	"", "",  "eighteen",
	"", "'", "nineteen"
};

static char* szDS[][3] =
{
	"",            "",           "",
	"",      "",     "ten",
	"",    "",   "twenty",
	"",    "",   "thirty",
	"",       "",      "forty",
	"",   "'",  "fifty",
	"",  "",  "sixty",
	"",   "",   "seventy",
	"", "", "eighty",
	"",   "'", "ninety"
};

static char* szHS[][2] =
{
	"",          "",
	"",       "",
	"",    "",
	"",    "",
	"", "",
	"",   "'",
	"",  "",
	"",   "",
	"", "",
	"", "'"
};

static char* szBS[][3] =
{
	"",            "",            "",
	"",       "",       "thousand",
	"",     "",     "million",
	"",    "",     "milliard",
	"",    "",    "trillion",
	"", "", "quadrillion",
	"", "", "quintillion"
};

static char* szPRBS[] =
{
	"",   "", "", "", "", "",   "",   "",   "",   "",
	"", "",  "", "", "", "", "", "", "", "",
	"",   "", "i", "i", "i", "",   "",   "",   "",   "",
	"i", "",  "", "", "", "i", "i", "i", "i", "i"
};


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::Number(DWORD dwLow, DWORD dwHigh, int nLang, BOOL isBinary)
{
	//    
	if(dwLow == 0 && dwHigh == 0)
	{
		Format("%s", szNL[nLang]);
		return *this;
	}

	EString strTmp;
	int n1, n2, pr, m, nTriade = 0;
	char szBS1[32];
	__int64 k = (isBinary) ? (__int64)4294967296 : (__int64)1000000000;
	__int64 lnBase = 1, lnNumber = k * (__int64)dwHigh + (__int64)dwLow;


	//  
	while(lnNumber / lnBase > 999)
	{
		lnBase *= 1000;
		nTriade++;
	}

	//   
	while(nTriade >= 0)
	{
		m = (int)(lnNumber / lnBase);
		lnNumber = lnNumber % lnBase;
		n2 = (m % 100) / 10;
		n1 = (n2 == 1) ? 0 : m % 10;
		pr = 10 * (2 * nLang + (nTriade != 1));

		wsprintf(szBS1, " %s%s ", szBS[nTriade][nLang], (nLang == 2) ? "" : szPRBS[n1 + pr]);
		strTmp += _number(m, nTriade == 1, nLang) + ((nTriade && m != 0) ? szBS1 : "");
		
		lnBase /= 1000;
		nTriade--;
	}
	strTmp.Trim();

	//  
	*(EString*)this = strTmp;
	return *this;
}


/////////////////////////////////////////////////////////////////////////////
//     0 - 999
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::_number(DWORD dwLow, int nMode, int nLang)
{
	EString strTmp;

	// ,   
	int n3 = dwLow / 100;
	int n2 = (dwLow % 100) / 10;
	int n1 = dwLow % 10;

	//  
	if(nLang == 2)
	{
		strTmp.Format("%s %s %s-%s", szES[n3][2], (n3 == 0) ? "" : "hundrend and", (n2 == 1) ? szMS[n1][2] : szDS[n2][2], (n2 == 1) ? "" : szES[n1][2]);
		strTmp.Replace(" -", " ");
		strTmp.Trim();
		strTmp.Trim("-");
		if(strTmp.Right(3) == "and") strTmp.str_release(strTmp.GetLength() - 3);
	}

	//    
	else
	{
		char szES1[16];
		strcpy(szES1, szES[(nMode && (n1 == 1 || n1 == 2)) ? n1 + 9 : n1][nLang]);
		strTmp.Format("%s %s %s", szHS[n3][nLang], (n2 == 1) ? szMS[n1][nLang] : szDS[n2][nLang], (n2 == 1) ? "" : szES1);
		strTmp.Replace("  ", " ");
	}
	
	strTmp.Trim();
	return strTmp;
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::TrNum(DWORD dwLow, DWORD dwHigh, LPCSTR lpszFiller, BOOL isBinary)
{
	__int64 k = (isBinary) ? (__int64)4294967296 : (__int64)1000000000;
	__int64 lnNumber = k * (__int64)dwHigh + (__int64)dwLow;

	EString strTmp;
	strTmp.Format("%I64d", lnNumber);

	EString* pstr = (EString*)this;

	int nLen = strTmp.GetLength();
	int nFirst = nLen % 3;
	int nFlen = str_len((void*)lpszFiller);
	
	*pstr = strTmp.Left(nFirst);
	if(nFlen) *pstr += lpszFiller;

	for(int i=0; i<nLen/3; i++)
	{
		*pstr += strTmp.Mid(nFirst + 3 * i, 3);
		if(nFlen) *pstr += lpszFiller;
	}

	//  
	if(nFlen) pstr->Trim(lpszFiller);
	return *this;
}


/////////////////////////////////////////////////////////////////////////////
//    RomanNumber
/////////////////////////////////////////////////////////////////////////////
static char* szRim[] = { "M","CM","D","CD","C","XC","L","XL","X","IX","V","IV","I" };
static int nDec[] = { 1000, 900, 500, 400, 100, 90, 50, 40, 10, 9, 5, 4, 1 };


/////////////////////////////////////////////////////////////////////////////
//      
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::RomanNumber(int nNumber)
{
	if(!__in00(nNumber, 0, 5332)) return "";

	int nPrev = -1, nCurr = 0, nCount = 0, nBegin = 0, nPos = 0;
	EString* pstr = (EString*)this;
	pstr->ToBuffer(32);

	//  
	while(nNumber > 0)
	{
		//  
		while(nDec[nCurr] > nNumber) nCurr++;
	
		//      
		if(nPrev != nCurr)
		{
			nCount = 0;
		}

		//     
		else
		{
			//    ,      
			if(nCurr % 4 == 0 && nCount != 2)
			{
				//  
				nCount++;
			}
			else
			{
				//  
				nCurr = ++nBegin;
				continue;
			}
		}

		//     
		m_pBuffer[nPos++] = szRim[nCurr][0];
		if(nCurr & 1) m_pBuffer[nPos++] = szRim[nCurr][1];

		//     ;  
		nNumber -= nDec[nCurr];
		nPrev = nCurr;

		//  
		nCurr = nBegin;
	}

	//  
	pstr->str_release(nPos);
	return *this;
}

/*
	static char* szRim[] = { "M","CM","D","CD","C","XC","L","XL","X","IX","V","IV","I" };
	static int nDec[] = { 1000, 900, 500, 400, 100, 90, 50, 40, 10, 9, 5, 4, 1 };

	int n = 999;

	EString s1;

	int j = 0;
	int c, d;

m1:
	c = (j % 4 == 0) ? 3 : 1;

m2:
	d = nDec[j] * c;

	if(n < d)
	{
		c--;
		if(c < 1)
		{
			j++;
			goto m1;
		}
		else
			goto m2;
	}
	else
	{
		n -= d;
		while(c)
		{
			s1 += szRim[j];
			c--;
		}
		j++;
		if(n > 0) goto m1;
	}
*/


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::HexSequence(BYTE* pBuf, int nCount, BOOL isChars, LPCSTR szAdder)
{
	EString* pstr = (EString*)this;
	pstr->Empty();

	BOOL isHexPrev = FALSE, isHexCurr = FALSE;
	EString s1;
	for(int i=0; i<nCount; i++)
	{
		BYTE ch = *(pBuf + i);
		isHexCurr = (ch < 0x20);
		if(isChars)
		{
			if(isHexCurr)
				s1.Format("%.2X", ch);
			else
				if(szAdder && (isHexPrev == TRUE || i == 0) && isHexCurr == FALSE)
					s1.Format("%s%c", szAdder, ch);
				else
					s1.Format("%c", ch);
			if((isHexPrev | isHexCurr) && i > 0)
				s1.Insert(INSERT_BEFOR, 0, ' ');
		}
		else
			s1.Format("%.2X", ch);
		*pstr += s1;
		isHexPrev = isHexCurr;
	}
	return *this;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
EString EStringFormat::PercentEncode(LPCSTR lpszSource)
{
	EString* pstr = (EString*)this;
	pstr->Empty();

	if(lpszSource == NULL) return *this;
	int nSourceLength = strlen(lpszSource);

	int nWideChars = ::MultiByteToWideChar(CP_ACP, 0, lpszSource, nSourceLength, NULL, 0);
	if(nWideChars == 0)
	{
		DWORD dwErrCode = ::GetLastError();
		return *this;
	}
	else
	{
		WCHAR* lpWideCharStr = new WCHAR[nWideChars];
		if(lpWideCharStr == NULL)
		{
			DWORD dwErrCode = ERROR_OUTOFMEMORY;
			return *this;
		}
		else
		{
			nWideChars = ::MultiByteToWideChar(CP_ACP, 0, lpszSource, nSourceLength, lpWideCharStr, nWideChars);
			int cbMultiByte = ::WideCharToMultiByte(CP_UTF8, 0, lpWideCharStr, nWideChars, NULL, 0, NULL, NULL);
			if(cbMultiByte == 0)
			{
				DWORD dwErrCode = ::GetLastError();
				return *this;
			}
			else
			{
				char* lpMultiByteStr = new char[cbMultiByte];
				if(lpMultiByteStr == NULL)
				{
					DWORD dwErrCode = ERROR_OUTOFMEMORY;
					return *this;
				}
				else
				{
					cbMultiByte = ::WideCharToMultiByte(CP_UTF8, 0, lpWideCharStr, nWideChars, lpMultiByteStr, cbMultiByte, NULL, NULL);
					for(int i=0; i<cbMultiByte; i++)
					{
						// http://en.wikipedia.org/wiki/UTF-8
						// UTF-8 encodes each character in one to four octets (8-bit bytes):
						//   1. One byte is needed to encode the 128 US-ASCII characters (Unicode range U+0000 to U+007F).
						//   2. Two bytes are needed for Latin letters with diacritics and for characters from Greek, Cyrillic, Armenian, Arabic, Syriac and Thaana alphabets (Unicode range U+0080 to U+07FF).
						//   3. Three bytes are needed for the rest of the Basic Multilingual Plane (which contains virtually all characters in common use).
						//   4. Four bytes are needed for characters in the other planes of Unicode, which are rarely used in practice.
						// http://ru.wikipedia.org/wiki/UTF-8
						//              Unicode        : UTF-8
						//   1. 0x00000000  0x0000007F: 0xxxxxxx
						//   2. 0x00000080  0x000007FF: 110xxxxx 10xxxxxx
						//   3. 0x00000800  0x0000FFFF: 1110xxxx 10xxxxxx 10xxxxxx
						//   4. 0x00010000  0x001FFFFF: 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
						char byte1 = lpMultiByteStr[i];
						if(byte1 & 0x80)
						{
							EString ch;
							ch.Format("%%%02X", (BYTE)byte1);
							*pstr += ch;
						}
						else
						{
							*pstr += byte1;
						}
					}
					delete [] lpMultiByteStr;
				}
			}
			delete [] lpWideCharStr;
		}
	}
	return *this;
}