// BufferManipulationFunc.h : header file
//

#ifndef __BUFFERMANIPULATIONFUNC_H__
#define __BUFFERMANIPULATIONFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  BufferManipulationFunc.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_BUFFERMANIPULATIONFUNC   "14.12.2012"



////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////
template <class TYPE>
inline void _EcxSwap(TYPE* ptVar1, TYPE* ptVar2)
{
	TYPE tmp = *ptVar1;
	*ptVar1 = *ptVar2;
	*ptVar2 = tmp;
}


////////////////////////////////////////////////////////////////////////////
//       
////////////////////////////////////////////////////////////////////////////
inline BOOL _EcxMemSwap(BYTE* pBuf, int nLength, int p1, int s1, int p2, int s2)
{
	if(s1 == 0 && s2 == 0) return FALSE;	//    

	//   
	if(min(p1, p2) == p2)
	{
		_EcxSwap(&p1, &p2);
		_EcxSwap(&s1, &s2);
	}

	if(p1 > nLength || p1 + s1 > nLength) return FALSE;	// 1-   
	if(p2 < p1 + s1) return FALSE;						//  
	if(p2 > nLength || p2 + s2 > nLength) return FALSE;	// 2-   

	BYTE* tmp = NULL;
	int s3 = p2 - p1 - s1;

	if(s1 + s3 > 0)
	{
		tmp = new BYTE[s1 + s3];
		memcpy(tmp, pBuf + p1, s1 + s3);
	}
	if(s2 > 0) memcpy(pBuf + p1, pBuf + p2, s2);
	if(s3 > 0) memcpy(pBuf + p1 + s2, tmp + s1, s3);
	if(s1 > 0) memcpy(pBuf + p1 + s2 + s3, tmp, s1);

	if(tmp) delete [] tmp;
	return TRUE;

}


////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////
inline int _EcxMemCompare(void* pBuf1, void* pBuf2, int nCount, BOOL isCase)
{
	return ((isCase) ? _memicmp(pBuf1, pBuf2, nCount) : memcmp(pBuf1, pBuf2, nCount));
}


////////////////////////////////////////////////////////////////////////////
//   .
//     ppDest   
//         pSrc.
////////////////////////////////////////////////////////////////////////////
inline int _EcxMemDup(BYTE** ppDest, BYTE* pSrc, int nLength)
{
	//     
	if(pSrc == NULL || ppDest == NULL) return 0;

	//     
	*ppDest = new BYTE[nLength];
	memcpy(*ppDest, pSrc, nLength);
	return nLength;
}


////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
template <class TYPE>
inline TYPE** _EcxAllocArray2D(int n, int m, TYPE)
{
	TYPE** arr = new TYPE*[n];
	for(int i=0; i<n; i++) arr[i] = new TYPE[m];
	return arr;
}


////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
template <class TYPE>
inline void _EcxFreeArray2D(TYPE** arr, int n, int m)
{
	for(int i=0; i<n; i++) delete [] arr[i];
	delete [] arr;
}



////////////////////////////////////////////////////////////////////////////
#endif // __BUFFERMANIPULATIONFUNC_H__
