// EJsonPath.h : header file
//

#ifndef __EJSONPATH_H__
#define __EJSONPATH_H__
#pragma once
/////////////////////////////////////////////////////////////////////////////

#include "..\TextParsing\TextParsingMacro.h"

#ifdef USED_JSON
/////////////////////////////////////////////////////////////////////////////
//  EJsonPath.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_EJSONPATH   "20.11.2013"



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
class EJsonPath  // path
{
public:

	EJsonPath();
	~EJsonPath();

	BOOL Split(LPCSTR szPath);
	void Clear();
	EString Print();

	BOOL IsACD(LPSTR pEntry);
	int GetACD(LPSTR pEntry);

	char* m_szPath;			//  

	LPSTR* m_ppEntry;		//  
	int m_nCount;			//   

	EString m_str;
};


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline EJsonPath::EJsonPath()
{
	m_szPath = NULL;
	m_ppEntry = NULL;
	m_nCount = 0;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline EJsonPath::~EJsonPath()
{
	Clear();
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
inline BOOL EJsonPath::Split(LPCSTR szPath)
{
	//   
	Clear();
	if(szPath == NULL) return FALSE;

	// 
	int len = strlen(szPath);
	if(len == 0) return FALSE;
	m_szPath = new char[len + 1];
	memcpy(m_szPath, szPath, len);
	m_szPath[len] = '\0';
	char* tmp = m_szPath;

	//   
	if(tmp[len - 1] == '.') tmp[len - 1] = '\0';
	skip_spaces(tmp);

	int n, i, j, count = 1;
	BOOL isArrBeg = FALSE;
	if(*tmp == '[')
	{
		isArrBeg = TRUE;
		count--;
	}


	//     
	while(*tmp) 
	{
		if(*tmp == '.') count++;
		if(*tmp == '[') count++;
		tmp++;
	}

	//   
	m_nCount = count;
	m_ppEntry = new LPSTR[m_nCount];

	char *p0, *p1, *e0, *e1;
	p1 = p0 = m_szPath;
	i = 0;

	//    
	while(1)
	{
		skip_spaces(p0);

		if(isArrBeg)
		{
			j = 0; i = -1;
			e0 = e1 = p0;
			
			goto LAB_ARR;
		}

		skip_to_char(p1, '.');
		len = p1 - p0;

		//   
		m_ppEntry[i] = new char[len + 1];
		memcpy(m_ppEntry[i], p0, len);
		m_ppEntry[i][len] = '\0';

		//     
		e0 = e1 = m_ppEntry[i];
		j = i;

LAB_ARR:
		//    
		while(*e1 != '[' && !is_char(*e1, CCM_SPACE) && !is_char(*e1, CCM_EOT)) e1++;
		len = e1 - e0;

		//    
		while(*e1 != '.' && !is_char(*e1, CCM_SPACE) && !is_char(*e1, CCM_EOT))
		{
			skip_spaces(e1);

			if(*e1 == ']')
			{
				e1++;
				continue;
			}

			if(*e1 == '[')
			{
				e1++;
				n = __strtoul(e1);
				i++;
				m_ppEntry[i] = (char*)((n + 1) | 0xACD00000);
			}
		}

		if(isArrBeg)
		{
			p1 = e1;
			isArrBeg = FALSE;
		}
		else
			m_ppEntry[j][len] = '\0';


		if(*p1 == '\0') break;

		i++;
		p0 = ++p1;
	}


	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
inline void EJsonPath::Clear()
{
	char* tmp;

	//  
	if(m_szPath != NULL)
	{
		delete [] m_szPath;
		m_szPath = NULL;
	}

	//   
	if(m_ppEntry != NULL)
	{
		for(int i=0; i<m_nCount; i++)
		{
			tmp = m_ppEntry[i];
			if(tmp != NULL && !IsACD(tmp)) delete [] tmp;
		}

		delete [] m_ppEntry;
		m_ppEntry = NULL;
		m_nCount = 0;
	}
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline EString EJsonPath::Print()
{
	int i;
	m_str.Format("m_szPath = \"%s\"\r\n\r\n", m_szPath);
	EString s1, s2;

	for(i = 0; i < m_nCount; i++)
	{
		if(IsACD(m_ppEntry[i]))
		{
			s2.Format("[%d]", ((int)m_ppEntry[i] & 0x000FFFFF) - 1);
		}
		else
		{
			s2 = m_ppEntry[i];
		}
		s1.Format("m_ppEntry[%d] = %s\r\n", i,  s2);
		m_str += s1;
	}
	return m_str;
}


/////////////////////////////////////////////////////////////////////////////
//         
// ACD - Array Counter Data
/////////////////////////////////////////////////////////////////////////////
inline BOOL EJsonPath::IsACD(LPSTR pEntry)
{
	return ((int)pEntry & 0xACD00000) == 0xACD00000;
}

/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline int EJsonPath::GetACD(LPSTR pEntry)
{
	return ((int)pEntry & 0x000FFFFF) - 1;
}

#endif //USED_JSON
/////////////////////////////////////////////////////////////////////////////
#endif // __EJSONPATH_H__
