// ELineArray.h : header file
//

#ifndef __ELINEARRAY_H__
#define __ELINEARRAY_H__
#pragma once



/////////////////////////////////////////////////////////////////////////////
//  ELineArray.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_ELINEARRAY   "05.03.2013"




////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
typedef struct _LineItem  // li
{
	char* pLine;
	int nLength;

} LINEITEM;


////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
class ELineArray : public EArray<LINEITEM>  // la
{
public:

	///////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////
	ELineArray()
		{ m_nLine = m_nColumn = 0; m_szBase = NULL; }

	///////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////
	void SetBase(char* szBase)
		{ m_szBase = szBase; }

	///////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////
	void AddLines(char* szText)
	{
		char *p0, *tmp = szText;
		if(tmp == NULL) return;

		m_szBase = szText;

		int n;
		LINEITEM li;
		p0 = tmp;

		//   
		while(1)
		{
			//   EOL  EOT
			if((n = is_eol_eot(tmp)))
			{
				tmp += n;
				li.pLine = p0;
				li.nLength = tmp - p0;
				Add(li);
				
				p0 = tmp;
				if(is_eot(tmp - n)) break;
				continue;
			}
			tmp++;
		}
	}

	///////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////
	BOOL FindPosition(int n)
	{
		if(m_szBase == NULL) return FALSE;
		m_nLine = m_nColumn = 0;
		LINEITEM li;
		int addr0, addr1;

		for(int i=0; i < GetCount(); i++)
		{
			li = GetItem(i);
			addr0 = li.pLine - m_szBase;
			addr1 = addr0 + li.nLength;

			if(__in10(n, addr0, addr1))
			{
				m_nLine = i + 1;
				m_nColumn = n - addr0 + 1;
				return TRUE;
			}
		}
		return FALSE;
	}

	///////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////
	EString GetPosition(int n)
	{
		EString str;
		if(FindPosition(n))
			str.Format("Ln %d, Col %d", m_nLine, m_nColumn);
		return str;
	}


	///////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////
	char* m_szBase;
	int m_nLine, m_nColumn;
};


/////////////////////////////////////////////////////////////////////////////
#endif // __ELINEARRAY_H__

