// EList.h : header file
//

#ifndef __ELIST_H__
#define __ELIST_H__
#pragma once
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  EList.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_ELIST   "31.05.2013"



/////////////////////////////////////////////////////////////////////////////
#undef POSITION1
#define POSITION1 DWORD*



/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
enum _ListTypeClass
{
	LST_SYMPLE,		//   
	LST_STRING,		// 
	LST_ARRAY		// 
};


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
typedef struct _ListItem
{
	DWORD dwSize;		//  
	BYTE* lpData;		// 

	_ListItem* pNext;
	_ListItem* pPrev;

	//  
	void Clear()
	{
		if(lpData != NULL)
		{
			delete [] lpData;
			lpData = NULL;
		}
	}

	// 
	_ListItem()
	{
		memset(this, 0, sizeof(_ListItem));
	}

	////////////////////////////////////////////////////////////////////////
	// 
	////////////////////////////////////////////////////////////////////////
	~_ListItem()
	{
		Clear();
	}

} LISTITEM;





/////////////////////////////////////////////////////////////////////////////
//   EList
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass = LST_SYMPLE>
class EList
{
public:

	EList();
	~EList();

	DWORD GetCount() { return m_nCount; };

	TYPE* AddHead(TYPE tData, DWORD dwSize = 0);
	TYPE* AddTail(TYPE tData, DWORD dwSize = 0);

//	void InsertBefore(DWORD pos, TYPE tData);
//	void InsertAfter(DWORD pos, TYPE tData);

//	BOOL RemoveHead(TYPE* tData);
//	BOOL RemoveTail(TYPE* tData);

//	BOOL remove_from(DWORD pos, TYPE* tData);
	void DeleteHead();
	void DeleteTail();
	BOOL DeleteFromTail(int nOffset, int nCount);
	void delete_from(LISTITEM* pos);

	void Clear();

	LISTITEM* GetHead();
	LISTITEM* GetTail();

	TYPE* GetHeadData();
	TYPE* GetTailData();

	LISTITEM* InitNext();
	BOOL Next(LISTITEM** pos, TYPE** pptData = NULL, LISTITEM** ppCurr = NULL);
//	BOOL get_prev(POSITION pos, TYPE* tData);
//	BOOL get(DWORD pos, TYPE *tData);

//	BOOL get_next_pos(POSITION pos);
//	BOOL get_prev_pos(POSITION pos);


private:

	TYPE* _set_data(LISTITEM** ppItem, TYPE tData, DWORD dwSize);

	
	LISTITEM *m_pHead, *m_pTail;
	int m_nCount;
};





/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
EList<TYPE, nTypeClass>::EList()
{
	//   
	m_pHead = m_pTail = NULL;
	m_nCount = 0;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
EList<TYPE, nTypeClass>::~EList()
{
	Clear();
}


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
TYPE* EList<TYPE, nTypeClass>::_set_data(LISTITEM** ppItem, TYPE tData, DWORD dwSize)
{
	void* tmp;

	//   
	switch(nTypeClass)
	{
		//   
		case LST_SYMPLE:
			dwSize = sizeof(TYPE);
			tmp = (void*)&tData;
			break;

		// 
		case LST_STRING:
			dwSize = strlen(*(char**)&tData) + 1;

		// 
		case LST_ARRAY:
			tmp = *(void**)&tData;
			break;
	}

	//  
	(*ppItem)->lpData = new BYTE[dwSize];
	memcpy((*ppItem)->lpData, tmp, dwSize);

	//  
	(*ppItem)->dwSize = dwSize;

	//    
	return (TYPE*)(*ppItem)->lpData;
}


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
TYPE* EList<TYPE, nTypeClass>::AddHead(TYPE tData, DWORD dwSize)
{
	//    head
	LISTITEM* pItem = new LISTITEM;

	//  
	TYPE* tmp = _set_data(&pItem, tData, dwSize);

	//    
	pItem->pNext = m_pHead;
	pItem->pPrev = NULL;

	//  head 
	if(m_pHead) m_pHead->pPrev = pItem;
	
	//  head
	m_pHead = pItem;

	//  tail   (   )
	if(!m_pTail) m_pTail = pItem;

	//   
	m_nCount++;

	//    
	return tmp;
}


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
TYPE* EList<TYPE, nTypeClass>::AddTail(TYPE tData, DWORD dwSize)
{
	//    tail
	LISTITEM* pItem = new LISTITEM;

	//  
	TYPE* tmp = _set_data(&pItem, tData, dwSize);

	//    
	pItem->pNext = NULL;
	pItem->pPrev = m_pTail;

	//  tail 
	if(m_pTail) m_pTail->pNext = pItem;

	//  tail
	m_pTail = pItem;

	//  head   (   )
	if(!m_pHead) m_pHead = pItem;

	//   
	m_nCount++;

	//    
	return tmp;
}

/*
/////////////////////////////////////////////////////////////////////////////
//      
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
void EList<TYPE, nTypeClass>::InsertBefore(DWORD pos, TYPE tData)
{
	LISTITEM* pItemTmp = (LISTITEM*)pos;
	LISTITEM* pItem = NULL;

	if(pos != 0)
	{
		if(!pItemTmp->pPrev)
		{
			AddHead(tData);
			return;
		}

		pItem = new LISTITEM;

		pItem->tData	= tData;
		pItem->pNext	= pItemTmp;
		pItem->pPrev = pItemTmp->pPrev;

		pItemTmp->pPrev->pNext = pItem;
		pItemTmp->pPrev = pItem;

		m_nCount++;
	}
	else
		AddTail(tData);
}
*/
/*
/////////////////////////////////////////////////////////////////////////////
//      
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
void EList<TYPE, nTypeClass>::InsertAfter(DWORD pos, TYPE tData)
{
	LISTITEM* pItemTmp = (LISTITEM*)pos;
	LISTITEM* pItem = NULL;

	if(pos != 0)
	{
		if(!pItemTmp->pNext)
		{
			AddTail(tData);
			return;
		}

		pItem = new LISTITEM;

		pItem->tData	= tData;
		pItem->pNext	= pItemTmp->pNext;
		pItem->pPrev = pItemTmp;

		pItemTmp->pNext->pPrev = pItem;
		pItemTmp->pNext = pItem;

		m_nCount++;
	}
}
*/
/*
/////////////////////////////////////////////////////////////////////////////
//      (list head)
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::RemoveHead(TYPE* tData)
{
	// check if the EList is not empty
	if(m_pHead)
	{
		*tData = m_pHead->tData;
		DeleteHead();

		return TRUE;
	}
	return FALSE;
}
*/
/*
/////////////////////////////////////////////////////////////////////////////
//      (list tail)
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::RemoveTail(TYPE* tData)
{
	LISTITEM* pItem;

	// check if the EList is not empty
	if(m_pTail)
	{
		*tData = m_pTail->tData;
		DeleteTail();

		return TRUE;
	}
	return FALSE;
}
*/
/*
/////////////////////////////////////////////////////////////////////////////
// remove an element from specified pos and return it's value
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::remove_from(DWORD pos, TYPE* tData)
{
	LISTITEM* pItemTmp = (LISTITEM*)pos;

	if(pos != 0)
	{
		if(!pItemTmp->pPrev) return RemoveHead(tData);
		if(!pItemTmp->pNext) return RemoveTail(tData);

		*tData = pItemTmp->tData;

		pItemTmp->pPrev->pNext = pItemTmp->pNext;
		pItemTmp->pNext->pPrev = pItemTmp->pPrev;
		delete pItemTmp;

		m_nCount--;
		return TRUE;
	}
	return FALSE;
}
*/

/////////////////////////////////////////////////////////////////////////////
//      (list head)
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
void EList<TYPE, nTypeClass>::DeleteHead()
{
	LISTITEM* pItem;

	// check if the EList is not empty
	if(m_pHead)
	{
		pItem = m_pHead->pNext;

		delete m_pHead;

		m_pHead = pItem;
		if(!m_pHead)
			m_pTail = NULL;
		else
			m_pHead->pPrev = NULL;

		m_nCount--;
	}
}


/////////////////////////////////////////////////////////////////////////////
//      (list tail)
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
void EList<TYPE, nTypeClass>::DeleteTail()
{
	LISTITEM* pItem;

	// check if the EList is not empty
	if(m_pTail)
	{
		pItem = m_pTail->pPrev;

		delete m_pTail;

		m_pTail = pItem;
		if(!m_pTail)
			m_pHead = NULL;
		else
			m_pTail->pNext = NULL;

		m_nCount--;
	}
}


/////////////////////////////////////////////////////////////////////////////
//  nCount       nOffset
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::DeleteFromTail(int nOffset, int nCount)
{
	if(nOffset + nCount > m_nCount) return FALSE;

	int i;
	LISTITEM *tmp, *pos = m_pTail;
	for(i=0; i<nOffset; i++)
	{
		pos = pos->pPrev;
	}
	for(i=0; i<nCount; i++)
	{
		tmp = pos->pPrev;
		delete_from(pos);
		pos = tmp;
	}

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// delete an element from specified pos
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
void EList<TYPE, nTypeClass>::delete_from(LISTITEM* pos)
{
	LISTITEM* tmp = pos;

	if(pos != 0)
	{
		if(!tmp->pPrev)
		{
			DeleteHead();
			return;
		}

		if(!tmp->pNext)
		{
			DeleteTail();
			return;
		}

		tmp->pPrev->pNext = tmp->pNext;
		tmp->pNext->pPrev = tmp->pPrev;
		delete tmp;

		m_nCount--;
	}
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
void EList<TYPE, nTypeClass>::Clear()
{
	//    
	while(m_pHead)
	{
		LISTITEM* tmp = m_pHead->pNext;

		//   ;     
		delete m_pHead;
		m_pHead = tmp;
	}

	//   
	m_pHead = m_pTail = NULL;
	m_nCount = 0;
}


/////////////////////////////////////////////////////////////////////////////
// get head's position
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
LISTITEM* EList<TYPE, nTypeClass>::GetHead()
{
	return m_pHead;
}


/////////////////////////////////////////////////////////////////////////////
// get tail's position
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
LISTITEM* EList<TYPE, nTypeClass>::GetTail()
{
	return m_pTail;
}

/////////////////////////////////////////////////////////////////////////////
// get head's position
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
TYPE* EList<TYPE, nTypeClass>::GetHeadData()
{
	return (TYPE*)m_pHead->lpData;
}


/////////////////////////////////////////////////////////////////////////////
// get tail's position
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
TYPE* EList<TYPE, nTypeClass>::GetTailData()
{
	return (TYPE*)m_pTail->lpData;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
LISTITEM* EList<TYPE, nTypeClass>::InitNext()
{
	return GetHead();
}

/////////////////////////////////////////////////////////////////////////////
// get element's tData (element is pointed by pos) and move to the pNext
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>:: Next(LISTITEM** pos, TYPE** pptData, LISTITEM** ppCurr)
{
	if(pos && *pos != NULL)
	{
		if(pptData) *pptData = (TYPE*)((*pos)->lpData);
		if(ppCurr) *ppCurr = *pos;
		*pos = (*pos)->pNext;
		return TRUE;
	}
	return FALSE;
}

/*
/////////////////////////////////////////////////////////////////////////////
// get element's tData (element is pointed by pos) and move to the pPrev
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::get_prev(POSITION pos, TYPE* tData)
{
	if(pos && (*pos != 0))
	{
		*tData = ((LISTITEM*)(*pos))->tData;
		*pos = (DWORD)((LISTITEM*)(*pos))->pPrev;
		return TRUE;
	}
	return FALSE;
}
*/
/*
/////////////////////////////////////////////////////////////////////////////
// get element's tData (element is pointed by pos) and move to the pPrev
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::get(DWORD pos, TYPE* tData)
{
	if(pos && (*pos != 0))
	{
		*tData = ((LISTITEM*)(*pos))->tData;
		return TRUE;
	}
	return FALSE;
}
*/
/*
/////////////////////////////////////////////////////////////////////////////
// get position of the previous element
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::get_next_pos(POSITION pos)
{
	if(pos && (*pos != 0))
	{
		*pos = (DWORD)((LISTITEM*)(*pos))->pNext;
		return TRUE;
	}
	return FALSE;
}
*/
/*
/////////////////////////////////////////////////////////////////////////////
// get position of the pNext element
/////////////////////////////////////////////////////////////////////////////
template <class TYPE, int nTypeClass>
BOOL EList<TYPE, nTypeClass>::get_prev_pos(POSITION pos)
{
	if(pos && (*pos != 0))
	{
		*pos = (DWORD)((LISTITEM*)(*pos))->pPrev;
		return TRUE;
	}
	return FALSE;
}
*/



/////////////////////////////////////////////////////////////////////////
#endif // __ELIST_H__