// ETree_FileSystem.h : header file
//

#ifndef __ETREE_FILESYSTEM_H__
#define __ETREE_FILESYSTEM_H__
#pragma once


#include "ETree.h"

#ifdef USED_TREE
/////////////////////////////////////////////////////////////////////////////
//  ETree_FileSystem.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_ETREE_FILESYSTEM   "06.01.2012"




/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
typedef struct _FileSystemEntry // fse
{
	WIN32_FIND_DATA wfd;

} FILESYSTEMENTRY;



/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
class ETree_FileSystem : public ETree  // tfs
{
// Construction
public:

	ETree_FileSystem();
//	~ETree_FileSystem();


	void AddTree(LPCSTR szPath, TREEENTRY* pTe, DWORD dwSortMode = TSM_NODE_LEAF|TSM_ASC_NAME|TSM_ASC_DATA);
	friend void CALLBACK DeleteDataProc(TREEENTRY* pTe);


};


////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
inline ETree_FileSystem::ETree_FileSystem()
{
}




////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////
inline void ETree_FileSystem::AddTree(LPCSTR szPath, TREEENTRY* pTe, DWORD dwSortMode)
{
	if(pTe == NULL) return;

	WIN32_FIND_DATA wfd;
	HANDLE hFile;
	TREEENTRY* pTe1;
	int pos, nType;

	//    -  ,
	//    
	EString strPath = szPath;
	EString path = strPath.Left(strPath.GetLength() - 3);
	_EcxStrDup(&pTe->szEntryData, path);

	//     
	if((hFile = ::FindFirstFile(szPath, &wfd)) != INVALID_HANDLE_VALUE)
	{
		//     
		do
		{
//			if(_is_no_flag(wfd.dwFileAttributes, FILE_ATTRIBUTE_HIDDEN)) continue;
//			if(_is_no_flag(wfd.dwFileAttributes, FILE_ATTRIBUTE_SYSTEM)) continue;

//			if(wfd.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) continue;
//			if(wfd.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM) continue;
//			if(_is_no_flag(wfd.dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY)) continue;
//			if(_is_flag(wfd.dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY)) continue;

			//     
			if(wfd.cFileName[0] == '.') continue;

			//      
			nType = (_is_flag(wfd.dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY)) ? TET_NODE : TET_LEAF;
			pTe1 = Add(pTe, nType, wfd.cFileName, NULL);


			//    ()
			if(nType == TET_NODE)
			{
				pTe1->pfnDelete = DeleteDataProc;

				FILESYSTEMENTRY* pFse = new FILESYSTEMENTRY;
				memcpy(&pFse->wfd, &wfd, sizeof(WIN32_FIND_DATA));
				pTe1->pData = (void*)pFse;

				EString str = path;
				str += wfd.cFileName;

				if(_EcxIsDirectoryNotEmpty(str, PRESENT_ANY))
//				if(_EcxIsDirectoryNotEmpty(str, PRESENT_FILE))
//				if(_EcxIsDirectoryNotEmpty(str, PRESENT_DIR))
				{
					Add(pTe1, TET_LEAF, NULL, NULL);
				}
			}

			//    ()
			else
			{
				EString name = wfd.cFileName;
				if((pos = name.FindRev('.')) != -1)
				{
					//      
					_EcxStrDup(&pTe1->szEntryData, name.Right(~name - pos - 1));
				}
			}
		}
		while(::FindNextFile(hFile, &wfd));
	}

	//     
	::FindClose(hFile);
	
	// 
	SortChild(pTe, dwSortMode, SortProc, (void**)this);
}


////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////
inline void CALLBACK DeleteDataProc(TREEENTRY* pTe)
{
	FILESYSTEMENTRY* pFse = (FILESYSTEMENTRY*)pTe->pData;
	if(pFse) delete pFse;
}






#endif //USED_TREE
/////////////////////////////////////////////////////////////////////////////
#endif // __ETREE_FILESYSTEM_H__
