// heap.h : header file
//

#ifndef __HEAP_H__
#define __HEAP_H__
#pragma once


/////////////////////////////////////////////////////////////////////////////
//  heap.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_HEAP   "08.12.2012"



/////////////////////////////////////////////////////////////////////////////
//        dwFlags 
// _EcxAlloc, _EcxCalloc  _EcxReAlloc   _ZERO_MEMORY
/////////////////////////////////////////////////////////////////////////////
#define _ZERO_MEMORY  HEAP_ZERO_MEMORY


/////////////////////////////////////////////////////////////////////////////
//    uSize  ""  
/////////////////////////////////////////////////////////////////////////////
inline void* __cdecl _EcxAlloc(UINT uSize, DWORD dwFlags = 0)
{
	return ::HeapAlloc(::GetProcessHeap(), dwFlags | HEAP_GENERATE_EXCEPTIONS, uSize);
}


/////////////////////////////////////////////////////////////////////////////
//    uNum      uSize
/////////////////////////////////////////////////////////////////////////////
inline void* __cdecl _EcxCalloc(UINT uNum, UINT uSize, DWORD dwFlags = 0)
{
	return _EcxAlloc(uNum * uSize, dwFlags);
}


/////////////////////////////////////////////////////////////////////////////
//   pMemBlock    uSize
/////////////////////////////////////////////////////////////////////////////
inline void* __cdecl _EcxReAlloc(void* pMemBlock, UINT uSize, DWORD dwFlags = 0)
{
	if(pMemBlock == NULL) return _EcxAlloc(uSize);
	return ::HeapReAlloc(::GetProcessHeap(), dwFlags | HEAP_GENERATE_EXCEPTIONS, pMemBlock, uSize);
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
inline void __cdecl _EcxFree(void* pMemBlock)
{
	if(pMemBlock != NULL) ::HeapFree(::GetProcessHeap(), 0, pMemBlock);
}


/////////////////////////////////////////////////////////////////////////////
//      
/////////////////////////////////////////////////////////////////////////////
#define __new_array(TYPE, count)	new TYPE[count]
#define __delete_array(ptr)			if(ptr != NULL) { delete ptr; ptr = NULL; }



/////////////////////////////////////////////////////////////////////////////
#endif // __HEAP_H__
