// COMFunc.h : header file
//

#ifndef __COMFUNC_H__
#define __COMFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


#include "objidl.h"


////////////////////////////////////////////////////////////////////////////
//  COMFunc.h
////////////////////////////////////////////////////////////////////////////
#define VERSION_COMFUNC   "08.10.2012"





////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////
inline BOOL _EcxAllocStream(DWORD dwBytes, IStream** ppStream)
{
	HGLOBAL hMem = ::GlobalAlloc(GHND, dwBytes);
	if(hMem == NULL) return FALSE;
	
	return (::CreateStreamOnHGlobal(hMem, FALSE, ppStream) == S_OK);
}


////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////
inline BOOL _EcxFileToStream(LPCTSTR szFile, IStream** ppStream)
{
	HGLOBAL hGlobal = NULL;
	BOOL res = FALSE;

	// open file
	HANDLE hFile = ::CreateFile(szFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if(INVALID_HANDLE_VALUE == hFile) return FALSE;

	// get file size
	DWORD dwBytesRead = 0, dwFileSize = ::GetFileSize(hFile, NULL);
	if(dwFileSize != -1)
	{
		hGlobal = ::GlobalAlloc(GMEM_MOVEABLE, dwFileSize);
		if(hGlobal != NULL)
		{
			PVOID pvData = ::GlobalLock(hGlobal);
			
			// read file and store in global memory
			::ReadFile(hFile, pvData, dwFileSize, &dwBytesRead, NULL);
			::GlobalUnlock(hGlobal);
			
			if(dwFileSize != dwBytesRead)
			{
				::GlobalFree(hGlobal);
			}
			else
				res = TRUE;
		}
	}

	::CloseHandle(hFile);

	
	if(res)
	{
		// create IStream* from global memory
		res = (::CreateStreamOnHGlobal(hGlobal, TRUE, ppStream) == S_OK);
	}

	return res;
}




////////////////////////////////////////////////////////////////////////////
#endif // __COMFUNC_H__
