/** \file CharacterClassificationFunc.h
	 .
*/

#ifndef __CHARACTERCLASSIFICATIONFUNC_H__
#define __CHARACTERCLASSIFICATIONFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


///  CharacterClassificationFunc.h
#define VERSION_CHARACTERCLASSIFICATIONFUNC   "23.11.2011"

///////////////////////////////////////////////////////////////////////
/** \defgroup hCharClassF # 
	 .
	\ingroup gCharClass
*/

/// \fn DWORD _EcxCharClassFromPOSIX(char** ppBuf, BOOL isIncBuffer = FALSE)
///	\ingroup hCharClassF
///   POSIX.
///     \c ppBuf     POSIX,
/// .&nbsp;.    <code>"[:posix:]"</code>,  \c posix   . \n
///  ,  \c isIncBuffer  \c TRUE,  \c ppBuf      POSIX.
/// \return   \c CCM_. 
/// \see gnPOSIX, _CharClassMasks
inline DWORD _EcxCharClassFromPOSIX(char** ppBuf, BOOL isIncBuffer = FALSE)
{
	int i, len;
	char* posix;
	DWORD dwCharClass;

	for(i=0; i<sizeof(gnPOSIX)/sizeof(gnPOSIX[0]); i++)
	{
		posix = gnPOSIX[i][1];
		len = strlen(posix);

		ifstrncmp(*ppBuf, posix, len)
		{
			dwCharClass = (DWORD)gnPOSIX[i][0];
			if(isIncBuffer) *ppBuf += len;
			return dwCharClass;
		}
	}
	return 0;
}



////////////////////////////////////////////////////////////////////////////
#endif // __CHARACTERCLASSIFICATIONFUNC_H__
