/** \file CharacterClassificationMacro.h
	 .
*/

#ifndef __CHARACTERCLASSIFICATIONMACRO_H__
#define __CHARACTERCLASSIFICATIONMACRO_H__
#pragma once
////////////////////////////////////////////////////////////////////////////

#include "CharacterClassification.h"


///  CharacterClassificationMacro.h
#define VERSION_CHARACTERCLASSIFICATIONMACRO   "26.02.2013"

///////////////////////////////////////////////////////////////////////
/** \defgroup hCharClassM # 
	 .
	\ingroup gCharClass
*/

/// \def is_char(ch, mask)
///	\ingroup hCharClassM
///     \c ch    \c mask.
#define is_char(ch, mask)	( (!!(_CharClassArray[(BYTE)(ch)] & (DWORD)(mask))) ^ ((mask) & CCM_INV) )


/// \def is_lower(ch, mask)
///	\ingroup hCharClassM
///     \c ch   .
/// \details  \c mask  : \c CCM_ALPHA, \c CCM_NCALP, \c CCM_CH_RUS  \c CCM_CH_UKR.

/// \def is_upper(ch, mask)
///	\ingroup hCharClassM
///     \c ch   .
/// \details  \c mask  : \c CCM_ALPHA, \c CCM_NCALP, \c CCM_CH_RUS  \c CCM_CH_UKR.

/// \def is_lower_upper(ch, mask, lower_upper)
///	\ingroup hCharClassM
///     \c ch     .
/// \details  \c lower_upper  : \c CCM_CH_LOWER  \c CCM_CH_UPPER, 
///  \c mask  \c CCM_ALPHA, \c CCM_NCALP, \c CCM_CH_RUS  \c CCM_CH_UKR.

#define is_lower(ch, mask)	( is_char(ch, CCM_CH_LOWER) && is_char(ch, mask) )
#define is_upper(ch, mask)	( is_char(ch, CCM_CH_UPPER) && is_char(ch, mask) )
#define is_lower_upper(ch, mask, lower_upper)	( is_char(ch, lower_upper) && is_char(ch, mask) )


/////////////////////////////////////////////////////////////////////////////
#endif // __CHARACTERCLASSIFICATIONMACRO_H__
