/** \file ERandomizeChar.h
	  ERandomizeChar.
*/

#ifndef __ERANDOMIZECHAR_H__
#define __ERANDOMIZECHAR_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


#include "..\BufferManipulation\EArray.h"
#include "EBitArray.h"
#include "CharacterClassificationMacro.h"


///  ERandomizeChar.h
#define VERSION_ERANDOMIZECHAR   "23.06.2011"

///////////////////////////////////////////////////////////////////////
/** \defgroup hERandChar ERandomizeChar
	  ERandomizeChar.
	\ingroup gCharClass
*/

///	\ingroup hERandChar
///    .
class ERandomizeChar  // rndc
{
public:

	///    /  .
	BYTE RandChar_Range(BYTE ch1, BYTE ch2, BOOL isFrom)
	{
		int ch;
		do
		{
			ch = __rand_range(0, 255);

		} while(__in11(ch, ch1, ch2) ^ isFrom);

		return ch;
	};

	///    /  .
	BYTE RandChar_CharClass(WORD wMask, BOOL isFrom)
	{
		int ch;
		do
		{
			ch = __rand_range(0, 255);

		} while(is_char(ch, wMask) ^ isFrom);

		return ch;
	};

	///    /  .
	BYTE RandChar_BitArray(EBitArray* pBa, BOOL isFrom)
	{
		int ch;
		do
		{
			ch = __rand_range(0, 255);

		} while(pBa->IsBit(ch) ^ isFrom);

		return ch;
	};


private:

};



////////////////////////////////////////////////////////////////////////////
#endif // __ERANDOMIZECHAR_H__
