// DateTimeManagement.h : header file
//

#ifndef __DATETIMEMANAGEMENT_H__
#define __DATETIMEMANAGEMENT_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


#include "..\..\api\EcxStatic\ECX\Include\__EString.h"



/////////////////////////////////////////////////////////////////////////////
//  DateTimeManagement.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_DATETIMEMANAGEMENT   "13.07.2012"



/////////////////////////////////////////////////////////////////////////////
//   1 
/////////////////////////////////////////////////////////////////////////////
#pragma  pack(push,1)


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
typedef struct tagDATE  // dt
{
	BYTE d;
	BYTE m;
	WORD y;

	/////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////
	tagDATE()							{ }
	tagDATE(tagDATE& dt)				{ d = dt.d; m = dt.m; y = dt.y; }
	tagDATE(BYTE nD, BYTE nM, WORD nY)	{ d = nD; m = nM; y = nY; }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	void Set(BYTE nD, BYTE nM, WORD nY)	{ d = nD; m = nM; y = nY; }


	/////////////////////////////////////////////////////////////
	//       
	/////////////////////////////////////////////////////////////
	BOOL IsDate()	{ return __in11(d, 1, 31) && __in11(m, 1, 12); }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	EString Format()	{ EString s1; s1.Format("%02d.%02d.%04d", d, m, y); return s1; }

	/////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////
	int Compare(tagDATE& dt)
	{
		int res;
		if((res = y - dt.y) == 0)
			if((res = m - dt.m) == 0)
				res = d - dt.d;
		return res;
	}

	/////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////
	void Scan(LPCSTR lpszFormat, LPCSTR lpszDate)
	{
		int nDay, nMonth, nYear;
		EString str = lpszDate;
		str.Scan(lpszFormat, &nDay, &nMonth, &nYear);
		Set(nDay, nMonth, nYear);
	}

} _DATE;




/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
typedef struct tagTIME  // tm
{
	BYTE h;
	BYTE m;

	/////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////
	tagTIME()					{ }
	tagTIME(tagTIME& tm)		{ h = tm.h; m = tm.m; }
	tagTIME(BYTE nH, BYTE nM)	{ h = nH; m = nM; }
	tagTIME(WORD w)				{ h = w / 60; m = w % 60; }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	void Set(BYTE nH, BYTE nM)	{ h = nH; m = nM; }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	operator WORD()		{ return (WORD)(h * 60 + m); }
	operator double()	{ return (double)(h * 60 + m) / 60.0; }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	tagTIME& operator=(tagTIME& tm)	{ h = tm.h; m = tm.m; return *this; }
	tagTIME& operator=(WORD w)		{ h = w / 60; m = w % 60; return *this; }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	tagTIME operator+(tagTIME& tm)	{ return tagTIME((h + tm.h) * 60 + m + tm.m); }
	tagTIME& operator+=(tagTIME& tm){ *this = tagTIME((h + tm.h) * 60 + m + tm.m); 	return *this; }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	tagTIME operator-(tagTIME& tm)	{ return tagTIME((*this > tm) ? (h - tm.h) * 60 + m - tm.m : 0); }
	tagTIME& operator-=(tagTIME& tm){ *this = tagTIME((*this > tm) ? (h - tm.h) * 60 + m - tm.m : 0); return *this; }

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	BOOL operator==(tagTIME& tm) { return ((h * 60 + m) == (tm.h * 60 + tm.m)); }
	BOOL operator!=(tagTIME& tm) { return ((h * 60 + m) != (tm.h * 60 + tm.m)); }
	BOOL operator<=(tagTIME& tm) { return ((h * 60 + m) <= (tm.h * 60 + tm.m)); }
	BOOL operator>=(tagTIME& tm) { return ((h * 60 + m) >= (tm.h * 60 + tm.m)); }
	BOOL operator<(tagTIME& tm)  { return ((h * 60 + m) < (tm.h * 60 + tm.m));  }
	BOOL operator>(tagTIME& tm)  { return ((h * 60 + m) > (tm.h * 60 + tm.m));  }

	/////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////
	int Compare(tagTIME& tm)
	{
		int res;
		if((res = h - tm.h) == 0)
			res = m - tm.m;
		return res;
	}

	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	EString Format()	{ EString s1; s1.Format("%02d:%02d", h, m); return s1; }

} _TIME;


/////////////////////////////////////////////////////////////////////////////
//   ( 4 )
/////////////////////////////////////////////////////////////////////////////
#pragma pack(pop)


////////////////////////////////////////////////////////////////////////////
#endif // __DATETIMEMANAGEMENT_H__

