// EDynaLink.h : header file  (06.11.2005)
//

#ifndef __EDYNALINK_H__
#define __EDYNALINK_H__
#pragma once
//////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  EDynaLink.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_EDYNALINK   "31.08.2012"



//////////////////////////////////////////////////////////////////////////////
//    EDynaLink
//////////////////////////////////////////////////////////////////////////////
template <class TYPE> class EDynaLink  
{
public:

	TYPE m_pFunction;
	HINSTANCE m_hLibrary;


	/////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////
	EDynaLink(LPCSTR pszLibraryName, LPCSTR pszFunctionName)
	{
		m_pFunction = NULL;
		m_hLibrary = NULL;
		Link(pszLibraryName, pszFunctionName);
	}


	/////////////////////////////////////////////////////////////
	// 
	/////////////////////////////////////////////////////////////
	virtual ~EDynaLink()
	{
		UnLink();
	}


	/////////////////////////////////////////////////////////////
	//      
	/////////////////////////////////////////////////////////////
	BOOL Link(LPCSTR pszLibraryName, LPCSTR pszFunctionName)
	{
		UnLink();
		m_hLibrary = ::LoadLibrary(pszLibraryName);
		if(m_hLibrary)
		{
			if(!(m_pFunction = (TYPE)::GetProcAddress(m_hLibrary, pszFunctionName)))
			{
				UnLink();
			}
		}
		return (BOOL)m_pFunction;
	}


	/////////////////////////////////////////////////////////////
	//  
	/////////////////////////////////////////////////////////////
	BOOL UnLink()
	{
		if(m_hLibrary)
		{
			BOOL res = ::FreeLibrary(m_hLibrary);
			m_pFunction = NULL;
			m_hLibrary = NULL;
			return res;
		}
		return FALSE;
	}


	/////////////////////////////////////////////////////////////
	//    
	/////////////////////////////////////////////////////////////
	BOOL IsValid()
	{ 
		return (BOOL)m_pFunction; 
	}


	/////////////////////////////////////////////////////////////
	//   
	/////////////////////////////////////////////////////////////
	TYPE operator()()
	{
		return m_pFunction; 
	}
};



//////////////////////////////////////////////////////////////////////////////
//    
//////////////////////////////////////////////////////////////////////////////
#define DECLARE(funcname, libname, funcalias, functype) \
	static EDynaLink<functype> funcalias(#libname, #funcname);



//////////////////////////////////////////////////////////////////////////////
#endif // __EDYNALINK_H__


