// FileInstallationLibraryFunc.h : header file
//

#ifndef __FILEINSTALLATIONLIBRARYFUNC_H__
#define __FILEINSTALLATIONLIBRARYFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////

#include "winver.h"
#pragma comment(lib, "version.lib")

////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  FileInstallationLibraryFunc.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_FILEINSTALLATIONLIBRARYFUNC   "17.01.2011"



////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
inline BOOL _EcxGetFixedFileInfo(LPCTSTR lpszModuleFileName, VS_FIXEDFILEINFO* pvsffi)
{
	DWORD dwHandle;
	DWORD dwInfoSize = ::GetFileVersionInfoSize((char*)lpszModuleFileName, &dwHandle);

	if(dwInfoSize > 0)
	{
		BYTE* lpBuff = new BYTE[dwInfoSize];
		
		if(::GetFileVersionInfo((char*)lpszModuleFileName, 0, dwInfoSize, lpBuff))
		{
			VS_FIXEDFILEINFO* tmp;
			UINT uInfoSize;

			if(::VerQueryValue(lpBuff, "\\", (LPVOID*)&tmp, &uInfoSize))
			{
				if(uInfoSize > 0)
				{
					*pvsffi = *tmp;
					return TRUE;
				}
			}
		}
	
		delete lpBuff;
	}

	return FALSE;
}


////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
inline char* _EcxGetVersionString(LPCTSTR lpszModuleFileName, char* lpszVersionString)
{
	if(lpszVersionString != NULL)
	{
		lpszVersionString[0] = '\0';

		VS_FIXEDFILEINFO vsffi;
		if(_EcxGetFixedFileInfo((char*)lpszModuleFileName, &vsffi))
		{
			WORD n1, n2, n3, n4;
			n1 = (WORD)(vsffi.dwFileVersionMS >> 16);
			n2 = (WORD)(vsffi.dwFileVersionMS & 0x0000FFFF);
			n3 = (WORD)(vsffi.dwFileVersionLS >> 16);
			n4 = (WORD)(vsffi.dwFileVersionLS & 0x0000FFFF);
			sprintf(lpszVersionString, "%d.%d.%d.%d", n1, n2, n3, n4); 
		}
	}

	return NULL;
}





////////////////////////////////////////////////////////////////////////////
#endif // __FILEINSTALLATIONLIBRARYFUNC_H__
