// FloatingPointSupportFunc.h : header file
//

#ifndef __FLOATINGPOINTSUPPORTFUNC_H__
#define __FLOATINGPOINTSUPPORTFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////

#include "FloatingPointSupport.h"


/////////////////////////////////////////////////////////////////////////////
//  FloatingPointSupportFunc.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_FLOATINGPOINTSUPPORTFUNC   "13.03.2011"



////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////
inline LPSTR _EcxStrFlags(LPSTR lpszFlags, DWORD dwFlags, ONEFLAGINFO* pFinf, int nFlagsCount)
{
	lpszFlags[0] = '\0';

	for(int i=0; i<nFlagsCount; i++)
	{
		if(_is_flag(dwFlags, pFinf[i].dwFlag))
		{
			lstrcat(lpszFlags, pFinf[i].szFlagName);
			lstrcat(lpszFlags, ", ");
		}
	}

	if(lpszFlags[0] != '\0')
	{
		int nPos = lstrlen(lpszFlags) - 2;
		if(lpszFlags[nPos] == ',') lpszFlags[nPos] = '\0';
	}

	return lpszFlags;
}


////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////
inline int _EcxGetBit(DWORD dwFlag)
{
	int nbit = 0;
	while(dwFlag != 1)
	{
		dwFlag >>= 1;
		nbit++;
	}

	return nbit;
}


////////////////////////////////////////////////////////////////////////////
//      x
////////////////////////////////////////////////////////////////////////////
inline double _frac(double x)
{
	double n;
	return modf(x, &n);
}


////////////////////////////////////////////////////////////////////////////
//   ,    
////////////////////////////////////////////////////////////////////////////
inline int _round(double x)
{
	return (int)(x + 0.5);
}


////////////////////////////////////////////////////////////////////////////
//   ,   p   
////////////////////////////////////////////////////////////////////////////
inline double _round(double x, int p)
{
	double k = pow(10.0,  (double)p);
	return _round(x * k) / k;
}




////////////////////////////////////////////////////////////////////////////
#endif // __FLOATINGPOINTSUPPORTFUNC_H__
