// FilledShapesFunc.h : header file
//

#ifndef __FILLEDSHAPESFUNC_H__
#define __FILLEDSHAPESFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  FilledShapesFunc.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_FILLEDSHAPESFUNC   "20.09.2012"



/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
inline void _EcxFastRect(HDC hDC, RECT* prc)
{
	::ExtTextOut(hDC, prc->left, prc->top, ETO_OPAQUE, prc, NULL, 0, NULL);
}

inline void _EcxFastRect(HDC hDC, int x, int y, int cx, int cy)
{
	RECT rc = { x, y, x + cx, y + cy };
	::ExtTextOut(hDC, rc.left, rc.top, ETO_OPAQUE, &rc, NULL, 0, NULL);
}

inline void _EcxFastColorRect(HDC hDC, RECT* prc, COLORREF cr)
{
	COLORREF cr0 = ::SetBkColor(hDC, _EcxGetSysColor(cr));
	::ExtTextOut(hDC, prc->left, prc->top, ETO_OPAQUE, prc, NULL, 0, NULL);
	::SetBkColor(hDC, cr0);
}

inline void _EcxFastColorRect(HDC hDC, int x, int y, int cx, int cy, COLORREF cr)
{
	COLORREF cr0 = ::SetBkColor(hDC, _EcxGetSysColor(cr));
	RECT rc = { x, y, x + cx, y + cy };
	::ExtTextOut(hDC, rc.left, rc.top, ETO_OPAQUE, &rc, NULL, 0, NULL);
	::SetBkColor(hDC, cr0);
}








/////////////////////////////////////////////////////////////////////////////
//     TRIVERTEX
/////////////////////////////////////////////////////////////////////////////
#define TRIVERTEX_COLOR(tvrt, tvrt_color) \
	tvrt.Red = (USHORT)(tvrt_color << 8) ; \
	tvrt.Green = (USHORT)(tvrt_color & 0x0000FF00); \
	tvrt.Blue = (USHORT)(tvrt_color >> 8); \
	tvrt.Alpha = 0


/////////////////////////////////////////////////////////////////////////////
//     TRIVERTEX
/////////////////////////////////////////////////////////////////////////////
#define TRIVERTEX_POS(tvrt, tvrt_x, tvrt_y) \
	tvrt.x = tvrt_x; \
	tvrt.y = tvrt_y



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#define GRAD_H12  GRADIENT_FILL_RECT_H
#define GRAD_H21  ( GRADIENT_FILL_RECT_H | 0x80000000 ) 

#define GRAD_V12  GRADIENT_FILL_RECT_V
#define GRAD_V21  ( GRADIENT_FILL_RECT_V | 0x80000000 ) 


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline void _EcxGradientRect(HDC hDC, int x, int y, int cx, int cy, int nDirection, COLORREF cr1, COLORREF cr2)
{
	TRIVERTEX tvrt[2];
	if(nDirection & 0x80000000) _EcxSwap(&cr1, &cr2);

	//    
	TRIVERTEX_POS(tvrt[0], x, y);
	TRIVERTEX_COLOR(tvrt[0], _EcxGetSysColor(cr1));

	//    
	TRIVERTEX_POS(tvrt[1], cx, cy);
	TRIVERTEX_COLOR(tvrt[1], _EcxGetSysColor(cr2));

	//   
	GRADIENT_RECT grc = { 0, 1 };
	::GradientFill(hDC, tvrt, 2, &grc, 1, nDirection & 0x000000FF);
}






////////////////////////////////////////////////////////////////////////////
#endif // __FILLEDSHAPESFUNC_H__
