// SystemInformationFunc.h : header file
//

#ifndef __SYSTEMINFORMATIONFUNC_H__
#define __SYSTEMINFORMATIONFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  SystemInformationFunc.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_SYSTEMINFORMATIONFUNC   "25.06.2012"



/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
#include "SystemInformation.h"
#include "..\DynamicLinkLibraries\DynamicLinkLibrariesFunc.h"



////////////////////////////////////////////////////////////////////////////
//      %env%
////////////////////////////////////////////////////////////////////////////
inline DWORD _EcxExpandEnvironment(LPCTSTR lpEnv, LPTSTR lpExpEnv, BOOL* pExpanded = NULL, PFN_EXPANDENVIRONMENTPROC ExpandEnvironmentProc = NULL, void* pData = NULL)
{
	if(lpEnv == NULL) return 0;

	DWORD dwLength = ::ExpandEnvironmentStrings(lpEnv, NULL, 0);
	char* tmp = new char[dwLength + MAX_PATH];
	tmp[0] = '\0';

	dwLength = ::ExpandEnvironmentStrings(lpEnv, tmp, dwLength);
	BOOL res = (strcmp(lpEnv, tmp) == 0);
	DWORD err = ::GetLastError();
	BOOL isExpanded = TRUE;

	if(dwLength == 0 || err == ERROR_ENVVAR_NOT_FOUND || res)
	{
		DWORD dw;
		dwLength = 0;

		ifstricmp(lpEnv, "%app_full%") dwLength = _EcxGetModuleName(tmp, MODULE_FULL);
		ifstricmp(lpEnv, "%app_path%") dwLength = _EcxGetModuleName(tmp, MODULE_PATH);
		ifstricmp(lpEnv, "%app_name%") dwLength = _EcxGetModuleName(tmp, MODULE_NAME);

		ifstricmp(lpEnv, "%sys_dir%") dwLength = ::GetSystemDirectory(tmp, MAX_PATH);
		ifstricmp(lpEnv, "%win_dir%") dwLength = ::GetWindowsDirectory(tmp, MAX_PATH);

		ifstricmp(lpEnv, "%user_name%")
		{
			dw = 257;
			::GetUserName(tmp, &dw);
			dwLength = dw;
		}

		ifstricmp(lpEnv, "%cmp_name%")
		{
			dw = MAX_COMPUTERNAME_LENGTH + 1;
			::GetComputerName(tmp, &dw);
			dwLength = dw;
		}
		
		
		isExpanded = (dwLength > 0);
	}

	if(!isExpanded && ExpandEnvironmentProc != NULL)
	{
		//    
		dwLength = ExpandEnvironmentProc(lpEnv, NULL, NULL, pData);

		//   
		if(dwLength > 0)
		{
			delete [] tmp;
			tmp = new char[dwLength + 1];
			dwLength = ExpandEnvironmentProc(lpEnv, tmp, &isExpanded, pData);
		}
	}

	dwLength = strlen(tmp);
	if(lpExpEnv != NULL) strcpy(lpExpEnv, tmp);
	delete [] tmp;

	if(pExpanded) *pExpanded = isExpanded;
	return dwLength;
}
 

/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline BOOL _EcxIsWinNT()
{
  // get windows version
  DWORD dwWindowsVersion = ::GetVersion();
  DWORD dwWindowsMajorVersion = (DWORD)(LOBYTE(LOWORD(dwWindowsVersion)));
  DWORD dwWindowsMinorVersion = (DWORD)(HIBYTE(LOWORD(dwWindowsVersion)));

  // Running on WIN9x ?
  if(dwWindowsVersion >= 0x80000000) return FALSE;
  
  // Running on NT
  return TRUE;
}





////////////////////////////////////////////////////////////////////////////
#endif // __SYSTEMINFORMATIONFUNC_H__
