// TextParsing.h : header file
//

#ifndef __TEXTPARSING_H__
#define __TEXTPARSING_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  TextParsing.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_TEXTPARSING   "20.03.2013"



/////////////////////////////////////////////////////////////////////////////
#ifndef _INTEGRAL_MAX_BITS
#define _INTEGRAL_MAX_BITS  64
#endif


////////////////////////////////////////////////////////////////////////////
//    lpBr1...lpBr2
////////////////////////////////////////////////////////////////////////////
typedef struct _BlockInfo  // binf
{
	char* lpBr1;	//  
	char* lpBr2;	//  
	BOOL isDelete;	//    lpBr1  lpBr2
	BOOL isCase;	//    
	int nType;		//  

	char* pBeg;		// 
	int nLength;	// 

	char* pBuff;	// 

	// 
	_BlockInfo()
	{
		memset(this, 0, sizeof(_BlockInfo));
	}

	// 
	~_BlockInfo()
	{
		if(isDelete)
		{
			if(lpBr1 != NULL) delete [] lpBr1;
			if(lpBr2 != NULL) delete [] lpBr2;
		}
	}

} BLOCK_INFO;


////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////
enum _SkipNonInfoType
{
	SKIP_BLANK				= 0x00000001,	//    [\v\f\t\s\xA0]  [\x0B\x0C\x09\x20\xA0]
	SKIP_NEWLINE_BREAK		= 0x00000002,	//    \EOL \EOT
	SKIP_STRING				= 0x00000004,	//    "str1"
	SKIP_STRING_CAT			= 0x00000008,	//    "str1" "str2" ... "strN"

	SKIP_USE_STATE_FUNC		= 0x00000010,
	SKIP_USE_CUSTOM_FUNC	= 0x00000020,
	SKIP_EOL				= 0x00000040,	//    [\n\r] [\x0A\x0D]
	SKIP_00000080			= 0x00000080,

	SKIP_MULTYLINE_COMMENT	= 0x00000100,	//    /*   COMMENT  */
	SKIP_HTML_COMMENT		= 0x00000200,	//    <!-- COMMENT -->
	SKIP_PASCAL_COMMENT		= 0x00000400,	//    (*   COMMENT  *)
	SKIP_COMMENT3			= 0x00000800,	//    {    COMMENT   }
	
	SKIP_COMMENT4			= 0x00001000,	//    <-   COMMENT  ->
	SKIP_00002000			= 0x00002000,
	SKIP_00004000			= 0x00004000,
	SKIP_00008000			= 0x00008000,

	SKIP_00010000			= 0x00010000,
	SKIP_00020000			= 0x00020000,
	SKIP_00040000			= 0x00040000,
	SKIP_00080000			= 0x00080000,

	SKIP_00100000			= 0x00100000,
	SKIP_00200000			= 0x00200000,
	SKIP_00400000			= 0x00400000,
	SKIP_00800000			= 0x00800000,

	SKIP_ONELINE_COMMENT	= 0x01000000,	//    //  COMMENT BR
	SKIP_VBSCRIPT_COMMENT	= 0x02000000,	//    '   COMMENT BR
	SKIP_BATCH_COMMENT		= 0x04000000,	//    REM COMMENT BR
	SKIP_COMMENT1			= 0x08000000,	//    #   COMMENT BR
	
	SKIP_COMMENT2			= 0x10000000,	//    ;   COMMENT BR
	SKIP_20000000			= 0x20000000,
	SKIP_40000000			= 0x40000000,
	SKIP_80000000			= 0x80000000,

// Haskell, Ada, Lua				-- COMMENT BR
// Forth							\ COMMENT BR
// Assembler						;  !  /  # COMMENT BR
// AWK, Perl, Python, Ruby, PHP		# COMMENT BR
// BASIC							'  REM COMMENT BR
// Clarion							! COMMENT BR
// MATLAB, Prolog, TeX				% COMMENT BR
// 
// 


	SKIP_SPACES				= SKIP_BLANK | SKIP_EOL,
	SKIP_BASE				= SKIP_SPACES | SKIP_ONELINE_COMMENT | SKIP_MULTYLINE_COMMENT | SKIP_NEWLINE_BREAK,
	SKIP_ALL				= 0xFFFFFFFF
};



////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////
typedef BOOL (CALLBACK *PFN_SKIPNONINFOPROC) (char**, int);


////////////////////////////////////////////////////////////////////////////
//    _EcxGetString
////////////////////////////////////////////////////////////////////////////
#define GSTR_SKIP		(char*)0x00000000
#define GSTR_LENGTH		(char*)0x00000001










////////////////////////////////////////////////////////////////////////////
#endif // __TEXTPARSING_H__
