// TextParsingMacro.h : header file
//

#ifndef __TEXTPARSINGMACRO_H__
#define __TEXTPARSINGMACRO_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  TextParsingMacro.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_TEXTPARSINGMACRO   "26.11.2016"


////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
#define cmp2(buf, val)	( *(WORD*)(buf) == (WORD)(val) )
#define cmp3(buf, val)	( (*(DWORD*)(buf) & 0x00FFFFFF) == (DWORD)(val) )
#define cmp4(buf, val)	( *(DWORD*)(buf) == (DWORD)(val) )

////////////////////////////////////////////////////////////////////////////
//     ( ) ????? error
////////////////////////////////////////////////////////////////////////////
#define cmpi1(buf, val)	( (*(BYTE*)(buf) & 0xDF) == (BYTE)(val) )
#define cmpi2(buf, val)	( (*(WORD*)(buf) & 0xDFDF) == (WORD)(val) )
#define cmpi3(buf, val)	( (*(DWORD*)(buf) & 0x00DFDFDF) == (DWORD)(val) )
#define cmpi4(buf, val)	( (*(DWORD*)(buf) & 0xDFDFDFDF) == (DWORD)(val) )
#define cmpi5(buf, val4, val1)	( cmpi4(buf, val4) && cmpi1(buf + 4, val1) )
#define cmpi6(buf, val4, val2)	( cmpi4(buf, val4) && cmpi2(buf + 4, val2) )


////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////
#define is_xml_tag_first_char(buf)		( is_char(*(buf), CCM_WORD) || *(buf) == ':' )
#define is_xml_tag_next_char(buf)		( is_xml_tag_first_char(buf) || *(buf) == '-' || *(buf) == '.' )
#define is_eot(buf)						( is_char(*(buf), CCM_EOT) )
#define is_not_eot(buf)					( is_char(*(buf), CCM_EOT|CCM_INV) )
#define is_stop(buf)					( is_char(*(buf), CCM_STOP) )
#define is_newline_break(buf)			( *(WORD*)(buf) == 0x0D5C || *(WORD*)(buf) == 0x0A5C || *(WORD*)(buf) == 0x005C )
#define is_comment(buf)					( *(WORD*)(buf) == 0x2F2F || *(WORD*)(buf) == 0x2A2F )
#define is_oneline_comment(buf)			( *(WORD*)(buf) == 0x2F2F )
#define is_multyline_comment(buf)		( *(WORD*)(buf) == 0x2A2F )
#define is_eol(buf)						( cmp3(buf, 0x000A0D0D) ? 3 : (*(WORD*)(buf) == 0x0A0D || *(WORD*)(buf) == 0x0D0A || *(WORD*)(buf) == 0x0D0D) ? 2 : ((*(buf) == 0x0A || *(buf) == 0x0D) ? 1 : 0) )
#define is_eol_eot(buf)					( cmp3(buf, 0x000A0D0D) ? 3 : (*(WORD*)(buf) == 0x0A0D || *(WORD*)(buf) == 0x0D0A || *(WORD*)(buf) == 0x0D0D) ? 2 : ((*(buf) == 0x0A || *(buf) == 0x0D || is_eot(buf)) ? 1 : 0) )




#define is_hex(ch)		( is_char((ch), CCM_HEX) )
#define is_alpha(ch)	( is_char((ch), CCM_ALPHA) )
#define is_alnum(ch)	( is_char((ch), CCM_ALNUM) )
#define is_id_start(ch)	( is_char((ch), CCM_ALPHA) || (ch)=='_'  || (ch)=='#')
#define is_id_next(ch)	( is_char((ch), CCM_WORD) )










////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////
#define skip_num1(buf, num)      if(*(BYTE*)(buf) == num) (buf) += 1;
#define skip_num2(buf, num)      if(*(WORD*)(buf) == num) (buf) += 2;
#define skip_num4(buf, num)      if(*(DWORD*)(buf) == num) (buf) += 4;


////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////
#define skip_word(buf)           while(is_char(*(buf), CCM_WORD)) (buf)++
#define skip_spaces(buf)         while(is_char(*(buf), CCM_SPACE)) (buf)++
#define skip_blank(buf)          while(is_char(*(buf), CCM_BLANK)) (buf)++
#define skip_digit(buf)          while(is_char(*(buf), CCM_DIGIT)) (buf)++
#define skip_class(buf, cls)     while(is_char(*(buf), cls)) (buf)++
#define skip_bitarray(buf, ba)   while(ba.IsBit(*(buf))) (buf)++

#define skip_line(buf)           while(!is_char(*(buf), CCM_STOP)) (buf)++; skip_eol(buf)
#define skip_comment(buf)        while(*(WORD*)(buf) != 0x2F2A && *(buf)) (buf)++

#define skip_to_char(buf, ch)    while(*(buf) != ch && !is_char(*(buf), CCM_EOT)) (buf)++
#define skip_to_word(buf, word)  while(*(WORD*)(buf) != word && !is_char(*(buf), CCM_EOT)) (buf)++
#define skip_to_class(buf, cls)  while(!is_char(*(buf), cls) && !is_char(*(buf), CCM_EOT)) (buf)++


#define skip_multiple_char(buf, ch)     while(*(buf) == ch) (buf)++; (buf)--;
#define skip_inline_to_char(buf, ch)    while(*(buf) != ch && !is_char(*(buf), CCM_STOP)) (buf)++

#define skip_comma(buf)          skip_spaces(buf); if(*(buf) == ',') (buf)++; skip_spaces(buf)



//  0x0A  0x0D  0x0A0D  0x0D0A
#define skip_eol(buf) \
	if(*(WORD*)(buf) == 0x0A0D || *(WORD*)(buf) == 0x0D0A) (buf) += 2; \
	else if(*(buf) == 0x0A || *(buf) == 0x0D) (buf)++; \





//  
#define skip_line_comment(buf)   skip_spaces(buf); if(*(WORD*)(buf) == 0x2F2F) { skip_line(buf); }



#define skip_lines(buf, n, i) \
	for(i=0; i<n; i++) \
	{ \
		skip_line(tmp); \
		if(!*tmp) break; \
	}
	

#define skip_n(buf, i, n) \
	i = 0; \
	while(*buf) { if(i == n) break; i++; buf++; }




#define _skip_to_char(buf, ch, is) \
	while(*buf != ch && !is_char(*buf, CCM_EOT)) buf++; \
	is = (*buf == ch)

#define _skip_to_word(buf, word, is) \
	while(*(WORD*)buf != word && *buf) buf++; \
	is = (*(WORD*)buf == word)

#define _skip_to_class(buf, mask, is) \
	while(!is_char(*buf, mask) && *buf) buf++; \
	is = is_char(*buf, mask)


#define skip_char_to(buf, ch, x, n) \
	x = 0; \
	while(*buf == ch) { if(x == n) break; x++; buf++; }

#define skip_char(buf, ch, i) \
	i = 0; \
	while(*buf == ch) { i++; buf++; }

#define skip_class_to(buf, mask, x, n) \
	x = 0; \
	while(is_char(*buf, mask)) { if(x == (n)) break; x++; buf++; }

#define __skip_class(buf, mask, x) \
	x = 0; \
	while(is_char(*buf, mask)) { x++; buf++; }


#define _skip_char(buf, ch, x) \
	x = 0; \
	while(*buf == ch || is_char(*buf, CCM_BLANK)) \
	{ \
		if(is_char(*buf++, CCM_BLANK)) continue; \
		x++; \
	}

#define _skip_class(buf, mask, x) \
	x = 0; \
	while(is_char(*buf, mask) || is_char(*buf, CCM_BLANK)) \
	{ \
		if(is_char(*buf++, CCM_BLANK)) continue; \
		x++; \
	}


#define next_char(buf, ch) \
	buf++; \
	ch = *buf











/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#define __scan_skip_spaces(buf, count) \
	while(is_char(*buf, CCM_SPACE)) \
	{ \
		buf++; \
		count++; \
	}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#define __scan_number(buf, is, num) \
	is = FALSE; \
	num = 0; \
	while(is_char(*buf, CCM_DIGIT)) \
	{ \
		is = TRUE; \
		num = mul_10(num) + (*buf - '0'); \
		buf++; \
	}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#define __scan_inc(buf, ch, count) \
	ch = *buf; \
	buf++; \
	count++

	
/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#define __scan_dec(buf, ch, count) \
	if(ch != '\0') \
	{ \
		buf--; \
		count--; \
	}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#define __scan_dec_width(is, width, n) \
	if(is) width -= n;









/////////////////////////////////////////////////////////////////////////////
// 0123456789(abcdef | ABCDEF) -> 0123456789:;<=>?
// 0123456789(abcdef | ABCDEF) -> 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
/////////////////////////////////////////////////////////////////////////////
#define _EcxConvertHex(ch)		( (is_char((ch), CCM_DIGIT) ? (ch) : (char)(((ch) | 0x20) - 0x27)) )
#define _EcxHex2Int(ch)			( _EcxConvertHex(ch) - '0' )








////////////////////////////////////////////////////////////////////////////
#endif // __TEXTPARSINGMACRO_H__
