// EHighResolutionTimer.h
//

#ifndef __EHIGHRESOLUTIONTIMER_H__
#define __EHIGHRESOLUTIONTIMER_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  EHighResolutionTimer.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_EHIGHRESOLUTIONTIMER   "17.01.2011"



////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////
class EHighResolutionTimer  // hrt
{
public:

	///////////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////////
	EHighResolutionTimer()
	{
		Reset();
		m_isTimerInstalled = ::QueryPerformanceFrequency((LARGE_INTEGER*)&m_qwFreq) ? true : false;
	}


	///////////////////////////////////////////////////////////////////
	//   
	///////////////////////////////////////////////////////////////////
	void Start()
	{
		if(m_isTimerInstalled)
			::QueryPerformanceCounter((LARGE_INTEGER*)&m_qwStart);
	}


	///////////////////////////////////////////////////////////////////
	//   
	///////////////////////////////////////////////////////////////////
	void Stop()
	{
		if(m_isTimerInstalled)
			::QueryPerformanceCounter((LARGE_INTEGER*)&m_qwStop);
	}


	///////////////////////////////////////////////////////////////////
	//   
	///////////////////////////////////////////////////////////////////
	double GetTime()
	{
		double dTime = 0.0;
		if(m_isTimerInstalled && m_qwFreq != 0)
		{
			dTime = (double)((m_qwStop - m_qwStart) / (double)m_qwFreq);
		}

		return dTime;
	}


	///////////////////////////////////////////////////////////////////
	//     
	///////////////////////////////////////////////////////////////////
	char* GetTimeString()
	{
		sprintf(m_szTime, "%f", GetTime());
		return m_szTime;
	}


	///////////////////////////////////////////////////////////////////
	//  
	///////////////////////////////////////////////////////////////////
	void Reset()
	{
		m_qwStart = m_qwStop = 0;
	}


	///////////////////////////////////////////////////////////////////
	//        
	///////////////////////////////////////////////////////////////////
	BOOL IsTimerInstalled()
	{
		return m_isTimerInstalled;
	}


protected:

	BOOL m_isTimerInstalled;
	__int64 m_qwStart, m_qwStop, m_qwFreq;
	char m_szTime[16];
};


////////////////////////////////////////////////////////////////////////////
#endif // __EHIGHRESOLUTIONTIMER_H__
