// Messages.h:   (25  2004 .)
//

#ifndef __MESSAGES_H__
#define __MESSAGES_H__
#pragma once

/////////////////////////////////////////////////////////////////////////////

#include "vfw.h"		// (WM_CAP_)
#include "cpl.h"		// (WM_CPL_)
#include "ime.h"		// (WM_IME_)
#include "dde.h"		// (WM_DDE_)
#include "commdlg.h"	// (WM_PSD_)


/////////////////////////////////////////////////////////////////////////////
//  Messages.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_MESSAGES   "08.03.2011"



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
typedef struct _MessageType  // msgtype
{
	LPTSTR lpszTypeName;
	LPTSTR lpszDescription;
	LPTSTR lpszHelpUrl;
	
} MESSAGETYPE, *PMESSAGETYPE;


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
typedef struct _MessageInfo  // msginf
{
	UINT uMsg;
	LPTSTR lpszMsgName;
	UINT uType;
	LPTSTR lpszDecode;
	LPTSTR lpszSig;
	LPTSTR lpszFunction;
	LPTSTR lpszHelpUrl;
	
} MESSAGEINFO, *PMESSAGEINFO;


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
typedef struct _MessageDescription  // msgdes
{
	UINT uMsg;
	UINT nFlags;
	LPTSTR lpszMsgName;
	LPTSTR lpszDecode;
	LPTSTR lpszSig;
	LPTSTR lpszFunction;
	LPTSTR lpszDescription;
	
} MESSAGEDESCRIPTION, *PMESSAGEDESCRIPTION;



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#ifdef USED_MESSAGES


/////////////////////////////////////////////////////////////////////////////
#define WM_QUERYAFXWNDPROC          0x0360
#define WM_SIZEPARENT               0x0361
#define WM_SETMESSAGESTRING         0x0362
#define WM_IDLEUPDATECMDUI          0x0363
#define WM_INITIALUPDATE            0x0364
#define WM_COMMANDHELP              0x0365
#define WM_HELPHITTEST              0x0366
#define WM_EXITHELPMODE             0x0367
#define WM_RECALCPARENT             0x0368
#define WM_SIZECHILD                0x0369
#define WM_KICKIDLE                 0x036A
#define WM_QUERYCENTERWND           0x036B
#define WM_DISABLEMODAL             0x036C
#define WM_FLOATSTATUS              0x036D
#define WM_ACTIVATETOPLEVEL         0x036E
#define WM_QUERY3DCONTROLS          0x036F

#define WM_RESERVED_0370            0x0370
#define WM_RESERVED_0371            0x0371
#define WM_RESERVED_0372            0x0372
#define WM_SOCKET_NOTIFY            0x0373
#define WM_SOCKET_DEAD              0x0374
#define WM_POPMESSAGESTRING         0x0375
#define WM_HELPPROMPTADDR           0x0376
#define WM_OCC_LOADFROMSTREAM       0x0376
#define WM_OCC_LOADFROMSTORAGE      0x0377
#define WM_OCC_INITNEW              0x0378
#define WM_OCC_LOADFROMSTREAM_EX    0x037A
#define WM_OCC_LOADFROMSTORAGE_EX   0x037B
#define WM_QUEUE_SENTINEL           0x0379
#define WM_RESERVED_037C            0x037C
#define WM_RESERVED_037D            0x037D
#define WM_RESERVED_037E            0x037E
#define WM_FORWARDMSG               0x037F



/////////////////////////////////////////////////////////////////////////////
// Message Type Flags (MTF_)
/////////////////////////////////////////////////////////////////////////////
#define MTF_SELECTED	0x00000001
#define MTF_DDE			0x00020000
#define MTF_CLIPBOARD	0x00040000
#define MTF_NONCLIENT	0x00080000
#define MTF_LISTBOX		0x00200000
#define MTF_BUTTON		0x00400000
#define MTF_STATIC		0x00800000
#define MTF_EDIT		0x02000000
#define MTF_SCROLLBAR	0x04000000
#define MTF_IMEDITOR	0x08000000
#define MTF_MFC			0x10000000


enum _MessageTypes
{
	MT_UNKNOWN,
	MT_HOOK,				// Hook Messages
	MT_COMMONCONTROL,		// Common Control Messages
	MT_POWERMANAGEMENT,		// Power Management Messages
	MT_MOUSEINPUT,			// Mouse Input Messages
	MT_KEYBOARDINPUT,		// Keyboard Input Messages
	MT_KEYBOARDACCEL,		// Keyboard Accelerator Messages"
	MT_WINDOW,				// Window Messages
	MT_PAINTINGDRAWING,		// Painting and Drawing Messages
	MT_SYSTEMSHUTDOWN,		// System Shutdown Messages
	MT_COLOR,				// Color Messages
	MT_DEVICECONTEXT,		// Device Context Messages
	MT_FONTTEXT,			// Font and Text Messages
	MT_TIME,				// Time Messages
	MT_CURSOR,				// Cursor Messages
	MT_DIALOGBOX,			// Dialog Box Messages
	MT_PRINTSPOOLER,		// Printing and Print Spooler Messages
	MT_CONTROL,				// Control Messages
	MT_ACCESSIBILITY,		// Microsoft Active Accessibility Messages
	MT_INTERPROCESS,		// Interprocess Communications Messages
	MT_COMBOBOX,			// Combo Box Messages
	MT_DDE,					// Dynamic Data Exchange (DDE) Messages
	MT_CLIPBOARD,			// Clipboard Messages
	MT_LISTBOX,				// List Box Messages
	MT_TREEVIEW,			// TreeView messages
	MT_,			// 

};

static MESSAGETYPE g_msgtype[] =
{
	{ "MT_UNKNOWN",			"", "" },
	{ "MT_HOOK",			"Hook Messages",							"winbase.chm::/devdoc/live/pdwbase/hooks_4cab.htm" },
	{ "MT_COMMONCONTROL",	"Common Control Messages",					"Shellcc.chm::/inet401/help/itt/CommCtls/Common/Messages/Messages.htm" },
	{ "MT_POWERMANAGEMENT",	"Power Management Messages",				"winbase.chm::/devdoc/live/pdwbase/power_11rn.htm" },
	{ "MT_MOUSEINPUT",		"Mouse Input Messages",						"winui.chm::/devdoc/live/pdui/mousinpt_5gs3.htm" },
	{ "MT_KEYBOARDINPUT",	"Keyboard Input Messages",					"winui.chm::/devdoc/live/pdui/keybinpt_4iib.htm" },
	{ "MT_KEYBOARDACCEL",	"Keyboard Accelerator Messages",			"winui.chm::/devdoc/live/pdui/keybacel_9vzn.htm" },
	{ "MT_WINDOW",			"Window Messages",							"winui.chm::/devdoc/live/pdui/windows_2v8z.htm" },
	{ "MT_PAINTINGDRAWING",	"Painting and Drawing Messages",			"GDI.chm::/devdoc/live/pdgrmm/pantdraw_51v7.htm" },
	{ "MT_SYSTEMSHUTDOWN",	"System Shutdown Messages",					"Sysmgmt.chm::/devdoc/live/pdsms/shutdown_2hir.htm" },
	{ "MT_COLOR",			"Color Messages",							"GDI.chm::/devdoc/live/pdgrmm/colors_8alv.htm" },
	{ "MT_DEVICECONTEXT",	"Device Context Messages",					"GDI.chm::/devdoc/live/pdgrmm/devcons_72cz.htm" },
	{ "MT_FONTTEXT",		"Font and Text Messages",					"GDI.chm::/devdoc/live/pdgrmm/fontext_8nxv.htm" },
	{ "MT_TIME",			"Time Messages",							"winbase.chm::/devdoc/live/pdwbase/time_9iur.htm" },
	{ "MT_CURSOR",			"Cursor Messages",							"winui.chm::/devdoc/live/pdui/cursors_0drn.htm" },
	{ "MT_DIALOGBOX",		"Dialog Box Messages",						"winui.chm::/devdoc/live/pdui/dlgboxes_3dbn.htm" },
	{ "MT_PRINTSPOOLER",	"Printing and Print Spooler Messages",		"GDI.chm::/devdoc/live/pdgrmm/prntspol_85v7.htm" },
	{ "MT_CONTROL",			"Control Messages",							"winui.chm::/devdoc/live/pdui/controls_8d0z.htm" },
	{ "MT_ACCESSIBILITY",	"Microsoft Active Accessibility Messages",	"msaa.chm::/devdoc/good/msaa/msaasdk_106r.htm" },
	{ "MT_INTERPROCESS",	"Interprocess Communications Messages",		"winbase.chm::/devdoc/live/pdwbase/ipc_4w1f.htm" },
	{ "MT_COMBOBOX",		"Combo Box Messages",						"winui.chm::/devdoc/live/pdui/combobox_7icz.htm" },
	{ "MT_DDE",				"Dynamic Data Exchange (DDE) Messages",		"winbase.chm::/devdoc/live/pdwbase/dde_7voz.htm" },
	{ "MT_CLIPBOARD",		"Clipboard Messages",						"winbase.chm::/devdoc/live/pdwbase/clipbrd_2bar.htm" },
	{ "MT_LISTBOX",			"List Box Messages",						"winui.chm::/devdoc/live/pdui/listbox_05rn.htm" },
	{ "MT_TREEVIEW",		"TreeView messages",						"Shellcc.chm::/inet401/help/itt/CommCtls/TreeView/Messages.htm#treeview_messages" },


};



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
static MESSAGEINFO g_msginf;
static char g_strMsgName[64];





//         wParam   lParam
// return (Lo, Hi) (Lo, Hi)


static MESSAGEINFO g_msginfSystem[WM_USER + 1] =
{
	/////////////////////////////////////////////////////////////////////////
	{ 0x0000, "WM_NULL",			0,					"()()", "sig_", "", "" },
	{ 0x0001, "WM_CREATE",			MT_WINDOW,			"i()(LPCREATESTRUCT=pCs)", "sig_is", "int OnCreate(LPCREATESTRUCT lpCreateStruct);", "winui.chm::/devdoc/live/pdui/windows_41d1.htm" },
	{ 0x0002, "WM_DESTROY",			MT_WINDOW,			"0()()", "sig_vv", "void OnDestroy();", "winui.chm::/devdoc/live/pdui/windows_414p.htm" },
	{ 0x0003, "WM_MOVE",			MT_WINDOW,			"0()(int=xPos,int=yPos)", "sig_vvii", "void OnMove(int xPos, int yPos);", "winui.chm::/devdoc/live/pdui/windows_9ip1.htm" },
	{ 0x0004, "wm_sizewait",		0,					"()()", "sig_", "", "" },
	{ 0x0005, "WM_SIZE",			MT_WINDOW,			"0(UINT=fwSizeType)(int=nWidth,int=nHeight)", "sig_vuii", "void OnSize(UINT nType, int cx, int cy);", "winui.chm::/devdoc/live/pdui/windows_2pk5.htm" },
	{ 0x0006, "WM_ACTIVATE",		MT_KEYBOARDINPUT,	"()()", "sig_", "", "" },
	{ 0x0007, "WM_SETFOCUS",		MT_KEYBOARDINPUT,	"()()", "sig_", "", "" },
	{ 0x0008, "WM_KILLFOCUS",		MT_KEYBOARDINPUT,	"()()", "sig_", "", "" },
	{ 0x0009, "WM_SETVISIBLE",		0,					"()()", "sig_", "", "" },
	{ 0x000A, "WM_ENABLE",			MT_WINDOW,			"0(BOOL=fEnabled)()", "sig_vb", "void OnEnable(BOOL bEnable);", "winui.chm::/devdoc/live/pdui/windows_1ahx.htm" },
	{ 0x000B, "WM_SETREDRAW",		MT_PAINTINGDRAWING,	"()()", "sig_", "", "" },
	{ 0x000C, "WM_SETTEXT",			MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x000D, "WM_GETTEXT",			MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x000E, "WM_GETTEXTLENGTH",	MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x000F, "WM_PAINT",			MT_PAINTINGDRAWING,	"()()", "sig_", "", "" },

	/////////////////////////////////////////////////////////////////////////
	{ 0x0010, "WM_CLOSE",			MT_WINDOW,			"0()()", "sig_vv", "void OnClose();", "winui.chm::/devdoc/live/pdui/windows_5uhx.htm" },
	{ 0x0011, "WM_QUERYENDSESSION",	MT_SYSTEMSHUTDOWN,	"()()", "sig_", "", "" },
	{ 0x0012, "WM_QUIT",			MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x0013, "WM_QUERYOPEN",		MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x0014, "WM_ERASEBKGND",		MT_PAINTINGDRAWING, "()()", "sig_", "", "" },
	{ 0x0015, "WM_SYSCOLORCHANGE",	MT_COLOR,			"()()", "sig_", "", "" },
	{ 0x0016, "WM_ENDSESSION",		MT_SYSTEMSHUTDOWN,	"()()", "sig_", "", "" },
	{ 0x0017, "wm_systemerror",		0,					"()()", "sig_", "", "" },
	{ 0x0018, "WM_SHOWWINDOW",		MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x0019, "WM_CTLCOLOR",		0,					"()()", "sig_", "", "" },
	{ 0x001A, "WM_WININICHANGE",	MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x001B, "WM_DEVMODECHANGE",	MT_DEVICECONTEXT,	"()()", "sig_", "", "" },
	{ 0x001C, "WM_ACTIVATEAPP",		MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x001D, "WM_FONTCHANGE",		MT_FONTTEXT,		"()()", "sig_", "", "" },
	{ 0x001E, "WM_TIMECHANGE",		MT_TIME,			"()()", "sig_", "", "" },
	{ 0x001F, "WM_CANCELMODE",		MT_WINDOW,			"()()", "sig_", "", "" },

	/////////////////////////////////////////////////////////////////////////
	{ 0x0020, "WM_SETCURSOR",		MT_CURSOR,			"()()", "sig_", "", "" },
	{ 0x0021, "WM_MOUSEACTIVATE",	MT_MOUSEINPUT,		"()()", "sig_", "", "" },
	{ 0x0022, "WM_CHILDACTIVATE",	MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x0023, "WM_QUEUESYNC",		MT_HOOK,			"()()", "sig_", "", "" },
	{ 0x0024, "WM_GETMINMAXINFO",	MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x0025, "wm_unused3",			0,					"()()", "sig_", "", "" },
	{ 0x0026, "WM_PAINTICON",		MT_PAINTINGDRAWING,	"()()", "sig_", "", "" },
	{ 0x0027, "WM_ICONERASEBKGND",	MT_PAINTINGDRAWING, "()()", "sig_", "", "" },
	{ 0x0028, "WM_NEXTDLGCTL",		MT_DIALOGBOX,		"()()", "sig_", "", "" },
	{ 0x0029, "wm_alttabactive",	0,					"()()", "sig_", "", "" },
	{ 0x002A, "WM_SPOOLERSTATUS",	MT_PRINTSPOOLER,	"()()", "sig_", "", "" },
	{ 0x002B, "WM_DRAWITEM",		0,					"()()", "sig_", "", "" },
	{ 0x002C, "WM_MEASUREITEM",		0,					"()()", "sig_", "", "" },
	{ 0x002D, "WM_DELETEITEM",		0,					"()()", "sig_", "", "" },
	{ 0x002E, "WM_VKEYTOITEM",		0,					"()()", "sig_", "", "" },
	{ 0x002F, "WM_CHARTOITEM",		0,					"()()", "sig_", "", "" },

	/////////////////////////////////////////////////////////////////////////
	{ 0x0030, "WM_SETFONT",			MT_CONTROL,			"()()", "sig_", "", "" },
	{ 0x0031, "WM_GETFONT",			MT_CONTROL,			"()()", "sig_", "", "" },
	{ 0x0032, "WM_SETHOTKEY",		MT_KEYBOARDINPUT,	"()()", "sig_", "", "" },
	{ 0x0033, "WM_GETHOTKEY",		MT_KEYBOARDINPUT,	"()()", "sig_", "", "" },
	{ 0x0034, "wm_filesyschange",	0,					"()()", "sig_", "", "" },
	{ 0x0035, "wm_isactiveicon",	0,					"()()", "sig_", "", "" },
	{ 0x0036, "wm_queryparkicon",	0,					"()()", "sig_", "", "" },
	{ 0x0037, "WM_QUERYDRAGICON",	MT_WINDOW,			"()()", "sig_", "", "" },
	{ 0x0038, "wm_querysavestate",	0,					"()()", "sig_", "", "" },
	{ 0x0039, "WM_COMPAREITEM",		0,					"()()", "sig_", "", "" },
	{ 0x003A, "wm_testing",			0,					"()()", "sig_", "", "" },
	{ 0x003B, NULL, 0, "", "", "" },
	{ 0x003C, NULL, 0, "", "", "" },
	{ 0x003D, "WM_GETOBJECT",		MT_ACCESSIBILITY,	"()()", "sig_", "", "" },
	{ 0x003E, "wm_activateshellwindow", 0,				"()()", "sig_", "", "" },
	{ 0x003F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0040, NULL, 0, "", "", "" },
	{ 0x0041, "wm_compacting", 0, "()()", "sig_", "", "" },
	{ 0x0042, NULL, 0, "", "", "" },
	{ 0x0043, NULL, 0, "", "", "" },
	{ 0x0044, "WM_COMMNOTIFY", 0, "()()", "sig_", "", "" },
	{ 0x0045, NULL, 0, "", "", "" },
	{ 0x0046, "WM_WINDOWPOSCHANGING", 0, "()()", "sig_", "", "" },
	{ 0x0047, "WM_WINDOWPOSCHANGED", 0, "()()", "sig_", "", "" },
	{ 0x0048, "WM_POWER", 0, "()()", "sig_", "", "" },
	{ 0x0049, NULL, 0, "", "", "" },
	{ 0x004A, "WM_COPYDATA", MT_INTERPROCESS, "b(HWND=hWnd)(PCOPYDATASTRUCT=pCds)", "sig_bpWCDS", "BOOL OnCopyData(EWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);", "winbase.chm::/devdoc/live/pdwbase/ipc_9alu.htm" },
	{ 0x004B, "WM_CANCELJOURNAL", 0, "()()", "sig_", "", "" },
	{ 0x004C, NULL, 0, "", "", "" },
	{ 0x004D, NULL, 0, "", "", "" },
	{ 0x004E, "WM_NOTIFY", 0, "()()", "sig_", "", "" },
	{ 0x004F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0050, "WM_INPUTLANGCHANGEREQUEST", 0, "()()", "sig_", "", "" },
	{ 0x0051, "WM_INPUTLANGCHANGE", 0, "()()", "sig_", "", "" },
	{ 0x0052, "WM_TCARD", 0, "()()", "sig_", "", "" },
	{ 0x0053, "WM_HELP", 0, "()()", "sig_", "", "" },
	{ 0x0054, "WM_USERCHANGED", 0, "()()", "sig_", "", "" },
	{ 0x0055, "WM_NOTIFYFORMAT", 0, "()()", "sig_", "", "" },
	{ 0x0056, NULL, 0, "", "", "" },
	{ 0x0057, NULL, 0, "", "", "" },
	{ 0x0058, NULL, 0, "", "", "" },
	{ 0x0059, NULL, 0, "", "", "" },
	{ 0x005A, NULL, 0, "", "", "" },
	{ 0x005B, NULL, 0, "", "", "" },
	{ 0x005C, NULL, 0, "", "", "" },
	{ 0x005D, NULL, 0, "", "", "" },
	{ 0x005E, NULL, 0, "", "", "" },
	{ 0x005F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0060, NULL, 0, "", "", "" },
	{ 0x0061, NULL, 0, "", "", "" },
	{ 0x0062, NULL, 0, "", "", "" },
	{ 0x0063, NULL, 0, "", "", "" },
	{ 0x0064, NULL, 0, "", "", "" },
	{ 0x0065, NULL, 0, "", "", "" },
	{ 0x0066, NULL, 0, "", "", "" },
	{ 0x0067, NULL, 0, "", "", "" },
	{ 0x0068, NULL, 0, "", "", "" },
	{ 0x0069, NULL, 0, "", "", "" },
	{ 0x006A, NULL, 0, "", "", "" },
	{ 0x006B, NULL, 0, "", "", "" },
	{ 0x006C, NULL, 0, "", "", "" },
	{ 0x006D, NULL, 0, "", "", "" },
	{ 0x006E, NULL, 0, "", "", "" },
	{ 0x006F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0070, NULL, 0, "", "", "" },
	{ 0x0071, NULL, 0, "", "", "" },
	{ 0x0072, NULL, 0, "", "", "" },
	{ 0x0073, NULL, 0, "", "", "" },
	{ 0x0074, NULL, 0, "", "", "" },
	{ 0x0075, NULL, 0, "", "", "" },
	{ 0x0076, NULL, 0, "", "", "" },
	{ 0x0077, NULL, 0, "", "", "" },
	{ 0x0078, NULL, 0, "", "", "" },
	{ 0x0079, NULL, 0, "", "", "" },
	{ 0x007A, NULL, 0, "", "", "" },
	{ 0x007B, "WM_CONTEXTMENU", 0, "()()", "sig_", "", "" },
	{ 0x007C, "WM_STYLECHANGING", 0, "()()", "sig_", "", "" },
	{ 0x007D, "WM_STYLECHANGED", 0, "()()", "sig_", "", "" },
	{ 0x007E, "WM_DISPLAYCHANGE", 0, "()()", "sig_", "", "" },
	{ 0x007F, "WM_GETICON", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0080, "WM_SETICON", 0, "()()", "sig_", "", "" },
	{ 0x0081, "WM_NCCREATE", 0, "()()", "sig_", "", "" },
	{ 0x0082, "WM_NCDESTROY", 0, "()()", "sig_", "", "" },
	{ 0x0083, "WM_NCCALCSIZE", 0, "()()", "sig_", "", "" },
	{ 0x0084, "WM_NCHITTEST", 0, "()()", "sig_", "", "" },
	{ 0x0085, "WM_NCPAINT", 0, "()()", "sig_", "", "" },
	{ 0x0086, "WM_NCACTIVATE", 0, "()()", "sig_", "", "" },
	{ 0x0087, "WM_GETDLGCODE", 0, "()()", "sig_", "", "" },
	{ 0x0088, "WM_SYNCPAINT", 0, "()()", "sig_", "", "" },
	{ 0x0089, "WM_SYNCTASK", 0, "()()", "sig_", "", "" },
	{ 0x008A, NULL, 0, "", "", "" },
	{ 0x008B, NULL, 0, "", "", "" },
	{ 0x008C, NULL, 0, "", "", "" },
	{ 0x008D, NULL, 0, "", "", "" },
	{ 0x008E, NULL, 0, "", "", "" },
	{ 0x008F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0090, NULL, 0, "", "", "" },
	{ 0x0091, NULL, 0, "", "", "" },
	{ 0x0092, NULL, 0, "", "", "" },
	{ 0x0093, NULL, 0, "", "", "" },
	{ 0x0094, NULL, 0, "", "", "" },
	{ 0x0095, NULL, 0, "", "", "" },
	{ 0x0096, NULL, 0, "", "", "" },
	{ 0x0097, NULL, 0, "", "", "" },
	{ 0x0098, NULL, 0, "", "", "" },
	{ 0x0099, NULL, 0, "", "", "" },
	{ 0x009A, NULL, 0, "", "", "" },
	{ 0x009B, NULL, 0, "", "", "" },
	{ 0x009C, NULL, 0, "", "", "" },
	{ 0x009D, NULL, 0, "", "", "" },
	{ 0x009E, NULL, 0, "", "", "" },
	{ 0x009F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x00A0, "WM_NCMOUSEMOVE", 0, "()()", "sig_", "", "" },
	{ 0x00A1, "WM_NCLBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x00A2, "WM_NCLBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x00A3, "WM_NCLBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x00A4, "WM_NCRBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x00A5, "WM_NCRBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x00A6, "WM_NCRBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x00A7, "WM_NCMBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x00A8, "WM_NCMBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x00A9, "WM_NCMBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x00AA, NULL, 0, "", "", "" },
	{ 0x00AB, "WM_NCXBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x00AC, "WM_NCXBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x00AD, "WM_NCXBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x00AE, NULL, 0, "", "", "" },
	{ 0x00AF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x00B0, "EM_GETSEL", 0, "()()", "sig_", "", "" },
	{ 0x00B1, "EM_SETSEL", 0, "()()", "sig_", "", "" },
	{ 0x00B2, "EM_GETRECT", 0, "()()", "sig_", "", "" },
	{ 0x00B3, "EM_SETRECT", 0, "()()", "sig_", "", "" },
	{ 0x00B4, "EM_SETRECTNP", 0, "()()", "sig_", "", "" },
	{ 0x00B5, "EM_SCROLL", 0, "()()", "sig_", "", "" },
	{ 0x00B6, "EM_LINESCROLL", 0, "()()", "sig_", "", "" },
	{ 0x00B7, "EM_SCROLLCARET", 0, "()()", "sig_", "", "" },
	{ 0x00B8, "EM_GETMODIFY", 0, "()()", "sig_", "", "" },
	{ 0x00B9, "EM_SETMODIFY", 0, "()()", "sig_", "", "" },
	{ 0x00BA, "EM_GETLINECOUNT", 0, "()()", "sig_", "", "" },
	{ 0x00BB, "EM_LINEINDEX", 0, "()()", "sig_", "", "" },
	{ 0x00BC, "EM_SETHANDLE", 0, "()()", "sig_", "", "" },
	{ 0x00BD, "EM_GETHANDLE", 0, "()()", "sig_", "", "" },
	{ 0x00BE, "EM_GETTHUMB", 0, "()()", "sig_", "", "" },
	{ 0x00BF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x00C0, NULL, 0, "", "", "" },
	{ 0x00C1, "EM_LINELENGTH", 0, "()()", "sig_", "", "" },
	{ 0x00C2, "EM_REPLACESEL", 0, "()()", "sig_", "", "" },
	{ 0x00C3, NULL, 0, "", "", "" },
	{ 0x00C4, "EM_GETLINE", 0, "()()", "sig_", "", "" },
	{ 0x00C5, "EM_LIMITTEXT", 0, "()()", "sig_", "", "" },
	{ 0x00C6, "EM_CANUNDO", 0, "()()", "sig_", "", "" },
	{ 0x00C7, "EM_UNDO", 0, "()()", "sig_", "", "" },
	{ 0x00C8, "EM_FMTLINES", 0, "()()", "sig_", "", "" },
	{ 0x00C9, "EM_LINEFROMCHAR", 0, "()()", "sig_", "", "" },
	{ 0x00CA, NULL, 0, "", "", "" },
	{ 0x00CB, "EM_SETTABSTOPS", 0, "()()", "sig_", "", "" },
	{ 0x00CC, "EM_SETPASSWORDCHAR", 0, "()()", "sig_", "", "" },
	{ 0x00CD, "EM_EMPTYUNDOBUFFER", 0, "()()", "sig_", "", "" },
	{ 0x00CE, "EM_GETFIRSTVISIBLELINE", 0, "()()", "sig_", "", "" },
	{ 0x00CF, "EM_SETREADONLY", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x00D0, "EM_SETWORDBREAKPROC", 0, "()()", "sig_", "", "" },
	{ 0x00D1, "EM_GETWORDBREAKPROC", 0, "()()", "sig_", "", "" },
	{ 0x00D2, "EM_GETPASSWORDCHAR", 0, "()()", "sig_", "", "" },
	{ 0x00D3, "EM_SETMARGINS", 0, "()()", "sig_", "", "" },
	{ 0x00D4, "EM_GETMARGINS", 0, "()()", "sig_", "", "" },
	{ 0x00D5, "EM_GETLIMITTEXT", 0, "()()", "sig_", "", "" },
	{ 0x00D6, "EM_POSFROMCHAR", 0, "()()", "sig_", "", "" },
	{ 0x00D7, "EM_CHARFROMPOS", 0, "()()", "sig_", "", "" },
	{ 0x00D8, "EM_SETIMESTATUS", 0, "()()", "sig_", "", "" },
	{ 0x00D9, "EM_GETIMESTATUS", 0, "()()", "sig_", "", "" },
	{ 0x00DA, NULL, 0, "", "", "" },
	{ 0x00DB, NULL, 0, "", "", "" },
	{ 0x00DC, NULL, 0, "", "", "" },
	{ 0x00DD, NULL, 0, "", "", "" },
	{ 0x00DE, NULL, 0, "", "", "" },
	{ 0x00DF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x00E0, "SBM_SETPOS", 0, "()()", "sig_", "", "" },
	{ 0x00E1, "SBM_GETPOS", 0, "()()", "sig_", "", "" },
	{ 0x00E2, "SBM_SETRANGE", 0, "()()", "sig_", "", "" },
	{ 0x00E3, "SBM_GETRANGE", 0, "()()", "sig_", "", "" },
	{ 0x00E4, "SBM_ENABLE_ARROWS", 0, "()()", "sig_", "", "" },
	{ 0x00E5, NULL, 0, "", "", "" },
	{ 0x00E6, "SBM_SETRANGEREDRAW", 0, "()()", "sig_", "", "" },
	{ 0x00E7, NULL, 0, "", "", "" },
	{ 0x00E8, NULL, 0, "", "", "" },
	{ 0x00E9, "SBM_SETSCROLLINFO", 0, "()()", "sig_", "", "" },
	{ 0x00EA, "SBM_GETSCROLLINFO", 0, "()()", "sig_", "", "" },
	{ 0x00EB, NULL, 0, "", "", "" },
	{ 0x00EC, NULL, 0, "", "", "" },
	{ 0x00ED, NULL, 0, "", "", "" },
	{ 0x00EE, NULL, 0, "", "", "" },
	{ 0x00EF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x00F0, "BM_GETCHECK", 0, "()()", "sig_", "", "" },
	{ 0x00F1, "BM_SETCHECK", 0, "()()", "sig_", "", "" },
	{ 0x00F2, "BM_GETSTATE", 0, "()()", "sig_", "", "" },
	{ 0x00F3, "BM_SETSTATE", 0, "()()", "sig_", "", "" },
	{ 0x00F4, "BM_SETSTYLE", 0, "()()", "sig_", "", "" },
	{ 0x00F5, "BM_CLICK", 0, "()()", "sig_", "", "" },
	{ 0x00F6, "BM_GETIMAGE", 0, "()()", "sig_", "", "" },
	{ 0x00F7, "BM_SETIMAGE", 0, "()()", "sig_", "", "" },
	{ 0x00F8, NULL, 0, "", "", "" },
	{ 0x00F9, NULL, 0, "", "", "" },
	{ 0x00FA, NULL, 0, "", "", "" },
	{ 0x00FB, NULL, 0, "", "", "" },
	{ 0x00FC, NULL, 0, "", "", "" },
	{ 0x00FD, NULL, 0, "", "", "" },
	{ 0x00FE, "WM_INPUT_DEVICE_CHANGE", 0, "()()", "sig_", "", "" },
	{ 0x00FF, "WM_INPUT", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0100, "WM_KEYDOWN", 0, "()()", "sig_", "", "" },
	{ 0x0101, "WM_KEYUP", 0, "()()", "sig_", "", "" },
	{ 0x0102, "WM_CHAR", 0, "()()", "sig_", "", "" },
	{ 0x0103, "WM_DEADCHAR", 0, "()()", "sig_", "", "" },
	{ 0x0104, "WM_SYSKEYDOWN", 0, "()()", "sig_", "", "" },
	{ 0x0105, "WM_SYSKEYUP", 0, "()()", "sig_", "", "" },
	{ 0x0106, "WM_SYSCHAR", MT_KEYBOARDACCEL, "()()", "sig_", "", "" },
	{ 0x0107, "WM_SYSDEADCHAR", 0, "()()", "sig_", "", "" },
	{ 0x0108, NULL, 0, "", "", "" },
	{ 0x0109, "WM_UNICHAR", 0, "()()", "sig_", "", "" },
	{ 0x010A, "WM_CONVERTREQUEST", 0, "()()", "sig_", "", "" },
	{ 0x010B, "WM_CONVERTRESULT", 0, "()()", "sig_", "", "" },
	{ 0x010C, "WM_INTERIM", 0, "()()", "sig_", "", "" },
	{ 0x010D, "WM_IME_STARTCOMPOSITION", 0, "()()", "sig_", "", "" },
	{ 0x010E, "WM_IME_ENDCOMPOSITION", 0, "()()", "sig_", "", "" },
	{ 0x010F, "WM_IME_COMPOSITION", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0110, "WM_INITDIALOG", 0, "()()", "sig_", "", "" },
	{ 0x0111, "WM_COMMAND", MT_KEYBOARDACCEL, "()()", "sig_", "", "" },
	{ 0x0112, "WM_SYSCOMMAND", MT_KEYBOARDACCEL, "0(UINT=uCmdType)(WORD=xPos,WORD=yPos)", "sig_vul", "void OnSysCommand(UINT nID, LPARAM lParam);", "winui.chm::/devdoc/live/pdui/keybacel_19t0.htm" },
	{ 0x0113, "WM_TIMER", 0, "()()", "sig_", "", "" },
	{ 0x0114, "WM_HSCROLL", 0, "()()", "sig_", "", "" },
	{ 0x0115, "WM_VSCROLL", 0, "()()", "sig_", "", "" },
	{ 0x0116, "WM_INITMENU", MT_KEYBOARDACCEL, "()()", "sig_", "", "" },
	{ 0x0117, "WM_INITMENUPOPUP", MT_KEYBOARDACCEL, "()()", "sig_", "", "" },
	{ 0x0118, "WM_SYSTIMER", 0, "()()", "sig_", "", "" },
	{ 0x0119, NULL, 0, "", "", "" },
	{ 0x011A, NULL, 0, "", "", "" },
	{ 0x011B, NULL, 0, "", "", "" },
	{ 0x011C, NULL, 0, "", "", "" },
	{ 0x011D, NULL, 0, "", "", "" },
	{ 0x011E, NULL, 0, "", "", "" },
	{ 0x011F, "WM_MENUSELECT", MT_KEYBOARDACCEL, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0120, "WM_MENUCHAR", MT_KEYBOARDACCEL, "(TCHAR=chUser,UINT=fuFlags)(HMENU=hmenu)", "sig_", "", "winui.chm::/devdoc/live/pdui/keybacel_4aeq.htm" },
	{ 0x0121, "WM_ENTERIDLE", 0, "()()", "sig_", "", "" },
	{ 0x0122, "WM_MENURBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x0123, "WM_MENUDRAG", 0, "()()", "sig_", "", "" },
	{ 0x0124, "WM_MENUGETOBJECT", 0, "()()", "sig_", "", "" },
	{ 0x0125, "WM_UNINITMENUPOPUP", 0, "()()", "sig_", "", "" },
	{ 0x0126, "WM_MENUCOMMAND", 0, "()()", "sig_", "", "" },
	{ 0x0127, "WM_CHANGEUISTATE", 0, "()()", "sig_", "", "" },
	{ 0x0128, "WM_UPDATEUISTATE", 0, "()()", "sig_", "", "" },
	{ 0x0129, "WM_QUERYUISTATE", 0, "()()", "sig_", "", "" },
	{ 0x012A, NULL, 0, "", "", "" },
	{ 0x012B, NULL, 0, "", "", "" },
	{ 0x012C, NULL, 0, "", "", "" },
	{ 0x012D, NULL, 0, "", "", "" },
	{ 0x012E, NULL, 0, "", "", "" },
	{ 0x012F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0130, NULL, 0, "", "", "" },
	{ 0x0131, "WM_LBTRACKPOINT", 0, "()()", "sig_", "", "" },
	{ 0x0132, "WM_CTLCOLORMSGBOX", 0, "()()", "sig_", "", "" },
	{ 0x0133, "WM_CTLCOLOREDIT", 0, "()()", "sig_", "", "" },
	{ 0x0134, "WM_CTLCOLORLISTBOX", 0, "()()", "sig_", "", "" },
	{ 0x0135, "WM_CTLCOLORBTN", 0, "()()", "sig_", "", "" },
	{ 0x0136, "WM_CTLCOLORDLG", 0, "()()", "sig_", "", "" },
	{ 0x0137, "WM_CTLCOLORSCROLLBAR", 0, "()()", "sig_", "", "" },
	{ 0x0138, "WM_CTLCOLORSTATIC", 0, "()()", "sig_", "", "" },
	{ 0x0139, NULL, 0, "", "", "" },
	{ 0x013A, NULL, 0, "", "", "" },
	{ 0x013B, NULL, 0, "", "", "" },
	{ 0x013C, NULL, 0, "", "", "" },
	{ 0x013D, NULL, 0, "", "", "" },
	{ 0x013E, NULL, 0, "", "", "" },
	{ 0x013F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0140, "CB_GETEDITSEL", 0, "()()", "sig_", "", "" },
	{ 0x0141, "CB_LIMITTEXT", 0, "()()", "sig_", "", "" },
	{ 0x0142, "CB_SETEDITSEL", 0, "()()", "sig_", "", "" },
	{ 0x0143, "CB_ADDSTRING", 0, "()()", "sig_", "", "" },
	{ 0x0144, "CB_DELETESTRING", 0, "()()", "sig_", "", "" },
	{ 0x0145, "CB_DIR", 0, "()()", "sig_", "", "" },
	{ 0x0146, "CB_GETCOUNT", 0, "()()", "sig_", "", "" },
	{ 0x0147, "CB_GETCURSEL", 0, "()()", "sig_", "", "" },
	{ 0x0148, "CB_GETLBTEXT", 0, "()()", "sig_", "", "" },
	{ 0x0149, "CB_GETLBTEXTLEN", 0, "()()", "sig_", "", "" },
	{ 0x014A, "CB_INSERTSTRING", 0, "()()", "sig_", "", "" },
	{ 0x014B, "CB_RESETCONTENT", 0, "()()", "sig_", "", "" },
	{ 0x014C, "CB_FINDSTRING", 0, "()()", "sig_", "", "" },
	{ 0x014D, "CB_SELECTSTRING", 0, "()()", "sig_", "", "" },
	{ 0x014E, "CB_SETCURSEL", 0, "()()", "sig_", "", "" },
	{ 0x014F, "CB_SHOWDROPDOWN", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0150, "CB_GETITEMDATA", 0, "()()", "sig_", "", "" },
	{ 0x0151, "CB_SETITEMDATA", 0, "()()", "sig_", "", "" },
	{ 0x0152, "CB_GETDROPPEDCONTROLRECT", 0, "()()", "sig_", "", "" },
	{ 0x0153, "CB_SETITEMHEIGHT", 0, "()()", "sig_", "", "" },
	{ 0x0154, "CB_GETITEMHEIGHT", 0, "()()", "sig_", "", "" },
	{ 0x0155, "CB_SETEXTENDEDUI", 0, "()()", "sig_", "", "" },
	{ 0x0156, "CB_GETEXTENDEDUI", 0, "()()", "sig_", "", "" },
	{ 0x0157, "CB_GETDROPPEDSTATE", 0, "()()", "sig_", "", "" },
	{ 0x0158, "CB_FINDSTRINGEXACT", 0, "()()", "sig_", "", "" },
	{ 0x0159, "CB_SETLOCALE", 0, "()()", "sig_", "", "" },
	{ 0x015A, "CB_GETLOCALE", 0, "()()", "sig_", "", "" },
	{ 0x015B, "CB_GETTOPINDEX", 0, "()()", "sig_", "", "" },
	{ 0x015C, "CB_SETTOPINDEX", 0, "()()", "sig_", "", "" },
	{ 0x015D, "CB_GETHORIZONTALEXTENT", 0, "()()", "sig_", "", "" },
	{ 0x015E, "CB_SETHORIZONTALEXTENT", 0, "()()", "sig_", "", "" },
	{ 0x015F, "CB_GETDROPPEDWIDTH", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0160, "CB_SETDROPPEDWIDTH", 0, "()()", "sig_", "", "" },
	{ 0x0161, "CB_INITSTORAGE", 0, "()()", "sig_", "", "" },
	{ 0x0162, NULL, 0, "", "", "" },
	{ 0x0163, NULL, 0, "", "", "" },
	{ 0x0164, NULL, 0, "", "", "" },
	{ 0x0165, NULL, 0, "", "", "" },
	{ 0x0166, NULL, 0, "", "", "" },
	{ 0x0167, NULL, 0, "", "", "" },
	{ 0x0168, NULL, 0, "", "", "" },
	{ 0x0169, NULL, 0, "", "", "" },
	{ 0x016A, NULL, 0, "", "", "" },
	{ 0x016B, NULL, 0, "", "", "" },
	{ 0x016C, NULL, 0, "", "", "" },
	{ 0x016D, NULL, 0, "", "", "" },
	{ 0x016E, NULL, 0, "", "", "" },
	{ 0x016F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0170, "STM_SETICON", 0, "()()", "sig_", "", "" },
	{ 0x0171, "STM_GETICON", 0, "()()", "sig_", "", "" },
	{ 0x0172, "STM_SETIMAGE", 0, "()()", "sig_", "", "" },
	{ 0x0173, "STM_GETIMAGE", 0, "()()", "sig_", "", "" },
	{ 0x0174, NULL, 0, "", "", "" },
	{ 0x0175, NULL, 0, "", "", "" },
	{ 0x0176, NULL, 0, "", "", "" },
	{ 0x0177, NULL, 0, "", "", "" },
	{ 0x0178, NULL, 0, "", "", "" },
	{ 0x0179, NULL, 0, "", "", "" },
	{ 0x017A, NULL, 0, "", "", "" },
	{ 0x017B, NULL, 0, "", "", "" },
	{ 0x017C, NULL, 0, "", "", "" },
	{ 0x017D, NULL, 0, "", "", "" },
	{ 0x017E, NULL, 0, "", "", "" },
	{ 0x017F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0180, "LB_ADDSTRING", 0, "()()", "sig_", "", "" },
	{ 0x0181, "LB_INSERTSTRING", 0, "()()", "sig_", "", "" },
	{ 0x0182, "LB_DELETESTRING", 0, "()()", "sig_", "", "" },
	{ 0x0183, "LB_SELITEMRANGEEX", 0, "()()", "sig_", "", "" },
	{ 0x0184, "LB_RESETCONTENT", 0, "()()", "sig_", "", "" },
	{ 0x0185, "LB_SETSEL", 0, "()()", "sig_", "", "" },
	{ 0x0186, "LB_SETCURSEL", 0, "()()", "sig_", "", "" },
	{ 0x0187, "LB_GETSEL", 0, "()()", "sig_", "", "" },
	{ 0x0188, "LB_GETCURSEL", 0, "()()", "sig_", "", "" },
	{ 0x0189, "LB_GETTEXT", 0, "()()", "sig_", "", "" },
	{ 0x018A, "LB_GETTEXTLEN", 0, "()()", "sig_", "", "" },
	{ 0x018B, "LB_GETCOUNT", 0, "()()", "sig_", "", "" },
	{ 0x018C, "LB_SELECTSTRING", 0, "()()", "sig_", "", "" },
	{ 0x018D, "LB_DIR", 0, "()()", "sig_", "", "" },
	{ 0x018E, "LB_GETTOPINDEX", 0, "()()", "sig_", "", "" },
	{ 0x018F, "LB_FINDSTRING", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0190, "LB_GETSELCOUNT", 0, "()()", "sig_", "", "" },
	{ 0x0191, "LB_GETSELITEMS", 0, "()()", "sig_", "", "" },
	{ 0x0192, "LB_SETTABSTOPS", 0, "()()", "sig_", "", "" },
	{ 0x0193, "LB_GETHORIZONTALEXTENT", 0, "()()", "sig_", "", "" },
	{ 0x0194, "LB_SETHORIZONTALEXTENT", 0, "()()", "sig_", "", "" },
	{ 0x0195, "LB_SETCOLUMNWIDTH", 0, "()()", "sig_", "", "" },
	{ 0x0196, "LB_ADDFILE", 0, "()()", "sig_", "", "" },
	{ 0x0197, "LB_SETTOPINDEX", 0, "()()", "sig_", "", "" },
	{ 0x0198, "LB_GETITEMRECT", 0, "()()", "sig_", "", "" },
	{ 0x0199, "LB_GETITEMDATA", 0, "()()", "sig_", "", "" },
	{ 0x019A, "LB_SETITEMDATA", 0, "()()", "sig_", "", "" },
	{ 0x019B, "LB_SELITEMRANGE", 0, "()()", "sig_", "", "" },
	{ 0x019C, "LB_SETANCHORINDEX", 0, "()()", "sig_", "", "" },
	{ 0x019D, "LB_GETANCHORINDEX", 0, "()()", "sig_", "", "" },
	{ 0x019E, "LB_SETCARETINDEX", 0, "()()", "sig_", "", "" },
	{ 0x019F, "LB_GETCARETINDEX", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x01A0, "LB_SETITEMHEIGHT", 0, "()()", "sig_", "", "" },
	{ 0x01A1, "LB_GETITEMHEIGHT", 0, "()()", "sig_", "", "" },
	{ 0x01A2, "LB_FINDSTRINGEXACT", 0, "()()", "sig_", "", "" },
	{ 0x01A3, "LB_CARETON", 0, "()()", "sig_", "", "" },
	{ 0x01A4, "LB_CARETOFF", 0, "()()", "sig_", "", "" },
	{ 0x01A5, "LB_SETLOCALE", 0, "()()", "sig_", "", "" },
	{ 0x01A6, "LB_GETLOCALE", 0, "()()", "sig_", "", "" },
	{ 0x01A7, "LB_SETCOUNT", 0, "()()", "sig_", "", "" },
	{ 0x01A8, "LB_INITSTORAGE", 0, "()()", "sig_", "", "" },
	{ 0x01A9, "LB_ITEMFROMPOINT", 0, "()()", "sig_", "", "" },
	{ 0x01AA, NULL, 0, "", "", "" },
	{ 0x01AB, NULL, 0, "", "", "" },
	{ 0x01AC, NULL, 0, "", "", "" },
	{ 0x01AD, NULL, 0, "", "", "" },
	{ 0x01AE, NULL, 0, "", "", "" },
	{ 0x01AF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x01B0, NULL, 0, "", "", "" },
	{ 0x01B1, NULL, 0, "", "", "" },
	{ 0x01B2, "LB_GETLISTBOXINFO", 0, "()()", "sig_", "", "" },
	{ 0x01B3, NULL, 0, "", "", "" },
	{ 0x01B4, NULL, 0, "", "", "" },
	{ 0x01B5, NULL, 0, "", "", "" },
	{ 0x01B6, NULL, 0, "", "", "" },
	{ 0x01B7, NULL, 0, "", "", "" },
	{ 0x01B8, NULL, 0, "", "", "" },
	{ 0x01B9, NULL, 0, "", "", "" },
	{ 0x01BA, NULL, 0, "", "", "" },
	{ 0x01BB, NULL, 0, "", "", "" },
	{ 0x01BC, NULL, 0, "", "", "" },
	{ 0x01BD, NULL, 0, "", "", "" },
	{ 0x01BE, NULL, 0, "", "", "" },
	{ 0x01BF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x01C0, NULL, 0, "", "", "" },
	{ 0x01C1, NULL, 0, "", "", "" },
	{ 0x01C2, NULL, 0, "", "", "" },
	{ 0x01C3, NULL, 0, "", "", "" },
	{ 0x01C4, NULL, 0, "", "", "" },
	{ 0x01C5, NULL, 0, "", "", "" },
	{ 0x01C6, NULL, 0, "", "", "" },
	{ 0x01C7, NULL, 0, "", "", "" },
	{ 0x01C8, NULL, 0, "", "", "" },
	{ 0x01C9, NULL, 0, "", "", "" },
	{ 0x01CA, NULL, 0, "", "", "" },
	{ 0x01CB, NULL, 0, "", "", "" },
	{ 0x01CC, NULL, 0, "", "", "" },
	{ 0x01CD, NULL, 0, "", "", "" },
	{ 0x01CE, NULL, 0, "", "", "" },
	{ 0x01CF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x01D0, NULL, 0, "", "", "" },
	{ 0x01D1, NULL, 0, "", "", "" },
	{ 0x01D2, NULL, 0, "", "", "" },
	{ 0x01D3, NULL, 0, "", "", "" },
	{ 0x01D4, NULL, 0, "", "", "" },
	{ 0x01D5, NULL, 0, "", "", "" },
	{ 0x01D6, NULL, 0, "", "", "" },
	{ 0x01D7, NULL, 0, "", "", "" },
	{ 0x01D8, NULL, 0, "", "", "" },
	{ 0x01D9, NULL, 0, "", "", "" },
	{ 0x01DA, NULL, 0, "", "", "" },
	{ 0x01DB, NULL, 0, "", "", "" },
	{ 0x01DC, NULL, 0, "", "", "" },
	{ 0x01DD, NULL, 0, "", "", "" },
	{ 0x01DE, NULL, 0, "", "", "" },
	{ 0x01DF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x01E0, NULL, 0, "", "", "" },
	{ 0x01E1, "MN_GETHMENU", 0, "()()", "sig_", "", "" },
	{ 0x01E2, NULL, 0, "", "", "" },
	{ 0x01E3, NULL, 0, "", "", "" },
	{ 0x01E4, NULL, 0, "", "", "" },
	{ 0x01E5, NULL, 0, "", "", "" },
	{ 0x01E6, NULL, 0, "", "", "" },
	{ 0x01E7, NULL, 0, "", "", "" },
	{ 0x01E8, NULL, 0, "", "", "" },
	{ 0x01E9, NULL, 0, "", "", "" },
	{ 0x01EA, NULL, 0, "", "", "" },
	{ 0x01EB, NULL, 0, "", "", "" },
	{ 0x01EC, NULL, 0, "", "", "" },
	{ 0x01ED, NULL, 0, "", "", "" },
	{ 0x01EE, NULL, 0, "", "", "" },
	{ 0x01EF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x01F0, NULL, 0, "", "", "" },
	{ 0x01F1, NULL, 0, "", "", "" },
	{ 0x01F2, NULL, 0, "", "", "" },
	{ 0x01F3, NULL, 0, "", "", "" },
	{ 0x01F4, NULL, 0, "", "", "" },
	{ 0x01F5, NULL, 0, "", "", "" },
	{ 0x01F6, NULL, 0, "", "", "" },
	{ 0x01F7, NULL, 0, "", "", "" },
	{ 0x01F8, NULL, 0, "", "", "" },
	{ 0x01F9, NULL, 0, "", "", "" },
	{ 0x01FA, NULL, 0, "", "", "" },
	{ 0x01FB, NULL, 0, "", "", "" },
	{ 0x01FC, NULL, 0, "", "", "" },
	{ 0x01FD, NULL, 0, "", "", "" },
	{ 0x01FE, NULL, 0, "", "", "" },
	{ 0x01FF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0200, "WM_MOUSEMOVE", 0, "()()", "sig_", "", "" },
	{ 0x0201, "WM_LBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x0202, "WM_LBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x0203, "WM_LBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x0204, "WM_RBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x0205, "WM_RBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x0206, "WM_RBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x0207, "WM_MBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x0208, "WM_MBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x0209, "WM_MBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x020A, "WM_MOUSEWHEEL", 0, "()()", "sig_", "", "" },
	{ 0x020B, "WM_XBUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x020C, "WM_XBUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x020D, "WM_XBUTTONDBLCLK", 0, "()()", "sig_", "", "" },
	{ 0x020E, "WM_MOUSEHWHEEL", 0, "()()", "sig_", "", "" },
	{ 0x020F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0210, "WM_PARENTNOTIFY", 0, "()()", "sig_", "", "" },
	{ 0x0211, "WM_ENTERMENULOOP", 0, "()()", "sig_", "", "" },
	{ 0x0212, "WM_EXITMENULOOP", 0, "()()", "sig_", "", "" },
	{ 0x0213, "WM_NEXTMENU", 0, "()()", "sig_", "", "" },
	{ 0x0214, "WM_SIZING", 0, "()()", "sig_", "", "" },
	{ 0x0215, "WM_CAPTURECHANGED", 0, "()()", "sig_", "", "" },
	{ 0x0216, "WM_MOVING", 0, "()()", "sig_", "", "" },
	{ 0x0217, "WM_POWERBROADCAST", 0, "()()", "sig_", "", "" },
	{ 0x0218, "WM_DEVICECHANGE", 0, "()()", "sig_", "", "" },
	{ 0x0219, NULL, 0, "", "", "" },
	{ 0x021A, NULL, 0, "", "", "" },
	{ 0x021B, NULL, 0, "", "", "" },
	{ 0x021C, NULL, 0, "", "", "" },
	{ 0x021D, NULL, 0, "", "", "" },
	{ 0x021E, NULL, 0, "", "", "" },
	{ 0x021F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0220, "WM_MDICREATE", 0, "()()", "sig_", "", "" },
	{ 0x0221, "WM_MDIDESTROY", 0, "()()", "sig_", "", "" },
	{ 0x0222, "WM_MDIACTIVATE", 0, "()()", "sig_", "", "" },
	{ 0x0223, "WM_MDIRESTORE", 0, "()()", "sig_", "", "" },
	{ 0x0224, "WM_MDINEXT", 0, "()()", "sig_", "", "" },
	{ 0x0225, "WM_MDIMAXIMIZE", 0, "()()", "sig_", "", "" },
	{ 0x0226, "WM_MDITILE", 0, "()()", "sig_", "", "" },
	{ 0x0227, "WM_MDICASCADE", 0, "()()", "sig_", "", "" },
	{ 0x0228, "WM_MDIICONARRANGE", 0, "()()", "sig_", "", "" },
	{ 0x0229, "WM_MDIGETACTIVE", 0, "()()", "sig_", "", "" },
	{ 0x022A, "WM_DROPOBJECT", 0, "()()", "sig_", "", "" },
	{ 0x022B, "WM_QUERYDROPOBJECT", 0, "()()", "sig_", "", "" },
	{ 0x022C, "WM_BEGINDRAG", 0, "()()", "sig_", "", "" },
	{ 0x022D, "WM_DRAGLOOP", 0, "()()", "sig_", "", "" },
	{ 0x022E, "WM_DRAGSELECT", 0, "()()", "sig_", "", "" },
	{ 0x022F, "WM_DRAGMOVE", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0230, "WM_MDISETMENU", 0, "()()", "sig_", "", "" },
	{ 0x0231, "WM_ENTERSIZEMOVE", 0, "()()", "sig_", "", "" },
	{ 0x0232, "WM_EXITSIZEMOVE", 0, "()()", "sig_", "", "" },
	{ 0x0233, "WM_DROPFILES", 0, "()()", "sig_", "", "" },
	{ 0x0234, "WM_MDIREFRESHMENU", 0, "()()", "sig_", "", "" },
	{ 0x0235, NULL, 0, "", "", "" },
	{ 0x0236, NULL, 0, "", "", "" },
	{ 0x0237, NULL, 0, "", "", "" },
	{ 0x0238, NULL, 0, "", "", "" },
	{ 0x0239, NULL, 0, "", "", "" },
	{ 0x023A, NULL, 0, "", "", "" },
	{ 0x023B, NULL, 0, "", "", "" },
	{ 0x023C, NULL, 0, "", "", "" },
	{ 0x023D, NULL, 0, "", "", "" },
	{ 0x023E, NULL, 0, "", "", "" },
	{ 0x023F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0240, NULL, 0, "", "", "" },
	{ 0x0241, NULL, 0, "", "", "" },
	{ 0x0242, NULL, 0, "", "", "" },
	{ 0x0243, NULL, 0, "", "", "" },
	{ 0x0244, NULL, 0, "", "", "" },
	{ 0x0245, NULL, 0, "", "", "" },
	{ 0x0246, NULL, 0, "", "", "" },
	{ 0x0247, NULL, 0, "", "", "" },
	{ 0x0248, NULL, 0, "", "", "" },
	{ 0x0249, NULL, 0, "", "", "" },
	{ 0x024A, NULL, 0, "", "", "" },
	{ 0x024B, NULL, 0, "", "", "" },
	{ 0x024C, NULL, 0, "", "", "" },
	{ 0x024D, NULL, 0, "", "", "" },
	{ 0x024E, NULL, 0, "", "", "" },
	{ 0x024F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0250, NULL, 0, "", "", "" },
	{ 0x0251, NULL, 0, "", "", "" },
	{ 0x0252, NULL, 0, "", "", "" },
	{ 0x0253, NULL, 0, "", "", "" },
	{ 0x0254, NULL, 0, "", "", "" },
	{ 0x0255, NULL, 0, "", "", "" },
	{ 0x0256, NULL, 0, "", "", "" },
	{ 0x0257, NULL, 0, "", "", "" },
	{ 0x0258, NULL, 0, "", "", "" },
	{ 0x0259, NULL, 0, "", "", "" },
	{ 0x025A, NULL, 0, "", "", "" },
	{ 0x025B, NULL, 0, "", "", "" },
	{ 0x025C, NULL, 0, "", "", "" },
	{ 0x025D, NULL, 0, "", "", "" },
	{ 0x025E, NULL, 0, "", "", "" },
	{ 0x025F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0260, NULL, 0, "", "", "" },
	{ 0x0261, NULL, 0, "", "", "" },
	{ 0x0262, NULL, 0, "", "", "" },
	{ 0x0263, NULL, 0, "", "", "" },
	{ 0x0264, NULL, 0, "", "", "" },
	{ 0x0265, NULL, 0, "", "", "" },
	{ 0x0266, NULL, 0, "", "", "" },
	{ 0x0267, NULL, 0, "", "", "" },
	{ 0x0268, NULL, 0, "", "", "" },
	{ 0x0269, NULL, 0, "", "", "" },
	{ 0x026A, NULL, 0, "", "", "" },
	{ 0x026B, NULL, 0, "", "", "" },
	{ 0x026C, NULL, 0, "", "", "" },
	{ 0x026D, NULL, 0, "", "", "" },
	{ 0x026E, NULL, 0, "", "", "" },
	{ 0x026F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0270, NULL, 0, "", "", "" },
	{ 0x0271, NULL, 0, "", "", "" },
	{ 0x0272, NULL, 0, "", "", "" },
	{ 0x0273, NULL, 0, "", "", "" },
	{ 0x0274, NULL, 0, "", "", "" },
	{ 0x0275, NULL, 0, "", "", "" },
	{ 0x0276, NULL, 0, "", "", "" },
	{ 0x0277, NULL, 0, "", "", "" },
	{ 0x0278, NULL, 0, "", "", "" },
	{ 0x0279, NULL, 0, "", "", "" },
	{ 0x027A, NULL, 0, "", "", "" },
	{ 0x027B, NULL, 0, "", "", "" },
	{ 0x027C, NULL, 0, "", "", "" },
	{ 0x027D, NULL, 0, "", "", "" },
	{ 0x027E, NULL, 0, "", "", "" },
	{ 0x027F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0280, NULL, 0, "", "", "" },
	{ 0x0281, "WM_IME_SETCONTEXT", 0, "()()", "sig_", "", "" },
	{ 0x0282, "WM_IME_NOTIFY", 0, "()()", "sig_", "", "" },
	{ 0x0283, "WM_IME_CONTROL", 0, "()()", "sig_", "", "" },
	{ 0x0284, "WM_IME_COMPOSITIONFULL", 0, "()()", "sig_", "", "" },
	{ 0x0285, "WM_IME_SELECT", 0, "()()", "sig_", "", "" },
	{ 0x0286, "WM_IME_CHAR", 0, "()()", "sig_", "", "" },
	{ 0x0287, NULL, 0, "", "", "" },
	{ 0x0288, "WM_IME_REQUEST", 0, "()()", "sig_", "", "" },
	{ 0x0289, NULL, 0, "", "", "" },
	{ 0x028A, NULL, 0, "", "", "" },
	{ 0x028B, NULL, 0, "", "", "" },
	{ 0x028C, NULL, 0, "", "", "" },
	{ 0x028D, NULL, 0, "", "", "" },
	{ 0x028E, NULL, 0, "", "", "" },
	{ 0x028F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0290, "WM_IME_KEYDOWN", 0, "()()", "sig_", "", "" },
	{ 0x0291, "WM_IME_KEYUP", 0, "()()", "sig_", "", "" },
	{ 0x0292, NULL, 0, "", "", "" },
	{ 0x0293, NULL, 0, "", "", "" },
	{ 0x0294, NULL, 0, "", "", "" },
	{ 0x0295, NULL, 0, "", "", "" },
	{ 0x0296, NULL, 0, "", "", "" },
	{ 0x0297, NULL, 0, "", "", "" },
	{ 0x0298, NULL, 0, "", "", "" },
	{ 0x0299, NULL, 0, "", "", "" },
	{ 0x029A, NULL, 0, "", "", "" },
	{ 0x029B, NULL, 0, "", "", "" },
	{ 0x029C, NULL, 0, "", "", "" },
	{ 0x029D, NULL, 0, "", "", "" },
	{ 0x029E, NULL, 0, "", "", "" },
	{ 0x029F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x02A0, "WM_NCMOUSEHOVER", 0, "()()", "sig_", "", "" },
	{ 0x02A1, "WM_MOUSEHOVER", 0, "()()", "sig_", "", "" },
	{ 0x02A2, "WM_NCMOUSELEAVE", 0, "()()", "sig_", "", "" },
	{ 0x02A3, "WM_MOUSELEAVE", 0, "()()", "sig_", "", "" },
	{ 0x02A4, NULL, 0, "", "", "" },
	{ 0x02A5, NULL, 0, "", "", "" },
	{ 0x02A6, NULL, 0, "", "", "" },
	{ 0x02A7, NULL, 0, "", "", "" },
	{ 0x02A8, NULL, 0, "", "", "" },
	{ 0x02A9, NULL, 0, "", "", "" },
	{ 0x02AA, NULL, 0, "", "", "" },
	{ 0x02AB, NULL, 0, "", "", "" },
	{ 0x02AC, NULL, 0, "", "", "" },
	{ 0x02AD, NULL, 0, "", "", "" },
	{ 0x02AE, NULL, 0, "", "", "" },
	{ 0x02AF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x02B0, NULL, 0, "", "", "" },
	{ 0x02B1, "WM_WTSSESSION_CHANGE", 0, "()()", "sig_", "", "" },
	{ 0x02B2, NULL, 0, "", "", "" },
	{ 0x02B3, NULL, 0, "", "", "" },
	{ 0x02B4, NULL, 0, "", "", "" },
	{ 0x02B5, NULL, 0, "", "", "" },
	{ 0x02B6, NULL, 0, "", "", "" },
	{ 0x02B7, NULL, 0, "", "", "" },
	{ 0x02B8, NULL, 0, "", "", "" },
	{ 0x02B9, NULL, 0, "", "", "" },
	{ 0x02BA, NULL, 0, "", "", "" },
	{ 0x02BB, NULL, 0, "", "", "" },
	{ 0x02BC, NULL, 0, "", "", "" },
	{ 0x02BD, NULL, 0, "", "", "" },
	{ 0x02BE, NULL, 0, "", "", "" },
	{ 0x02BF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x02C0, "WM_TABLET_FIRST", 0, "()()", "sig_", "", "" },
	{ 0x02C1, "WM_TABLET_FIRST+1", 0, "()()", "sig_", "", "" },
	{ 0x02C2, "WM_TABLET_FIRST+2", 0, "()()", "sig_", "", "" },
	{ 0x02C3, "WM_TABLET_FIRST+3", 0, "()()", "sig_", "", "" },
	{ 0x02C4, "WM_TABLET_FIRST+4", 0, "()()", "sig_", "", "" },
	{ 0x02C5, "WM_TABLET_FIRST+5", 0, "()()", "sig_", "", "" },
	{ 0x02C6, "WM_TABLET_FIRST+7", 0, "()()", "sig_", "", "" },
	{ 0x02C7, "WM_TABLET_FIRST+8", 0, "()()", "sig_", "", "" },
	{ 0x02C8, "WM_TABLET_FIRST+9", 0, "()()", "sig_", "", "" },
	{ 0x02C9, "WM_TABLET_FIRST+10", 0, "()()", "sig_", "", "" },
	{ 0x02CA, "WM_TABLET_FIRST+11", 0, "()()", "sig_", "", "" },
	{ 0x02CB, "WM_TABLET_FIRST+12", 0, "()()", "sig_", "", "" },
	{ 0x02CC, "WM_TABLET_FIRST+13", 0, "()()", "sig_", "", "" },
	{ 0x02CD, "WM_TABLET_FIRST+14", 0, "()()", "sig_", "", "" },
	{ 0x02CE, "WM_TABLET_FIRST+15", 0, "()()", "sig_", "", "" },
	{ 0x02CF, "WM_TABLET_FIRST+16", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x02D0, "WM_TABLET_FIRST+17", 0, "()()", "sig_", "", "" },
	{ 0x02D1, "WM_TABLET_FIRST+18", 0, "()()", "sig_", "", "" },
	{ 0x02D2, "WM_TABLET_FIRST+19", 0, "()()", "sig_", "", "" },
	{ 0x02D3, "WM_TABLET_FIRST+20", 0, "()()", "sig_", "", "" },
	{ 0x02D4, "WM_TABLET_FIRST+21", 0, "()()", "sig_", "", "" },
	{ 0x02D5, "WM_TABLET_FIRST+22", 0, "()()", "sig_", "", "" },
	{ 0x02D6, "WM_TABLET_FIRST+23", 0, "()()", "sig_", "", "" },
	{ 0x02D7, "WM_TABLET_FIRST+24", 0, "()()", "sig_", "", "" },
	{ 0x02D8, "WM_TABLET_FIRST+25", 0, "()()", "sig_", "", "" },
	{ 0x02D9, "WM_TABLET_FIRST+26", 0, "()()", "sig_", "", "" },
	{ 0x02DA, "WM_TABLET_FIRST+27", 0, "()()", "sig_", "", "" },
	{ 0x02DB, "WM_TABLET_FIRST+28", 0, "()()", "sig_", "", "" },
	{ 0x02DC, "WM_TABLET_FIRST+29", 0, "()()", "sig_", "", "" },
	{ 0x02DD, "WM_TABLET_FIRST+30", 0, "()()", "sig_", "", "" },
	{ 0x02DE, "WM_TABLET_FIRST+31", 0, "()()", "sig_", "", "" },
	{ 0x02DF, "WM_TABLET_LAST", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x02E0, NULL, 0, "", "", "" },
	{ 0x02E1, NULL, 0, "", "", "" },
	{ 0x02E2, NULL, 0, "", "", "" },
	{ 0x02E3, NULL, 0, "", "", "" },
	{ 0x02E4, NULL, 0, "", "", "" },
	{ 0x02E5, NULL, 0, "", "", "" },
	{ 0x02E6, NULL, 0, "", "", "" },
	{ 0x02E7, NULL, 0, "", "", "" },
	{ 0x02E8, NULL, 0, "", "", "" },
	{ 0x02E9, NULL, 0, "", "", "" },
	{ 0x02EA, NULL, 0, "", "", "" },
	{ 0x02EB, NULL, 0, "", "", "" },
	{ 0x02EC, NULL, 0, "", "", "" },
	{ 0x02ED, NULL, 0, "", "", "" },
	{ 0x02EE, NULL, 0, "", "", "" },
	{ 0x02EF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x02F0, NULL, 0, "", "", "" },
	{ 0x02F1, NULL, 0, "", "", "" },
	{ 0x02F2, NULL, 0, "", "", "" },
	{ 0x02F3, NULL, 0, "", "", "" },
	{ 0x02F4, NULL, 0, "", "", "" },
	{ 0x02F5, NULL, 0, "", "", "" },
	{ 0x02F6, NULL, 0, "", "", "" },
	{ 0x02F7, NULL, 0, "", "", "" },
	{ 0x02F8, NULL, 0, "", "", "" },
	{ 0x02F9, NULL, 0, "", "", "" },
	{ 0x02FA, NULL, 0, "", "", "" },
	{ 0x02FB, NULL, 0, "", "", "" },
	{ 0x02FC, NULL, 0, "", "", "" },
	{ 0x02FD, NULL, 0, "", "", "" },
	{ 0x02FE, NULL, 0, "", "", "" },
	{ 0x02FF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0300, "WM_CUT",				 MT_CLIPBOARD, "(0)(0)",										"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_57sk.htm" },
	{ 0x0301, "WM_COPY",			 MT_CLIPBOARD, "(0)(0)",										"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_3bp5.htm" },
	{ 0x0302, "WM_PASTE",			 MT_CLIPBOARD, "(0)(0)",										"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_946d.htm" },
	{ 0x0303, "WM_CLEAR",			 MT_CLIPBOARD, "(0)(0)",										"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_4y0i.htm" },
	{ 0x0304, "WM_UNDO",			 0,			   "BOOL(0)(0)",									"sig_", "", "winui.chm::/devdoc/live/pdui/editcon_4ctr.htm" },
	{ 0x0305, "WM_RENDERFORMAT",	 MT_CLIPBOARD, "0(UINT=uFormat)()",								"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_3lpw.htm" },
	{ 0x0306, "WM_RENDERALLFORMATS", MT_CLIPBOARD, "0()()",											"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_194j.htm" },
	{ 0x0307, "WM_DESTROYCLIPBOARD", MT_CLIPBOARD, "0()()",											"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_3ejo.htm" },
	{ 0x0308, "WM_DRAWCLIPBOARD",	 MT_CLIPBOARD, "()()",											"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_5690.htm" },
	{ 0x0309, "WM_PAINTCLIPBOARD",	 MT_CLIPBOARD, "0(HWND=hWndViewer)(HGLOBAL=hglbPs)",			"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_1p0k.htm" },
	{ 0x030A, "WM_VSCROLLCLIPBOARD", MT_CLIPBOARD, "0(HWND=hWndViewer)(int=nScrollCode,int=nPos)",	"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_1tus.htm" },
	{ 0x030B, "WM_SIZECLIPBOARD",	 MT_CLIPBOARD, "(HWND=hWndViewer)(HGLOBAL=hglbRc)",				"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_8c84.htm" },
	{ 0x030C, "WM_ASKCBFORMATNAME",  MT_CLIPBOARD, "0(DWORD=cchName)(LPTSTR=lpszFormatName)",		"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_3c11.htm" },
	{ 0x030D, "WM_CHANGECBCHAIN",	 MT_CLIPBOARD, "0(HWND=hWndRemove)(HWND=hWndNext)",				"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_34q6.htm" },
	{ 0x030E, "WM_HSCROLLCLIPBOARD", MT_CLIPBOARD, "0(HWND=hWndViewer)(int=nScrollCode,int=nPos)",	"sig_", "", "winbase.chm::/devdoc/live/pdwbase/clipbrd_4ndw.htm" },
	{ 0x030F, "WM_QUERYNEWPALETTE",  MT_COLOR,	   "BOOL()()",										"sig_", "", "GDI.chm::/devdoc/live/pdgrmm/colors_9w4l.htm" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0310, "WM_PALETTEISCHANGING", 0, "()()", "sig_", "", "" },
	{ 0x0311, "WM_PALETTECHANGED", 0, "()()", "sig_", "", "" },
	{ 0x0312, "WM_HOTKEY", 0, "()()", "sig_", "", "" },
	{ 0x0313, "WM_POPUPSYSTEMMENU", 0, "()()", "sig_", "", "" },
	{ 0x0314, NULL, 0, "", "", "" },
	{ 0x0315, NULL, 0, "", "", "" },
	{ 0x0316, NULL, 0, "", "", "" },
	{ 0x0317, "WM_PRINT", 0, "()()", "sig_", "", "" },
	{ 0x0318, "WM_PRINTCLIENT", 0, "()()", "sig_", "", "" },
	{ 0x0319, "WM_APPCOMMAND", 0, "()()", "sig_", "", "" },
	{ 0x031A, "WM_THEMECHANGED", 0, "()()", "sig_", "", "" },
	{ 0x031B, NULL, 0, "", "", "" },
	{ 0x031C, NULL, 0, "", "", "" },
	{ 0x031D, "WM_CLIPBOARDUPDATE", 0, "()()", "sig_", "", "" },
	{ 0x031E, "WM_DWMCOMPOSITIONCHANGED", 0, "()()", "sig_", "", "" },
	{ 0x031F, "WM_DWMNCRENDERINGCHANGED", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0320, "WM_DWMCOLORIZATIONCOLORCHANGED", 0, "()()", "sig_", "", "" },
	{ 0x0321, "WM_DWMWINDOWMAXIMIZEDCHANGE", 0, "()()", "sig_", "", "" },
	{ 0x0322, NULL, 0, "", "", "" },
	{ 0x0323, NULL, 0, "", "", "" },
	{ 0x0324, NULL, 0, "", "", "" },
	{ 0x0325, NULL, 0, "", "", "" },
	{ 0x0326, NULL, 0, "", "", "" },
	{ 0x0327, NULL, 0, "", "", "" },
	{ 0x0328, NULL, 0, "", "", "" },
	{ 0x0329, NULL, 0, "", "", "" },
	{ 0x032A, NULL, 0, "", "", "" },
	{ 0x032B, NULL, 0, "", "", "" },
	{ 0x032C, NULL, 0, "", "", "" },
	{ 0x032D, NULL, 0, "", "", "" },
	{ 0x032E, NULL, 0, "", "", "" },
	{ 0x032F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0330, NULL, 0, "", "", "" },
	{ 0x0331, NULL, 0, "", "", "" },
	{ 0x0332, NULL, 0, "", "", "" },
	{ 0x0333, NULL, 0, "", "", "" },
	{ 0x0334, NULL, 0, "", "", "" },
	{ 0x0335, NULL, 0, "", "", "" },
	{ 0x0336, NULL, 0, "", "", "" },
	{ 0x0337, NULL, 0, "", "", "" },
	{ 0x0338, NULL, 0, "", "", "" },
	{ 0x0339, NULL, 0, "", "", "" },
	{ 0x033A, NULL, 0, "", "", "" },
	{ 0x033B, NULL, 0, "", "", "" },
	{ 0x033C, NULL, 0, "", "", "" },
	{ 0x033D, NULL, 0, "", "", "" },
	{ 0x033E, NULL, 0, "", "", "" },
	{ 0x033F, "WM_GETTITLEBARINFOEX", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0340, NULL, 0, "", "", "" },
	{ 0x0341, NULL, 0, "", "", "" },
	{ 0x0342, NULL, 0, "", "", "" },
	{ 0x0343, NULL, 0, "", "", "" },
	{ 0x0344, NULL, 0, "", "", "" },
	{ 0x0345, NULL, 0, "", "", "" },
	{ 0x0346, NULL, 0, "", "", "" },
	{ 0x0347, NULL, 0, "", "", "" },
	{ 0x0348, NULL, 0, "", "", "" },
	{ 0x0349, NULL, 0, "", "", "" },
	{ 0x034A, NULL, 0, "", "", "" },
	{ 0x034B, NULL, 0, "", "", "" },
	{ 0x034C, NULL, 0, "", "", "" },
	{ 0x034D, NULL, 0, "", "", "" },
	{ 0x034E, NULL, 0, "", "", "" },
	{ 0x034F, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0350, NULL, 0, "", "", "" },
	{ 0x0351, NULL, 0, "", "", "" },
	{ 0x0352, NULL, 0, "", "", "" },
	{ 0x0353, NULL, 0, "", "", "" },
	{ 0x0354, NULL, 0, "", "", "" },
	{ 0x0355, NULL, 0, "", "", "" },
	{ 0x0356, NULL, 0, "", "", "" },
	{ 0x0357, NULL, 0, "", "", "" },
	{ 0x0358, "WM_HANDHELDFIRST", 0, "()()", "sig_", "", "" },
	{ 0x0359, "WM_HANDHELDFIRST+1", 0, "()()", "sig_", "", "" },
	{ 0x035A, "WM_HANDHELDFIRST+2", 0, "()()", "sig_", "", "" },
	{ 0x035B, "WM_HANDHELDFIRST+3", 0, "()()", "sig_", "", "" },
	{ 0x035C, "WM_HANDHELDFIRST+4", 0, "()()", "sig_", "", "" },
	{ 0x035D, "WM_HANDHELDFIRST+5", 0, "()()", "sig_", "", "" },
	{ 0x035E, "WM_HANDHELDFIRST+6", 0, "()()", "sig_", "", "" },
	{ 0x035F, "WM_HANDHELDLAST", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0360, "WM_QUERYAFXWNDPROC", 0, "()()", "sig_", "", "" },
	{ 0x0361, "WM_SIZEPARENT", 0, "()()", "sig_", "", "" },
	{ 0x0362, "WM_SETMESSAGESTRING", 0, "()()", "sig_", "", "" },
	{ 0x0363, "WM_IDLEUPDATECMDUI", 0, "()()", "sig_", "", "" },
	{ 0x0364, "WM_INITIALUPDATE", 0, "()()", "sig_", "", "" },
	{ 0x0365, "WM_COMMANDHELP", 0, "()()", "sig_", "", "" },
	{ 0x0366, "WM_HELPHITTEST", 0, "()()", "sig_", "", "" },
	{ 0x0367, "WM_EXITHELPMODE", 0, "()()", "sig_", "", "" },
	{ 0x0368, "WM_RECALCPARENT", 0, "()()", "sig_", "", "" },
	{ 0x0369, "WM_SIZECHILD", 0, "()()", "sig_", "", "" },
	{ 0x036A, "WM_KICKIDLE", 0, "()()", "sig_", "", "" },
	{ 0x036B, "WM_QUERYCENTERWND", 0, "()()", "sig_", "", "" },
	{ 0x036C, "WM_DISABLEMODAL", 0, "()()", "sig_", "", "" },
	{ 0x036D, "WM_FLOATSTATUS", 0, "()()", "sig_", "", "" },
	{ 0x036E, "WM_ACTIVATETOPLEVEL", 0, "()()", "sig_", "", "" },
	{ 0x036F, "WM_QUERY3DCONTROLS", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0370, NULL, 0, "", "", "" },
	{ 0x0371, NULL, 0, "", "", "" },
	{ 0x0372, NULL, 0, "", "", "" },
	{ 0x0373, "WM_SOCKET_NOTIFY", 0, "()()", "sig_", "", "" },
	{ 0x0374, "WM_SOCKET_DEAD", 0, "()()", "sig_", "", "" },
	{ 0x0375, "WM_POPMESSAGESTRING", 0, "()()", "sig_", "", "" },
	{ 0x0376, "WM_OCC_LOADFROMSTREAM", 0, "()()", "sig_", "", "" },
	{ 0x0377, "WM_OCC_LOADFROMSTORAGE", 0, "()()", "sig_", "", "" },
	{ 0x0378, "WM_OCC_INITNEW", 0, "()()", "sig_", "", "" },
	{ 0x0379, "WM_QUEUE_SENTINEL", 0, "()()", "sig_", "", "" },
	{ 0x037A, "WM_OCC_LOADFROMSTREAM_EX", 0, "()()", "sig_", "", "" },
	{ 0x037B, "WM_OCC_LOADFROMSTORAGE_EX", 0, "()()", "sig_", "", "" },
	{ 0x037C, NULL, 0, "", "", "" },
	{ 0x037D, NULL, 0, "", "", "" },
	{ 0x037E, NULL, 0, "", "", "" },
	{ 0x037F, "WM_AFXLAST", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0380, "WM_PENWINFIRST", 0, "()()", "sig_", "", "" },
	{ 0x0381, "WM_RCRESULT", 0, "()()", "sig_", "", "" },
	{ 0x0382, "WM_HOOKRCRESULT", 0, "()()", "sig_", "", "" },
	{ 0x0383, "WM_GLOBALRCCHANGE", 0, "()()", "sig_", "", "" },
	{ 0x0384, "WM_SKB", 0, "()()", "sig_", "", "" },
	{ 0x0385, "WM_HEDITCTL", 0, "()()", "sig_", "", "" },
	{ 0x0386, NULL, 0, "", "", "" },
	{ 0x0387, NULL, 0, "", "", "" },
	{ 0x0388, NULL, 0, "", "", "" },
	{ 0x0389, NULL, 0, "", "", "" },
	{ 0x038A, NULL, 0, "", "", "" },
	{ 0x038B, NULL, 0, "", "", "" },
	{ 0x038C, NULL, 0, "", "", "" },
	{ 0x038D, NULL, 0, "", "", "" },
	{ 0x038E, NULL, 0, "", "", "" },
	{ 0x038F, "WM_PENWINLAST", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0390, "WM_COALESCE_FIRST", 0, "()()", "sig_", "", "" },
	{ 0x0391, NULL, 0, "", "", "" },
	{ 0x0392, NULL, 0, "", "", "" },
	{ 0x0393, NULL, 0, "", "", "" },
	{ 0x0394, NULL, 0, "", "", "" },
	{ 0x0395, NULL, 0, "", "", "" },
	{ 0x0396, NULL, 0, "", "", "" },
	{ 0x0397, NULL, 0, "", "", "" },
	{ 0x0398, NULL, 0, "", "", "" },
	{ 0x0399, NULL, 0, "", "", "" },
	{ 0x039A, NULL, 0, "", "", "" },
	{ 0x039B, NULL, 0, "", "", "" },
	{ 0x039C, NULL, 0, "", "", "" },
	{ 0x039D, NULL, 0, "", "", "" },
	{ 0x039E, NULL, 0, "", "", "" },
	{ 0x039F, "WM_COALESCE_LAST", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x03A0, "MM_JOY1MOVE", 0, "()()", "sig_", "", "" },
	{ 0x03A1, "MM_JOY2MOVE", 0, "()()", "sig_", "", "" },
	{ 0x03A2, "MM_JOY1ZMOVE", 0, "()()", "sig_", "", "" },
	{ 0x03A3, "MM_JOY2ZMOVE", 0, "()()", "sig_", "", "" },
	{ 0x03A4, NULL, 0, "", "", "" },
	{ 0x03A5, NULL, 0, "", "", "" },
	{ 0x03A6, NULL, 0, "", "", "" },
	{ 0x03A7, NULL, 0, "", "", "" },
	{ 0x03A8, NULL, 0, "", "", "" },
	{ 0x03A9, NULL, 0, "", "", "" },
	{ 0x03AA, NULL, 0, "", "", "" },
	{ 0x03AB, NULL, 0, "", "", "" },
	{ 0x03AC, NULL, 0, "", "", "" },
	{ 0x03AD, NULL, 0, "", "", "" },
	{ 0x03AE, NULL, 0, "", "", "" },
	{ 0x03AF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x03B0, NULL, 0, "", "", "" },
	{ 0x03B1, NULL, 0, "", "", "" },
	{ 0x03B2, NULL, 0, "", "", "" },
	{ 0x03B3, NULL, 0, "", "", "" },
	{ 0x03B4, NULL, 0, "", "", "" },
	{ 0x03B5, "MM_JOY1BUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x03B6, "MM_JOY2BUTTONDOWN", 0, "()()", "sig_", "", "" },
	{ 0x03B7, "MM_JOY1BUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x03B8, "MM_JOY2BUTTONUP", 0, "()()", "sig_", "", "" },
	{ 0x03B9, "MM_MCINOTIFY", 0, "()()", "sig_", "", "" },
	{ 0x03BA, NULL, 0, "", "", "" },
	{ 0x03BB, "MM_WOM_OPEN", 0, "()()", "sig_", "", "" },
	{ 0x03BC, "MM_WOM_CLOSE", 0, "()()", "sig_", "", "" },
	{ 0x03BD, "MM_WOM_DONE", 0, "()()", "sig_", "", "" },
	{ 0x03BE, "MM_WIM_OPEN", 0, "()()", "sig_", "", "" },
	{ 0x03BF, "MM_WIM_CLOSE", 0, "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x03C0, "MM_WIM_DATA", 0, "()()", "sig_", "", "" },
	{ 0x03C1, "MM_MIM_OPEN", 0, "()()", "sig_", "", "" },
	{ 0x03C2, "MM_MIM_CLOSE", 0, "()()", "sig_", "", "" },
	{ 0x03C3, "MM_MIM_DATA", 0, "()()", "sig_", "", "" },
	{ 0x03C4, "MM_MIM_LONGDATA", 0, "()()", "sig_", "", "" },
	{ 0x03C5, "MM_MIM_ERROR", 0, "()()", "sig_", "", "" },
	{ 0x03C6, "MM_MIM_LONGERROR", 0, "()()", "sig_", "", "" },
	{ 0x03C7, "MM_MOM_OPEN", 0, "()()", "sig_", "", "" },
	{ 0x03C8, "MM_MOM_CLOSE", 0, "()()", "sig_", "", "" },
	{ 0x03C9, "MM_MOM_DONE", 0, "()()", "sig_", "", "" },
	{ 0x03CA, NULL, 0, "", "", "" },
	{ 0x03CB, NULL, 0, "", "", "" },
	{ 0x03CC, NULL, 0, "", "", "" },
	{ 0x03CD, NULL, 0, "", "", "" },
	{ 0x03CE, NULL, 0, "", "", "" },
	{ 0x03CF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x03D0, NULL, 0, "", "", "" },
	{ 0x03D1, NULL, 0, "", "", "" },
	{ 0x03D2, NULL, 0, "", "", "" },
	{ 0x03D3, NULL, 0, "", "", "" },
	{ 0x03D4, NULL, 0, "", "", "" },
	{ 0x03D5, NULL, 0, "", "", "" },
	{ 0x03D6, NULL, 0, "", "", "" },
	{ 0x03D7, NULL, 0, "", "", "" },
	{ 0x03D8, NULL, 0, "", "", "" },
	{ 0x03D9, NULL, 0, "", "", "" },
	{ 0x03DA, NULL, 0, "", "", "" },
	{ 0x03DB, NULL, 0, "", "", "" },
	{ 0x03DC, NULL, 0, "", "", "" },
	{ 0x03DD, NULL, 0, "", "", "" },
	{ 0x03DE, NULL, 0, "", "", "" },
	{ 0x03DF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x03E0, "WM_DDE_INITIATE",	MT_DDE, "(HWND)(ATOM=aApp,ATOM=aTopic)", "sig_", "", "" },
	{ 0x03E1, "WM_DDE_TERMINATE",	MT_DDE, "()()", "sig_", "", "" },
	{ 0x03E2, "WM_DDE_ADVISE",		MT_DDE, "()()", "sig_", "", "" },
	{ 0x03E3, "WM_DDE_UNADVISE",	MT_DDE, "(HWND)(=cfFormat,ATOM=aItem)", "sig_", "", "" },
	{ 0x03E4, "WM_DDE_ACK",			MT_DDE, "(HWND)()", "sig_", "", "" },
	{ 0x03E5, "WM_DDE_DATA",		MT_DDE, "()()", "sig_", "", "" },
	{ 0x03E6, "WM_DDE_REQUEST",		MT_DDE, "(HWND)()", "sig_", "", "" },
	{ 0x03E7, "WM_DDE_POKE",		MT_DDE, "(HWND)(HANDLE=hData,ATOM=aItem)", "sig_", "", "" },
	{ 0x03E8, "WM_DDE_EXECUTE",		MT_DDE, "()()", "sig_", "", "" },
	{ 0x03E9, NULL, 0, "", "", "" },
	{ 0x03EA, NULL, 0, "", "", "" },
	{ 0x03EB, NULL, 0, "", "", "" },
	{ 0x03EC, NULL, 0, "", "", "" },
	{ 0x03ED, NULL, 0, "", "", "" },
	{ 0x03EE, NULL, 0, "", "", "" },
	{ 0x03EF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x03F0, NULL, 0, "", "", "" },
	{ 0x03F1, NULL, 0, "", "", "" },
	{ 0x03F2, NULL, 0, "", "", "" },
	{ 0x03F3, NULL, 0, "", "", "" },
	{ 0x03F4, NULL, 0, "", "", "" },
	{ 0x03F5, NULL, 0, "", "", "" },
	{ 0x03F6, NULL, 0, "", "", "" },
	{ 0x03F7, NULL, 0, "", "", "" },
	{ 0x03F8, NULL, 0, "", "", "" },
	{ 0x03F9, NULL, 0, "", "", "" },
	{ 0x03FA, NULL, 0, "", "", "" },
	{ 0x03FB, NULL, 0, "", "", "" },
	{ 0x03FC, NULL, 0, "", "", "" },
	{ 0x03FD, NULL, 0, "", "", "" },
	{ 0x03FE, NULL, 0, "", "", "" },
	{ 0x03FF, NULL, 0, "", "", "" },

/////////////////////////////////////////////////////////////////////////
	{ 0x0400, "WM_USER", 0, "", "", "" }
};




/////////////////////////////////////////////////////////////////////////////
// 0x1100 - 0x1200: TreeView messages
/////////////////////////////////////////////////////////////////////////////
static MESSAGEINFO g_msginfTreeView[] =
{
	/////////////////////////////////////////////////////////////////////////
	{ 0x1100, "TVM_INSERTITEMA",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1101, "TVM_DELETEITEM",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1102, "TVM_EXPAND",				MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1104, "TVM_GETITEMRECT",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1105, "TVM_GETCOUNT",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1106, "TVM_GETINDENT",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1107, "TVM_SETINDENT",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1108, "TVM_GETIMAGELIST",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1109, "TVM_SETIMAGELIST",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x110A, "TVM_GETNEXTITEM",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x110B, "TVM_SELECTITEM",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x110C, "TVM_GETITEMA",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x110D, "TVM_SETITEMA",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x110E, "TVM_EDITLABELA",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x110F, "TVM_GETEDITCONTROL",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1110, "TVM_GETVISIBLECOUNT",	MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1111, "TVM_HITTEST",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1112, "TVM_CREATEDRAGIMAGE",	MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1113, "TVM_SORTCHILDREN",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1114, "TVM_ENSUREVISIBLE",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1115, "TVM_SORTCHILDRENCB",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1116, "TVM_ENDEDITLABELNOW",	MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1117, "TVM_GETISEARCHSTRINGA",	MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1118, "TVM_SETTOOLTIPS",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1119, "TVM_GETTOOLTIPS",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x111A, "TVM_SETINSERTMARK",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x111B, "TVM_SETITEMHEIGHT",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x111C, "TVM_GETITEMHEIGHT",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x111D, "TVM_SETBKCOLOR",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x111E, "TVM_SETTEXTCOLOR",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x111F, "TVM_GETBKCOLOR",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1120, "TVM_GETTEXTCOLOR",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1121, "TVM_SETSCROLLTIME",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1122, "TVM_GETSCROLLTIME",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1125, "TVM_SETINSERTMARKCOLOR",	MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1126, "TVM_GETINSERTMARKCOLOR",	MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1132, "TVM_INSERTITEMW",		MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x113E, "TVM_GETITEMW",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x113F, "TVM_SETITEMW",			MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1140, "TVM_GETISEARCHSTRINGW",	MT_TREEVIEW, "()()", "sig_", "", "" },
	{ 0x1141, "TVM_EDITLABELW",			MT_TREEVIEW, "()()", "sig_", "", "" },
};





/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////

// WPARAM - UINT
// LPARAM - LONG

//         wParam   lParam
// return (Lo, Hi) (Lo, Hi)

static MESSAGEDESCRIPTION g_msgdes[] =
{
/////////////////////////////////////////////////////////////////////////

/* 0x0000 */  { WM_NULL,          MT_UNKNOWN,         "WM_NULL",          "()()", "sig_", "", "" },
/* 0x0001 */  { WM_CREATE,        MT_WINDOW,          "WM_CREATE",        "int()(lpcs = (LPCREATESTRUCT)lParam)", "sig_is", "" },
/* 0x0002 */  { WM_DESTROY,       MT_WINDOW,          "WM_DESTROY",       "0()()", "sig_vv", "Sent when a window is being destroyed" },
/* 0x0003 */  { WM_MOVE,          MT_WINDOW,          "WM_MOVE",          "0()(xPos = (int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam))", "sig_vii", "" },
/* 0x0004 */
/* 0x0005 */  { WM_SIZE,          MT_WINDOW,          "WM_SIZE",          "0(fwSizeType = wParam)(nWidth = LOWORD(lParam),nHeight = HIWORD(lParam))", "sig_uii", "" },
/* 0x0006 */  { WM_ACTIVATE,      MT_KEYBOARDINPUT,   "WM_ACTIVATE",      "0(fActive = LOWORD(wParam))(fMinimized = (BOOL)HIWORD(wParam),hwndPrevious = (HWND)lParam)", "sig_vubh", "" },
/* 0x0007 */  { WM_SETFOCUS,      MT_KEYBOARDINPUT,   "WM_SETFOCUS",      "(HWND=hwndLoseFocus)()", "sig_", "", "" },
/* 0x0008 */  { WM_KILLFOCUS,     MT_KEYBOARDINPUT,   "WM_KILLFOCUS",     "(HWND=hwndGetFocus)()", "sig_", "", "" },
/* 0x0009 */
/* 0x000A */  { WM_ENABLE,        MT_WINDOW,          "WM_ENABLE",        "(BOOL=fEnabled)()", "sig_", "", "" },
/* 0x000B */  { WM_SETREDRAW,     MT_PAINTINGDRAWING, "WM_SETREDRAW",     "0(UINT=fRedraw)(0)", "sig_", "", "Sends to a window to allow changes in that window to be redrawn or to prevent changes in that window from being redrawn" },
/* 0x000C */  { WM_SETTEXT,       MT_WINDOW,          "WM_SETTEXT",       "(0)(LPCTSTR=lpsz)", "sig_", "", "" },
/* 0x000D */  { WM_GETTEXT,       MT_WINDOW,          "WM_GETTEXT",       "(=cchTextMax)(LPCTSTR=lpszText)", "sig_", "", "" },
/* 0x000E */  { WM_GETTEXTLENGTH, MT_WINDOW,          "WM_GETTEXTLENGTH", "(0)(0)", "sig_", "", "" },
/* 0x000F */  { WM_PAINT,         MT_PAINTINGDRAWING, "WM_PAINT",         "0(HDC=hdc)()", "sig_", "", "Sends when the system or another application makes a request to paint a portion of an application's window" },

/////////////////////////////////////////////////////////////////////////

/* 0x0010 */  { WM_CLOSE,           MT_WINDOW,          "WM_CLOSE", "0()()", "sig_", "", "" },
/* 0x0011 */  { WM_QUERYENDSESSION, MT_SYSTEMSHUTDOWN,  "WM_QUERYENDSESSION", "BOOL(UINT=nSource)(LONG=fLogOff)", "sig_", "", "sent when the user chooses to end the session or when an application calls the ExitWindows function" },
/* 0x0012 */  { WM_QUIT,            MT_WINDOW,          "WM_QUIT", "(int=nExitCode)()", "sig_", "", "" },
/* 0x0013 */  { WM_QUERYOPEN,       MT_WINDOW,          "WM_QUERYOPEN", "()()", "sig_", "", "" },
/* 0x0014 */  { WM_ERASEBKGND,      MT_PAINTINGDRAWING, "WM_ERASEBKGND", "(HDC=hdc)()", "sig_", "", "" },
/* 0x0015 */  { WM_SYSCOLORCHANGE,  MT_COLOR,           "WM_SYSCOLORCHANGE", "()()", "sig_", "", "sent to all top-level windows when a change is made to a system color setting" },
/* 0x0016 */  { WM_ENDSESSION,      MT_SYSTEMSHUTDOWN,  "WM_ENDSESSION", "0(BOOL=fEndSession)(LONG=fLogOff)", "sig_", "", "sent to an application after the system processes the results of the WM_QUERYENDSESSION message" },
/* 0x0017 */
/* 0x0018 */  { WM_SHOWWINDOW,      MT_WINDOW,          "WM_SHOWWINDOW", "(BOOL=fShow)(int=fnStatus)", "sig_", "", "Sent to a window when the window is about to be hidden or shown" },
/* 0x0019 */
/* 0x001A */  { WM_SETTINGCHANGE,   MT_WINDOW,          "WM_SETTINGCHANGE", "0(wFlag)(LPCTSTR=pszSection)", "sig_", "", "sends the WM_SETTINGCHANGE message to all top-level windows when theSystemParametersInfo function changes a system-wide setting" }, // WM_WININICHANGE
/* 0x001B */  { WM_DEVMODECHANGE,   MT_DEVICECONTEXT,   "WM_DEVMODECHANGE", "0()(LPCTSTR=lpszDev)", "sig_", "", "to all top-level windows whenever the user changes device-mode settings" },
/* 0x001C */  { WM_ACTIVATEAPP,     MT_WINDOW,          "WM_ACTIVATEAPP", "(BOOL=fActive)(DWORD=dwThreadID)", "sig_", "", "" },
/* 0x001D */  { WM_FONTCHANGE,      MT_FONTTEXT,        "WM_FONTCHANGE", "(0)(0)", "sig_", "", "sends to all top-level windows in the system after changing the pool of font resources" },
/* 0x001E */  { WM_TIMECHANGE,      MT_TIME,            "WM_TIMECHANGE", "0(0)(0)", "sig_", "", "send to all top-level windows after changing the system time" },
/* 0x001F */  { WM_CANCELMODE,      MT_WINDOW,          "WM_CANCELMODE", "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
 
/* 0x0020 */  { WM_SETCURSOR,     MT_CURSOR,           "WM_SETCURSOR",     "(HWND=hwnd)(WORD=nHittest,WORD=wMouseMsg)", "sig_", "", "sent to a window if the mouse causes the cursor to move within a window and mouse input is not captured" },
/* 0x0021 */  { WM_MOUSEACTIVATE, MT_MOUSEINPUT,       "WM_MOUSEACTIVATE", "(HWND=hwndTopLevel);(INT=nHittest,UINT=uMsg)", "sig_", "", "" },
/* 0x0022 */  { WM_CHILDACTIVATE, MT_WINDOW,           "WM_CHILDACTIVATE", "()()", "sig_", "", "" },
/* 0x0023 */  { WM_QUEUESYNC,     MT_HOOK,             "WM_QUEUESYNC",     "(0)(0)", "sig_", "", "Sent by a computer-based training (CBT) application to separate user-input messages from other messages sent through the WH_JOURNALPLAYBACK hook procedure" },
/* 0x0024 */  { WM_GETMINMAXINFO, MT_WINDOW,           "WM_GETMINMAXINFO", "()(LPMINMAXINFO=lpmmi)", "sig_", "", "" },
/* 0x0025 */
/* 0x0026 */  { WM_PAINTICON,      MT_PAINTINGDRAWING, "WM_PAINTICON",      "()()", "sig_", "", "" },
/* 0x0027 */  { WM_ICONERASEBKGND, MT_PAINTINGDRAWING, "WM_ICONERASEBKGND", "(HDC=hdc)()", "sig_", "", "" },
/* 0x0028 */  { WM_NEXTDLGCTL,     MT_DIALOGBOX,       "WM_NEXTDLGCTL",     "0(UINT=wCtlFocus)(BOOL=fHandle,)", "sig_", "", "sent to a dialog box procedure to set the keyboard focus to a different control in the dialog box" },
/* 0x0029 */
/* 0x002A */  { WM_SPOOLERSTATUS,  MT_PRINTSPOOLER,     "WM_SPOOLERSTATUS", "(UINT=fwJobStatus)(WORD=cJobsLeft,)", "sig_", "", "sent from Print Manager whenever a job is added to or removed from the Print Manager queue" },
/* 0x002B */  { WM_DRAWITEM,       0,                   "WM_DRAWITEM",      "(UINT=idCtl)(LPDRAWITEMSTRUCT=lpdis)", "sig_", "", "" },
/* 0x002C */  { WM_MEASUREITEM,    0,                   "WM_MEASUREITEM",   "(UINT=idCtl)(LPMEASUREITEMSTRUCT=lpmis)", "sig_", "", "" },
/* 0x002D */  { WM_DELETEITEM,     0,                   "WM_DELETEITEM",    "(=idCtl)(LPDELETEITEMSTRUCT=lpdis)", "sig_", "", "" },
/* 0x002E */  { WM_VKEYTOITEM,     0,                   "WM_VKEYTOITEM",    "(=vkey,=nCaretPos)(HWND=hwndLB)", "sig_", "", "" },
/* 0x002F */  { WM_CHARTOITEM,     0,                   "WM_CHARTOITEM",    "(=nKey,=nCaretPos)(HWND=hwndListBox)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0030 */  { WM_SETFONT, MT_CONTROL, "WM_SETFONT", "(HFONT=hfont)(WORD=fRedraw,0)", "sig_", "", "sends a message to specify the font that a control is to use when drawing text" },
/* 0x0031 */  { WM_GETFONT, MT_CONTROL, "WM_GETFONT", "HFONT(0)(0)", "sig_", "", "sends a message to a control to retrieve the font with which the control is currently drawing its text" },
/* 0x0032 */  { WM_SETHOTKEY, MT_KEYBOARDINPUT, "WM_SETHOTKEY", "(=vkey,=modifiers)(0)", "sig_", "", "" },
/* 0x0033 */  { WM_GETHOTKEY, MT_KEYBOARDINPUT, "WM_GETHOTKEY", "(0)(0)", "sig_", "", "" },
/* 0x0034 */
/* 0x0035 */
/* 0x0036 */
/* 0x0037 */  { WM_QUERYDRAGICON, MT_WINDOW, "WM_QUERYDRAGICON", ";", "sig_", "", "" },
/* 0x0038 */
/* 0x0039 */  { WM_COMPAREITEM, 0, "WM_COMPAREITEM", "(=idCtl)(LPCOMPAREITEMSTRUCT=lpcis)", "sig_", "", "" },
/* 0x003A */
/* 0x003B */
/* 0x003C */
/* 0x003D */  { WM_GETOBJECT, MT_ACCESSIBILITY, "WM_GETOBJECT", "UINT(DWORD=dwFlags)(DWORD=dwObjId)", "sig_", "", "The oleacc.dll dynamic link library sends this message to an Active Accessibility server application to retrieve information about an accessible object it contains" },
/* 0x003E */
/* 0x003F */

/////////////////////////////////////////////////////////////////////////

/* 0x0040 */
/* 0x0041 */  { WM_COMPACTING,        MT_WINDOW, "WM_COMPACTING",        "(=wCompactRatio)()", "sig_", "", "" },
/* 0x0042 */
/* 0x0043 */
/* 0x0044 */  { WM_COMMNOTIFY,        MT_UNKNOWN, "WM_COMMNOTIFY",        "!", "", "" },
/* 0x0045 */
/* 0x0046 */  { WM_WINDOWPOSCHANGING, MT_WINDOW, "WM_WINDOWPOSCHANGING", "0()(LPWINDOWPOS=lpwp)", "sig_", "", "Sent to a window whose size, position, or place in the Z order is about to change" },
/* 0x0047 */  { WM_WINDOWPOSCHANGED,  MT_WINDOW, "WM_WINDOWPOSCHANGED",  "0()(LPWINDOWPOS=lpwp)", "sig_", "", "Sent to a window whose size, position, or place in the Z order has changed" },
/* 0x0048 */  { WM_POWER,             MT_POWERMANAGEMENT, "WM_POWER",             "!UINT(UINT=fwPowerEvt)()", "sig_", "", "Sent when the system, typically a battery-powered personal computer, is about to enter suspended mode" },
/* 0x0049 */
/* 0x004A */  { WM_COPYDATA,          MT_INTERPROCESS, "WM_COPYDATA",          "BOOL(HWND=hwnd)(PCOPYDATASTRUCT=pcds)", "sig_", "", "sent when an application passes data to another application" },
/* 0x004B */  { WM_CANCELJOURNAL,     MT_HOOK, "WM_CANCELJOURNAL",     "(0)(0)", "sig_", "", "Posted to an application when a user cancels the application's journaling activities" },
/* 0x004C */
/* 0x004D */
/* 0x004E */  { WM_NOTIFY,            MT_COMMONCONTROL, "WM_NOTIFY",            "(int=idCtrl)(LPNMHDR=pnmh)", "sig_", "", "Sent by a common control to its parent window when an event has occurred in the control or the control requires some kind of information" },
/* 0x004F */

/////////////////////////////////////////////////////////////////////////

/* 0x0050 */  { WM_INPUTLANGCHANGEREQUEST, MT_WINDOW, "WM_INPUTLANGCHANGEREQUEST", "(BOOL=fSysCharSet)(HKL=hkl)", "sig_", "", "" },
/* 0x0051 */  { WM_INPUTLANGCHANGE, MT_WINDOW, "WM_INPUTLANGCHANGE", "(=charset)(HKL=hkl)", "sig_", "", "" },
/* 0x0052 */  { WM_TCARD, 0, "WM_TCARD", "0(UINT=idAction)(LONG=dwActionData)", "sig_", "", "Sent to an application that has initiated a training card with Windows Help" },
/* 0x0053 */  { WM_HELP, 0, "WM_HELP", "()(LPHELPINFO=lphi)", "sig_", "", "" },
/* 0x0054 */  { WM_USERCHANGED, MT_WINDOW, "WM_USERCHANGED", "(0)(0)", "sig_", "", "" },
/* 0x0055 */  { WM_NOTIFYFORMAT, MT_COMMONCONTROL, "WM_NOTIFYFORMAT", "int(HWND=hwndFrom)(int=Command)", "sig_", "", "Used to determine if a window accepts ANSI or Unicode structures in the WM_NOTIFY notification message" },

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

/* 0x007B */  { WM_CONTEXTMENU, 0, "WM_CONTEXTMENU", "(HWND=hwnd)(=xPos,=yPos)", "sig_", "", "" },
/* 0x007C */  { WM_STYLECHANGING, MT_WINDOW, "WM_STYLECHANGING", "(=wStyleType)(LPSTYLESTRUCT=lpss)", "sig_", "", "" },
/* 0x007D */  { WM_STYLECHANGED, MT_WINDOW, "WM_STYLECHANGED", "(=wStyleType)()", "LPSTYLESTRUCT=lpss", "" },
/* 0x007E */  { WM_DISPLAYCHANGE, MT_PAINTINGDRAWING, "WM_DISPLAYCHANGE", "(=cBitsPerPixel)(=cxScreen,=cyScreen)", "sig_", "", "" },
/* 0x007F */  { WM_GETICON, MT_WINDOW, "WM_GETICON", "(=fType)()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0080 */  { WM_SETICON, MT_WINDOW, "WM_SETICON", "(=fType)(HICON=hicon)", "sig_", "", "" },
/* 0x0081 */  { WM_NCCREATE,   MT_WINDOW,           "WM_NCCREATE",   "BOOL()(LPCREATESTRUCT=lpcs)",                                          "sig_", "", "Sent prior to the WM_CREATE message when a window is first created" },
/* 0x0082 */  { WM_NCDESTROY,  MT_WINDOW,           "WM_NCDESTROY",  "0()()",                                                                "sig_", "", "Informs a window that its nonclient area is being destroyed" },
/* 0x0083 */  { WM_NCCALCSIZE, MT_WINDOW,           "WM_NCCALCSIZE", "UINT(BOOL=fCalcValidRects)(LPNCCALCSIZE_PARAMS=lpncsp|LPRECT=lpncsp)", "sig_", "", "Sent when the size and position of a window's client area must be calculated" },
/* 0x0084 */  { WM_NCHITTEST,  MT_MOUSEINPUT, "WM_NCHITTEST",  "UINT()(WORD=xPos,WORD=yPos)",                                          "sig_", "", "Sent to a window when the cursor moves, or when a mouse button is pressed or released" },
/* 0x0085 */  { WM_NCPAINT,    MT_PAINTINGDRAWING,           "WM_NCPAINT",    "0(HRGN=hrgn)()",                                                       "sig_", "", "Sends to a window when its frame must be painted" },
/* 0x0086 */  { WM_NCACTIVATE, MT_WINDOW,           "WM_NCACTIVATE", "BOOL(BOOL=fActive)()",                                                 "sig_", "", "Sent to a window when its nonclient area needs to be changed to indicate an active or inactive state" },
/* 0x0087 */  { WM_GETDLGCODE, MT_DIALOGBOX, "WM_GETDLGCODE", "UINT()(LPMSG=pMsg)", "sig_", "", "sent to the window procedure associated with a control. By default, the system handles all keyboard input to the control" },
/* 0x0088 */  { WM_SYNCPAINT, MT_PAINTINGDRAWING, "WM_SYNCPAINT", "0()()", "sig_", "", "Used to synchronize painting while avoiding linking independent GUI threads" },

/////////////////////////////////////////////////////////////////////////

/* 0x00A0 */  { WM_NCMOUSEMOVE,     MT_MOUSEINPUT, "WM_NCMOUSEMOVE",     "0(INT=nHittest)(POINTS=pts)", "sig_", "", "Posted to a window when the cursor is moved within the nonclient area of the window" },
/* 0x00A1 */  { WM_NCLBUTTONDOWN,   MT_MOUSEINPUT, "WM_NCLBUTTONDOWN",   "0(INT=nHittest)(POINTS=pts)", "sig_", "", "posted when the user presses the left mouse button while the cursor is within the nonclient area of a window" },
/* 0x00A2 */  { WM_NCLBUTTONUP,     MT_MOUSEINPUT, "WM_NCLBUTTONUP",     "0(INT=nHittest)(POINTS=pts)", "sig_", "", "posted when the user releases the left mouse button while the cursor is within the nonclient area of a window" },
/* 0x00A3 */  { WM_NCLBUTTONDBLCLK, MT_MOUSEINPUT, "WM_NCLBUTTONDBLCLK", "0(INT=nHittest)(POINTS=pts)", "sig_", "", "posted when the user double-clicks the left mouse button while the cursor is within the nonclient area of a window" },
/* 0x00A4 */  { WM_NCRBUTTONDOWN,   MT_MOUSEINPUT, "WM_NCRBUTTONDOWN",   "0(INT=nHittest)(POINTS=pts)", "sig_", "", "" },
/* 0x00A5 */  { WM_NCRBUTTONUP,     MT_MOUSEINPUT, "WM_NCRBUTTONUP",     "0(INT=nHittest)(POINTS=pts)", "sig_", "", "" },
/* 0x00A6 */  { WM_NCRBUTTONDBLCLK, MT_MOUSEINPUT, "WM_NCRBUTTONDBLCLK", "0(INT=nHittest)(POINTS=pts)", "sig_", "", "" },
/* 0x00A7 */  { WM_NCMBUTTONDOWN,   MT_MOUSEINPUT, "WM_NCMBUTTONDOWN",   "0(INT=nHittest)(POINTS=pts)", "sig_", "", "" },
/* 0x00A8 */  { WM_NCMBUTTONUP,     MT_MOUSEINPUT, "WM_NCMBUTTONUP",     "0(INT=nHittest)(POINTS=pts)", "sig_", "", "" },
/* 0x00A9 */  { WM_NCMBUTTONDBLCLK, MT_MOUSEINPUT, "WM_NCMBUTTONDBLCLK", "0(INT=nHittest)(POINTS=pts)", "sig_", "", "" },
/* 0x00AA */
/* 0x00AB */
/* 0x00AC */
/* 0x00AD */
/* 0x00AE */
/* 0x00AF */


/////////////////////////////////////////////////////////////////////////
// Edit Control Messages (EM_)
/////////////////////////////////////////////////////////////////////////
/* 0x00B0 */  { EM_GETSEL, MTF_EDIT, "EM_GETSEL", "", "sig_", "", "" },
/* 0x00B1 */  { EM_SETSEL, MTF_EDIT, "EM_SETSEL", "", "sig_", "", "" },
/* 0x00B2 */  { EM_GETRECT, MTF_EDIT, "EM_GETRECT", "", "sig_", "", "" },
/* 0x00B3 */  { EM_SETRECT, MTF_EDIT, " EM_SETRECT", "", "sig_", "", "" },
/* 0x00B4 */  { EM_SETRECTNP, MTF_EDIT, "EM_SETRECTNP", "", "sig_", "", "" },
/* 0x00B5 */  { EM_SCROLL, MTF_EDIT, "EM_SCROLL", "", "sig_", "", "" },
/* 0x00B6 */  { EM_LINESCROLL, MTF_EDIT, "EM_LINESCROLL", "", "sig_", "", "" },
/* 0x00B7 */  { EM_SCROLLCARET, MTF_EDIT, "EM_SCROLLCARET", "", "sig_", "", "" },
/* 0x00B8 */  { EM_GETMODIFY, MTF_EDIT, "EM_GETMODIFY", "", "sig_", "", "" },
/* 0x00B9 */  { EM_SETMODIFY, MTF_EDIT, "EM_SETMODIFY", "", "sig_", "", "" },
/* 0x00BA */  { EM_GETLINECOUNT, MTF_EDIT, "EM_GETLINECOUNT", "", "sig_", "", "" },
/* 0x00BB */  { EM_LINEINDEX, MTF_EDIT, "EM_LINEINDEX", "", "sig_", "", "" },
/* 0x00BC */  { EM_SETHANDLE, MTF_EDIT, "EM_SETHANDLE", "", "sig_", "", "" },
/* 0x00BD */  { EM_GETHANDLE, MTF_EDIT, "EM_GETHANDLE", "", "sig_", "", "" },
/* 0x00BE */  { EM_GETTHUMB, MTF_EDIT, "EM_GETTHUMB", "", "sig_", "", "" },
/* 0x00BF */

/////////////////////////////////////////////////////////////////////////

/* 0x00C0 */
/* 0x00C1 */  { EM_LINELENGTH, MTF_EDIT, "EM_LINELENGTH", "", "sig_", "", "" },
/* 0x00C2 */  { EM_REPLACESEL, MTF_EDIT, "EM_REPLACESEL", "", "sig_", "", "" },
/* 0x00C3 */
/* 0x00C4 */  { EM_GETLINE, MTF_EDIT, "EM_GETLINE", "", "sig_", "", "" },
/* 0x00C5 */  { EM_LIMITTEXT, MTF_EDIT, "EM_LIMITTEXT", "", "sig_", "", "" },
/* 0x00C6 */  { EM_CANUNDO, MTF_EDIT, "EM_CANUNDO", "", "sig_", "", "" },
/* 0x00C7 */  { EM_UNDO, MTF_EDIT, "EM_UNDO", "", "sig_", "", "" },
/* 0x00C8 */  { EM_FMTLINES, MTF_EDIT, "EM_FMTLINES", "", "sig_", "", "" },
/* 0x00C9 */  { EM_LINEFROMCHAR, MTF_EDIT, "EM_LINEFROMCHAR", "", "sig_", "", "" },
/* 0x00CA */
/* 0x00CB */  { EM_SETTABSTOPS, MTF_EDIT, "EM_SETTABSTOPS", "", "sig_", "", "" },
/* 0x00CC */  { EM_SETPASSWORDCHAR, MTF_EDIT, "EM_SETPASSWORDCHAR", "", "sig_", "", "" },
/* 0x00CD */  { EM_EMPTYUNDOBUFFER, MTF_EDIT, "EM_EMPTYUNDOBUFFER", "", "sig_", "", "" },
/* 0x00CE */  { EM_GETFIRSTVISIBLELINE, MTF_EDIT, "EM_GETFIRSTVISIBLELINE", "", "sig_", "", "" },
/* 0x00CF */  { EM_SETREADONLY, MTF_EDIT, "EM_SETREADONLY", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x00D0 */  { EM_SETWORDBREAKPROC, MTF_EDIT, "EM_SETWORDBREAKPROC", "", "sig_", "", "" },
/* 0x00D1 */  { EM_GETWORDBREAKPROC, MTF_EDIT, "EM_GETWORDBREAKPROC", "", "sig_", "", "" },
/* 0x00D2 */  { EM_GETPASSWORDCHAR, MTF_EDIT, "EM_GETPASSWORDCHAR", "", "sig_", "", "" },
/* 0x00D3 */  { EM_SETMARGINS, MTF_EDIT, "EM_SETMARGINS", "", "sig_", "", "" },
/* 0x00D4 */  { EM_GETMARGINS, MTF_EDIT, "EM_GETMARGINS", "", "sig_", "", "" },
/* 0x00D5 */  { EM_GETLIMITTEXT, MTF_EDIT, "EM_GETLIMITTEXT", "", "sig_", "", "" },
/* 0x00D6 */  { EM_POSFROMCHAR, MTF_EDIT, "EM_POSFROMCHAR", "", "sig_", "", "" },
/* 0x00D7 */  { EM_CHARFROMPOS, MTF_EDIT, "EM_CHARFROMPOS", "", "sig_", "", "" },
/* 0x00D8 */  { EM_SETIMESTATUS, MTF_EDIT, "EM_SETIMESTATUS", "", "sig_", "", "" },
/* 0x00D9 */  { EM_GETIMESTATUS, MTF_EDIT, "EM_GETIMESTATUS", "", "sig_", "", "" },
/* 0x00DA */
/* 0x00DB */
/* 0x00DC */
/* 0x00DD */
/* 0x00DE */
/* 0x00DF */


/////////////////////////////////////////////////////////////////////////
// Scroll Bar Messages (SBM_)
/////////////////////////////////////////////////////////////////////////
/* 0x00E0 */  { SBM_SETPOS, MTF_SCROLLBAR, "SBM_SETPOS", "", "sig_", "", "" },
/* 0x00E1 */  { SBM_GETPOS, MTF_SCROLLBAR, "SBM_GETPOS", "", "sig_", "", "" },
/* 0x00E2 */  { SBM_SETRANGE, MTF_SCROLLBAR, "SBM_SETRANGE", "", "sig_", "", "" },
/* 0x00E3 */  { SBM_GETRANGE, MTF_SCROLLBAR, "SBM_GETRANGE", "", "sig_", "", "" },
/* 0x00E4 */  { SBM_ENABLE_ARROWS, MTF_SCROLLBAR, "SBM_ENABLE_ARROWS", "", "sig_", "", "" },
/* 0x00E5 */
/* 0x00E6 */  { SBM_SETRANGEREDRAW, MTF_SCROLLBAR, "SBM_SETRANGEREDRAW", "", "sig_", "", "" },
/* 0x00E7 */
/* 0x00E8 */
/* 0x00E9 */  { SBM_SETSCROLLINFO, MTF_SCROLLBAR, "SBM_SETSCROLLINFO", "", "sig_", "", "" },
/* 0x00EA */  { SBM_GETSCROLLINFO, MTF_SCROLLBAR, "SBM_GETSCROLLINFO", "", "sig_", "", "" },
/* 0x00EB */
/* 0x00EC */
/* 0x00ED */
/* 0x00EE */
/* 0x00EF */


/////////////////////////////////////////////////////////////////////////
// Button Control Messages (BM_)
/////////////////////////////////////////////////////////////////////////
/* 0x00F0 */  { BM_GETCHECK, MTF_BUTTON, "BM_GETCHECK", "(0)(0)", "sig_", "", "" },
/* 0x00F1 */  { BM_SETCHECK, MTF_BUTTON, "BM_SETCHECK", "(=fCheck)(0)", "sig_", "", "" },
/* 0x00F2 */  { BM_GETSTATE, MTF_BUTTON, "BM_GETSTATE", "(0)(0)", "sig_", "", "" },
/* 0x00F3 */  { BM_SETSTATE, MTF_BUTTON, "BM_SETSTATE", "(=fState)(0)", "sig_", "", "" },
/* 0x00F4 */  { BM_SETSTYLE, MTF_BUTTON, "BM_SETSTYLE", "(,=dwStyle)(=fRedraw,0)", "sig_", "", "" },
/* 0x00F5 */  { BM_CLICK, MTF_BUTTON, "BM_CLICK", "(0)(0)", "sig_", "", "" },
/* 0x00F6 */  { BM_GETIMAGE, MTF_BUTTON, "BM_GETIMAGE", "(=fImageType)(0)", "sig_", "", "" },
/* 0x00F7 */  { BM_SETIMAGE, MTF_BUTTON, "BM_SETIMAGE", "(=fImageType)(HANDLE=hImage)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0100 */  { WM_KEYDOWN, MT_KEYBOARDINPUT, "WM_KEYDOWN", "(int=nVirtKey)(=lKeyData)", "sig_", "", "" },
/* 0x0101 */  { WM_KEYUP, MT_KEYBOARDINPUT, "WM_KEYUP", "(int=nVirtKey)(=lKeyData)", "sig_", "", "" },
/* 0x0102 */  { WM_CHAR, MT_KEYBOARDINPUT, "WM_CHAR", "(TCHAR=chCharCode)(=lKeyData)", "sig_", "", "" },
/* 0x0103 */  { WM_DEADCHAR, MT_KEYBOARDINPUT, "WM_DEADCHAR", "(TCHAR=chCharCode)(=lKeyData)", "sig_", "", "" },
/* 0x0104 */  { WM_SYSKEYDOWN, MT_KEYBOARDINPUT, "WM_SYSKEYDOWN", "(int=nVirtKey)(=lKeyData)", "sig_", "", "" },
/* 0x0105 */  { WM_SYSKEYUP, MT_KEYBOARDINPUT, "WM_SYSKEYUP", "(int=nVirtKey)(=lKeyData)", "sig_", "", "" },
/* 0x0106 */  { WM_SYSCHAR, MT_KEYBOARDINPUT, "WM_SYSCHAR", "(TCHAR=chCharCode)(=lKeyData)", "sig_", "", "" },
/* 0x0107 */  { WM_SYSDEADCHAR, MT_KEYBOARDINPUT, "WM_SYSDEADCHAR", "(TCHAR=chCharCode)(=lKeyData)", "sig_", "", "" },
/* 0x0108 */  { WM_KEYLAST, 0, "WM_KEYLAST", "()()", "sig_", "", "" },
/* 0x0109 */  { WM_WNT_CONVERTREQUESTEX, MTF_IMEDITOR, "WM_WNT_CONVERTREQUESTEX", "", "sig_", "", "" },
/* 0x010A */  { WM_CONVERTREQUEST, MTF_IMEDITOR, "WM_CONVERTREQUEST", "", "sig_", "", "" },
/* 0x010B */  { WM_CONVERTRESULT, MTF_IMEDITOR, "WM_CONVERTRESULT", "", "sig_", "", "" },
/* 0x010C */  { WM_INTERIM, MTF_IMEDITOR, "WM_INTERIM", "", "sig_", "", "" },
/* 0x010D */  { WM_IME_STARTCOMPOSITION, MTF_IMEDITOR, "WM_IME_STARTCOMPOSITION", "()()", "sig_", "", "" },
/* 0x010E */  { WM_IME_ENDCOMPOSITION, MTF_IMEDITOR, "WM_IME_ENDCOMPOSITION", "()()", "sig_", "", "" },
/* 0x010F */  { WM_IME_COMPOSITION, MTF_IMEDITOR, "WM_IME_COMPOSITION", "(WORD=chDBCS)(BOOL=fFlags)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0110 */  { WM_INITDIALOG, MT_DIALOGBOX, "WM_INITDIALOG", "BOOL(HWND=hwndFocus)(LONG=lInitParam)", "sig_", "", "sent to the dialog box procedure immediately before a dialog box is displayed" },
/* 0x0111 */  { WM_COMMAND, 0, "WM_COMMAND", "(=wID,=wNotifyCode)(HWND=hwndCtl", "sig_", "", "" },
/* 0x0112 */  { WM_SYSCOMMAND, 0, "WM_SYSCOMMAND", "(=uCmdType)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0113 */  { WM_TIMER, 0, "WM_TIMER", "(=wTimerID)(TIMERPROC*=tmprc)", "sig_", "", "" },
/* 0x0114 */  { WM_HSCROLL, 0, "WM_HSCROLL", "(int=nScrollCode,short=nPos)(HWND=hwndScrollBar)", "sig_", "", "" },
/* 0x0115 */  { WM_VSCROLL, 0, "WM_VSCROLL", "(int=nScrollCode,short=nPos)(HWND=hwndScrollBar)", "sig_", "", "" },
/* 0x0116 */  { WM_INITMENU, 0, "WM_INITMENU", "(HMENU=hmenuInit)()", "sig_", "", "" },
/* 0x0117 */  { WM_INITMENUPOPUP, 0, "WM_INITMENUPOPUP", "(HMENU=hmenuPopup)(UINT=uPos,BOOL=fSystemMenu)", "sig_", "", "" },
/* 0x011F */  { WM_MENUSELECT, 0, "WM_MENUSELECT", "(UINT=uItem,UINT=fuFlags)(HMENU=hmenu)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0120 */  { WM_MENUCHAR, 0, "WM_MENUCHAR", "(TCHAR=chUser,UINT=fuFlags)(HMENU=hmenu)", "sig_", "", "" },
/* 0x0121 */  { WM_ENTERIDLE, MT_DIALOGBOX, "WM_ENTERIDLE", "0(UINT=fuSource)(HWND=hwnd)", "sig_", "", "sent to the owner window of a modal dialog box or menu that is entering an idle state" },
/* 0x0122 */  { WM_MENURBUTTONUP, 0, "WM_MENURBUTTONUP", "", "sig_", "", "" },
/* 0x0123 */  { WM_MENUDRAG, 0, "WM_MENUDRAG", "", "sig_", "", "" },
/* 0x0124 */  { WM_MENUGETOBJECT, 0, "WM_MENUGETOBJECT", "", "sig_", "", "" },
/* 0x0125 */  { WM_UNINITMENUPOPUP, 0, "WM_UNINITMENUPOPUP", "", "sig_", "", "" },
/* 0x0126 */  { WM_MENUCOMMAND, 0, "WM_MENUCOMMAND", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0132 */  { WM_CTLCOLORMSGBOX, MT_DIALOGBOX, "WM_CTLCOLORMSGBOX", "!", "", "" },
/* 0x0133 */  { WM_CTLCOLOREDIT, 0, "WM_CTLCOLOREDIT", "(HDC=hdcEdit)(HWND=hwndEdit)", "sig_", "", "" },
/* 0x0134 */  { WM_CTLCOLORLISTBOX, 0, "WM_CTLCOLORLISTBOX", "(HDC=hdcLB)(HWND=hwndLB)", "sig_", "", "" },
/* 0x0135 */  { WM_CTLCOLORBTN, 0, "WM_CTLCOLORBTN", "(HDC=hdcButton)(HWND=hwndButton)", "sig_", "", "" },
/* 0x0136 */  { WM_CTLCOLORDLG, MT_DIALOGBOX, "WM_CTLCOLORDLG", "HBRUSH(HDC=hdcDlg)(HWND=hwndDlg)", "sig_", "", "to a dialog box before the system draws the dialog box" },
/* 0x0137 */  { WM_CTLCOLORSCROLLBAR, 0, "WM_CTLCOLORSCROLLBAR", "(HDC=hdcSB)(HWND=hwndSB)", "sig_", "", "" },
/* 0x0138 */  { WM_CTLCOLORSTATIC, 0, "WM_CTLCOLORSTATIC", "(HDC=hdcStatic)(HWND=hwndStatic)", "sig_", "", "" },
	

/////////////////////////////////////////////////////////////////////////
// Combo Box Messages (CB_)
/////////////////////////////////////////////////////////////////////////
/* 0x0140 */  { CB_GETEDITSEL, MT_COMBOBOX, "CB_GETEDITSEL", "", "sig_", "", "" },
/* 0x0141 */  { CB_LIMITTEXT, MT_COMBOBOX, "CB_LIMITTEXT", "", "sig_", "", "" },
/* 0x0142 */  { CB_SETEDITSEL, MT_COMBOBOX, "CB_SETEDITSEL", "", "sig_", "", "" },
/* 0x0143 */  { CB_ADDSTRING, MT_COMBOBOX, "CB_ADDSTRING", "", "sig_", "", "" },
/* 0x0144 */  { CB_DELETESTRING, MT_COMBOBOX, "CB_DELETESTRING", "", "sig_", "", "" },
/* 0x0145 */  { CB_DIR, MT_COMBOBOX, "CB_DIR", "", "sig_", "", "" },
/* 0x0146 */  { CB_GETCOUNT, MT_COMBOBOX, "CB_GETCOUNT", "", "sig_", "", "" },
/* 0x0147 */  { CB_GETCURSEL, MT_COMBOBOX, "CB_GETCURSEL", "", "sig_", "", "" },
/* 0x0148 */  { CB_GETLBTEXT, MT_COMBOBOX, "CB_GETLBTEXT", "", "sig_", "", "" },
/* 0x0149 */  { CB_GETLBTEXTLEN, MT_COMBOBOX, "CB_GETLBTEXTLEN", "", "sig_", "", "" },
/* 0x014A */  { CB_INSERTSTRING, MT_COMBOBOX, "CB_INSERTSTRING", "", "sig_", "", "" },
/* 0x014B */  { CB_RESETCONTENT, MT_COMBOBOX, "CB_RESETCONTENT", "", "sig_", "", "" },
/* 0x014C */  { CB_FINDSTRING, MT_COMBOBOX, "CB_FINDSTRING", "", "sig_", "", "" },
/* 0x014D */  { CB_SELECTSTRING, MT_COMBOBOX, "CB_SELECTSTRING", "", "sig_", "", "" },
/* 0x014E */  { CB_SETCURSEL, MT_COMBOBOX, "CB_SETCURSEL", "", "sig_", "", "" },
/* 0x014F */  { CB_SHOWDROPDOWN, MT_COMBOBOX, "CB_SHOWDROPDOWN", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0150 */  { CB_GETITEMDATA, MT_COMBOBOX, "CB_GETITEMDATA", "", "sig_", "", "" },
/* 0x0151 */  { CB_SETITEMDATA, MT_COMBOBOX, "CB_SETITEMDATA", "", "sig_", "", "" },
/* 0x0152 */  { CB_GETDROPPEDCONTROLRECT, MT_COMBOBOX, "CB_GETDROPPEDCONTROLRECT", "", "sig_", "", "" },
/* 0x0153 */  { CB_SETITEMHEIGHT, MT_COMBOBOX, "CB_SETITEMHEIGHT", "", "sig_", "", "" },
/* 0x0154 */  { CB_GETITEMHEIGHT, MT_COMBOBOX, "CB_GETITEMHEIGHT", "", "sig_", "", "" },
/* 0x0155 */  { CB_SETEXTENDEDUI, MT_COMBOBOX, "CB_SETEXTENDEDUI", "", "sig_", "", "" },
/* 0x0156 */  { CB_GETEXTENDEDUI, MT_COMBOBOX, "CB_GETEXTENDEDUI", "", "sig_", "", "" },
/* 0x0157 */  { CB_GETDROPPEDSTATE, MT_COMBOBOX, "CB_GETDROPPEDSTATE", "", "sig_", "", "" },
/* 0x0158 */  { CB_FINDSTRINGEXACT, MT_COMBOBOX, "CB_FINDSTRINGEXACT", "", "sig_", "", "" },
/* 0x0159 */  { CB_SETLOCALE, MT_COMBOBOX, "CB_SETLOCALE", "", "sig_", "", "" },
/* 0x015A */  { CB_GETLOCALE, MT_COMBOBOX, "CB_GETLOCALE", "", "sig_", "", "" },
/* 0x015B */  { CB_GETTOPINDEX, MT_COMBOBOX, "CB_GETTOPINDEX", "", "sig_", "", "" },
/* 0x015C */  { CB_SETTOPINDEX, MT_COMBOBOX, "CB_SETTOPINDEX", "", "sig_", "", "" },
/* 0x015D */  { CB_GETHORIZONTALEXTENT, MT_COMBOBOX, "CB_GETHORIZONTALEXTENT", "", "sig_", "", "" },
/* 0x015E */  { CB_SETHORIZONTALEXTENT, MT_COMBOBOX, "CB_SETHORIZONTALEXTENT", "", "sig_", "", "" },
/* 0x015F */  { CB_GETDROPPEDWIDTH, MT_COMBOBOX, "CB_GETDROPPEDWIDTH", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0160 */  { CB_SETDROPPEDWIDTH, MT_COMBOBOX, "CB_SETDROPPEDWIDTH", "", "sig_", "", "" },
/* 0x0161 */  { CB_INITSTORAGE, MT_COMBOBOX, "CB_INITSTORAGE", "", "sig_", "", "" },
/* 0x0162 */  { CB_MSGMAX, MT_COMBOBOX, "CB_MSGMAX", "", "sig_", "", "" },


/////////////////////////////////////////////////////////////////////////
// Static Control Messages (STM_)
/////////////////////////////////////////////////////////////////////////
/* 0x0170 */  { STM_SETICON, MTF_STATIC, "STM_SETICON", "(HICON=hicon)(0)", "sig_", "", "" },
/* 0x0171 */  { STM_GETICON, MTF_STATIC, "STM_GETICON", "(0)(0)", "sig_", "", "" },
/* 0x0172 */  { STM_SETIMAGE, MTF_STATIC, "STM_SETIMAGE", "(=fImageType)(HANDLE=hImage)", "sig_", "", "" },
/* 0x0173 */  { STM_GETIMAGE, MTF_STATIC, "STM_GETIMAGE", "(=fImageType)(0)", "sig_", "", "" },
/* 0x0174 */  { STM_MSGMAX, MTF_STATIC, "STM_MSGMAX", "()()", "sig_", "", "" },


/////////////////////////////////////////////////////////////////////////
// List Box Messages (LB_)
/////////////////////////////////////////////////////////////////////////
/* 0x0180 */  { LB_ADDSTRING, MTF_LISTBOX, "LB_ADDSTRING", "", "sig_", "", "" },
/* 0x0181 */  { LB_INSERTSTRING, MTF_LISTBOX, "LB_INSERTSTRING", "", "sig_", "", "" },
/* 0x0182 */  { LB_DELETESTRING, MTF_LISTBOX, "LB_DELETESTRING", "", "sig_", "", "" },
/* 0x0183 */  { LB_SELITEMRANGEEX, MTF_LISTBOX, "LB_SELITEMRANGEEX", "", "sig_", "", "" },
/* 0x0184 */  { LB_RESETCONTENT, MTF_LISTBOX, "LB_RESETCONTENT", "", "sig_", "", "" },
/* 0x0185 */  { LB_SETSEL, MTF_LISTBOX, "LB_SETSEL", "", "sig_", "", "" },
/* 0x0186 */  { LB_SETCURSEL, MTF_LISTBOX, "LB_SETCURSEL", "", "sig_", "", "" },
/* 0x0187 */  { LB_GETSEL, MTF_LISTBOX, "LB_GETSEL", "", "sig_", "", "" },
/* 0x0188 */  { LB_GETCURSEL, MTF_LISTBOX, "LB_GETCURSEL", "", "sig_", "", "" },
/* 0x0189 */  { LB_GETTEXT, MTF_LISTBOX, "LB_GETTEXT", "", "sig_", "", "" },
/* 0x018A */  { LB_GETTEXTLEN, MTF_LISTBOX, "LB_GETTEXTLEN", "", "sig_", "", "" },
/* 0x018B */  { LB_GETCOUNT, MTF_LISTBOX, "LB_GETCOUNT", "", "sig_", "", "" },
/* 0x018C */  { LB_SELECTSTRING, MTF_LISTBOX, "LB_SELECTSTRING", "", "sig_", "", "" },
/* 0x018D */  { LB_DIR, MTF_LISTBOX, "LB_DIR", "", "sig_", "", "" },
/* 0x018E */  { LB_GETTOPINDEX, MTF_LISTBOX, "LB_GETTOPINDEX", "", "sig_", "", "" },
/* 0x018F */  { LB_FINDSTRING, MTF_LISTBOX, "LB_FINDSTRING", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0190 */  { LB_GETSELCOUNT, MTF_LISTBOX, "LB_GETSELCOUNT", "", "sig_", "", "" },
/* 0x0191 */  { LB_GETSELITEMS, MTF_LISTBOX, "LB_GETSELITEMS", "", "sig_", "", "" },
/* 0x0192 */  { LB_SETTABSTOPS, MTF_LISTBOX, "LB_SETTABSTOPS", "", "sig_", "", "" },
/* 0x0193 */  { LB_GETHORIZONTALEXTENT, MTF_LISTBOX, "LB_GETHORIZONTALEXTENT", "", "sig_", "", "" },
/* 0x0194 */  { LB_SETHORIZONTALEXTENT, MTF_LISTBOX, "LB_SETHORIZONTALEXTENT", "", "sig_", "", "" },
/* 0x0195 */  { LB_SETCOLUMNWIDTH, MTF_LISTBOX, "LB_SETCOLUMNWIDTH", "", "sig_", "", "" },
/* 0x0196 */  { LB_ADDFILE, MTF_LISTBOX, "LB_ADDFILE", "", "sig_", "", "" },
/* 0x0197 */  { LB_SETTOPINDEX, MTF_LISTBOX, "LB_SETTOPINDEX", "", "sig_", "", "" },
/* 0x0198 */  { LB_GETITEMRECT, MTF_LISTBOX, "LB_GETITEMRECT", "", "sig_", "", "" },
/* 0x0199 */  { LB_GETITEMDATA, MTF_LISTBOX, "LB_GETITEMDATA", "", "sig_", "", "" },
/* 0x019A */  { LB_SETITEMDATA, MTF_LISTBOX, "LB_SETITEMDATA", "", "sig_", "", "" },
/* 0x019B */  { LB_SELITEMRANGE, MTF_LISTBOX, "LB_SELITEMRANGE", "", "sig_", "", "" },
/* 0x019C */  { LB_SETANCHORINDEX, MTF_LISTBOX, "LB_SETANCHORINDEX", "", "sig_", "", "" },
/* 0x019D */  { LB_GETANCHORINDEX, MTF_LISTBOX, "LB_GETANCHORINDEX", "", "sig_", "", "" },
/* 0x019E */  { LB_SETCARETINDEX, MTF_LISTBOX, "LB_SETCARETINDEX", "", "sig_", "", "" },
/* 0x019F */  { LB_GETCARETINDEX, MTF_LISTBOX, "LB_GETCARETINDEX", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x01A0 */  { LB_SETITEMHEIGHT, MTF_LISTBOX, "LB_SETITEMHEIGHT", "", "sig_", "", "" },
/* 0x01A1 */  { LB_GETITEMHEIGHT, MTF_LISTBOX, "LB_GETITEMHEIGHT", "", "sig_", "", "" },
/* 0x01A2 */  { LB_FINDSTRINGEXACT, MTF_LISTBOX, "LB_FINDSTRINGEXACT", "", "sig_", "", "" },
/* 0x01A5 */  { LB_SETLOCALE, MTF_LISTBOX, "LB_SETLOCALE", "", "sig_", "", "" },
/* 0x01A6 */  { LB_GETLOCALE, MTF_LISTBOX, "LB_GETLOCALE", "", "sig_", "", "" },
/* 0x01A7 */  { LB_SETCOUNT, MTF_LISTBOX, "LB_SETCOUNT", "", "sig_", "", "" },
/* 0x01A8 */  { LB_INITSTORAGE, MTF_LISTBOX, "LB_INITSTORAGE", "", "sig_", "", "" },
/* 0x01A9 */  { LB_ITEMFROMPOINT, MTF_LISTBOX, "LB_ITEMFROMPOINT", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x01B0 */  { LB_MSGMAX, MTF_LISTBOX, "LB_MSGMAX", "", "sig_", "", "" },



/////////////////////////////////////////////////////////////////////////

/* 0x0200 */  { WM_MOUSEMOVE, MT_MOUSEINPUT, "WM_MOUSEMOVE", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0201 */  { WM_LBUTTONDOWN, MT_MOUSEINPUT, "WM_LBUTTONDOWN", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0202 */  { WM_LBUTTONUP, MT_MOUSEINPUT, "WM_LBUTTONUP", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0203 */  { WM_LBUTTONDBLCLK, MT_MOUSEINPUT, "WM_LBUTTONDBLCLK", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0204 */  { WM_RBUTTONDOWN, MT_MOUSEINPUT, "WM_RBUTTONDOWN", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0205 */  { WM_RBUTTONUP, MT_MOUSEINPUT, "WM_RBUTTONUP", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0206 */  { WM_RBUTTONDBLCLK, MT_MOUSEINPUT, "WM_RBUTTONDBLCLK", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0207 */  { WM_MBUTTONDOWN, MT_MOUSEINPUT, "WM_MBUTTONDOWN", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0208 */  { WM_MBUTTONUP, MT_MOUSEINPUT, "WM_MBUTTONUP", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x0209 */  { WM_MBUTTONDBLCLK, MT_MOUSEINPUT, "WM_MBUTTONDBLCLK", "(=fwKeys)(=xPos,=yPos)", "sig_", "", "" },
/* 0x020A */  { WM_MOUSEWHEEL, MT_MOUSEINPUT, "WM_MOUSEWHEEL", "(=fwKeys,short=zDelta)(short=xPos,short=yPos)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0210 */  { WM_PARENTNOTIFY, MT_WINDOW, "WM_PARENTNOTIFY", "(=fwEvent,=idChild)(=lValue)", "sig_", "", "Sent to the parent of a child window when the child window is created or destroyed" },
/* 0x0211 */  { WM_ENTERMENULOOP, 0, "WM_ENTERMENULOOP", "(BOOL=fIsTrackPopupMenu)(0)", "sig_", "", "" },
/* 0x0212 */  { WM_EXITMENULOOP, 0, "WM_EXITMENULOOP", "(BOOL=fIsTrackPopupMenu)(0)", "sig_", "", "" },
/* 0x0213 */  { WM_NEXTMENU, 0, "WM_NEXTMENU", "(int=nVirtKey)(LPMDINEXTMENU=pmdin)", "sig_", "", "" },
/* 0x0214 */  { WM_SIZING, MT_WINDOW, "WM_SIZING", "(=fwSide)(LPRECT=lprc)", "sig_", "", "" },
/* 0x0215 */  { WM_CAPTURECHANGED, MT_MOUSEINPUT, "WM_CAPTURECHANGED", "0()(HWND=hwndNewCapture)", "sig_", "", "sent to the window that is losing the mouse capture" },
/* 0x0216 */  { WM_MOVING, MT_WINDOW, "WM_MOVING", "(=fwSide)(LPRECT=lprc)", "sig_", "", "" },
/* 0x0218 */  { WM_POWERBROADCAST, MT_POWERMANAGEMENT, "WM_POWERBROADCAST", "int(DWORD=dwPowerEvent)(DWORD=dwData)", "sig_", "", "Sent to an application to notify it of power-management events" },
/* 0x0219 */  { WM_DEVICECHANGE, 0, "WM_DEVICECHANGE", "(UINT=Event)(DWORD=dwData)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0220 */  { WM_MDICREATE, 0, "WM_MDICREATE", "", "sig_", "", "" },
/* 0x0221 */  { WM_MDIDESTROY, 0, "WM_MDIDESTROY", "", "sig_", "", "" },
/* 0x0222 */  { WM_MDIACTIVATE, 0, "WM_MDIACTIVATE", "", "sig_", "", "" },
/* 0x0223 */  { WM_MDIRESTORE, 0, "WM_MDIRESTORE", "", "sig_", "", "" },
/* 0x0224 */  { WM_MDINEXT, 0, "WM_MDINEXT", "", "sig_", "", "" },
/* 0x0225 */  { WM_MDIMAXIMIZE, 0, "WM_MDIMAXIMIZE", "", "sig_", "", "" },
/* 0x0226 */  { WM_MDITILE, 0, "WM_MDITILE", "", "sig_", "", "" },
/* 0x0227 */  { WM_MDICASCADE, 0, "WM_MDICASCADE", "", "sig_", "", "" },
/* 0x0228 */  { WM_MDIICONARRANGE, 0, "WM_MDIICONARRANGE", "", "sig_", "", "" },
/* 0x0229 */  { WM_MDIGETACTIVE, 0, "WM_MDIGETACTIVE", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0230 */  { WM_MDISETMENU, 0, "WM_MDISETMENU", "", "sig_", "", "" },
/* 0x0231 */  { WM_ENTERSIZEMOVE, MT_WINDOW, "WM_ENTERSIZEMOVE", "", "sig_", "", "" },
/* 0x0232 */  { WM_EXITSIZEMOVE, MT_WINDOW, "WM_EXITSIZEMOVE", "", "sig_", "", "" },
/* 0x0233 */  { WM_DROPFILES, 0, "WM_DROPFILES", "", "sig_", "", "" },
/* 0x0234 */  { WM_MDIREFRESHMENU, 0, "WM_MDIREFRESHMENU", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0280 */  { WM_IME_REPORT, MTF_IMEDITOR, "WM_IME_REPORT", "", "sig_", "", "" },
/* 0x0281 */  { WM_IME_SETCONTEXT, MTF_IMEDITOR, "WM_IME_SETCONTEXT", "(BOOL=fSet)(DWORD=iShow)", "sig_", "", "" },
/* 0x0282 */  { WM_IME_NOTIFY, MTF_IMEDITOR, "WM_IME_NOTIFY", "(DWORD=dwCommand)(DWORD=dwData)", "sig_", "", "" },
/* 0x0283 */  { WM_IME_CONTROL, MTF_IMEDITOR, "WM_IME_CONTROL", "(DWORD=dwCommand)(DWORD=dwData)", "sig_", "", "" },
/* 0x0284 */  { WM_IME_COMPOSITIONFULL, MTF_IMEDITOR, "WM_IME_COMPOSITIONFULL", "()()", "sig_", "", "" },
/* 0x0285 */  { WM_IME_SELECT, MTF_IMEDITOR, "WM_IME_SELECT", "(BOOL=fSeleft)(HANDLE=hKL)", "sig_", "", "" },
/* 0x0286 */  { WM_IME_CHAR, MTF_IMEDITOR, "WM_IME_CHAR", "(char=chCharCode1,char=chCharCode2)()", "sig_", "", "" },
/* 0x0288 */  { WM_IME_REQUEST, MTF_IMEDITOR, "WM_IME_REQUEST", "(DWORD=dwRequest)(DWORD=dwData)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0290 */  { WM_IMEKEYDOWN, MTF_IMEDITOR, "WM_IMEKEYDOWN", "", "sig_", "", "" },
/* 0x0291 */  { WM_IMEKEYUP, MTF_IMEDITOR, "WM_IMEKEYUP", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x02A1 */  { WM_MOUSEHOVER, MT_MOUSEINPUT, "WM_MOUSEHOVER", "", "sig_", "", "The mouse hovered over the client area of the window for the period of time specified in a prior call to TrackMouseEvent" },
/* 0x02A2 */  { WM_MOUSELEAVE, MT_MOUSEINPUT, "WM_MOUSELEAVE", "", "sig_", "", "The mouse left the client area of the window specified in a prior call to TrackMouseEvent" },

/////////////////////////////////////////////////////////////////////////

/* 0x0300 */  { WM_CUT, MTF_CLIPBOARD, "WM_CUT", "(0)(0)", "sig_", "", "" },
/* 0x0301 */  { WM_COPY, MTF_CLIPBOARD, "WM_COPY", "(0)(0)", "sig_", "", "" },
/* 0x0302 */  { WM_PASTE, MTF_CLIPBOARD, "WM_PASTE", "(0)(0)", "sig_", "", "" },
/* 0x0303 */  { WM_CLEAR, MTF_CLIPBOARD, "WM_CLEAR", "(0)(0)", "sig_", "", "" },
/* 0x0304 */  { WM_UNDO, MTF_CLIPBOARD, "WM_UNDO", "(0)(0)", "sig_", "", "" },
/* 0x0305 */  { WM_RENDERFORMAT, MTF_CLIPBOARD, "WM_RENDERFORMAT", "(UINT=uFormat)()", "sig_", "", "" },
/* 0x0306 */  { WM_RENDERALLFORMATS, MTF_CLIPBOARD, "WM_RENDERALLFORMATS", "()()", "sig_", "", "" },
/* 0x0307 */  { WM_DESTROYCLIPBOARD, MTF_CLIPBOARD, "WM_DESTROYCLIPBOARD", "()()", "sig_", "", "" },
/* 0x0308 */  { WM_DRAWCLIPBOARD, MTF_CLIPBOARD, "WM_DRAWCLIPBOARD", "()()", "sig_", "", "" },
/* 0x0309 */  { WM_PAINTCLIPBOARD, MTF_CLIPBOARD, "WM_PAINTCLIPBOARD", "(HWND=hwndViewer)(HGLOBAL=hglbPs)", "sig_", "", "" },
/* 0x030A */  { WM_VSCROLLCLIPBOARD, MTF_CLIPBOARD, "WM_VSCROLLCLIPBOARD", "(HWND=hwndViewer)(int=nScrollCode,int=nPos)", "sig_", "", "" },
/* 0x030B */  { WM_SIZECLIPBOARD, MTF_CLIPBOARD, "WM_SIZECLIPBOARD", "(HWND=hwndViewer)(HGLOBAL=hglbRs)", "sig_", "", "" },
/* 0x030C */  { WM_ASKCBFORMATNAME, MTF_CLIPBOARD, "WM_ASKCBFORMATNAME", "(DWORD=cchName)(LPTSTR=lpszFormatName)", "sig_", "", "" },
/* 0x030D */  { WM_CHANGECBCHAIN, MTF_CLIPBOARD, "WM_CHANGECBCHAIN", "(HWND=hwndRemove)(HWND=hwndNext)", "sig_", "", "" },
/* 0x030E */  { WM_HSCROLLCLIPBOARD, MTF_CLIPBOARD, "WM_HSCROLLCLIPBOARD", "(HWND=hwndViewer)(int=nScrollCode,int=nPos)", "sig_", "", "" },
/* 0x030F */  { WM_QUERYNEWPALETTE, MT_COLOR, "WM_QUERYNEWPALETTE", "BOOL()()", "sig_", "", "Informs a window that it is about to receive the keyboard focus, giving the window the opportunity to realize its logical palette when it receives the focus" },

/////////////////////////////////////////////////////////////////////////

/* 0x0310 */  { WM_PALETTEISCHANGING, MT_COLOR, "WM_PALETTEISCHANGING", "0(HWND=hwndRealize)()", "sig_", "", "Informs applications that an application is going to realize its logical palette" },
/* 0x0311 */  { WM_PALETTECHANGED, MT_COLOR, "WM_PALETTECHANGED", "(HWND=hwndPalChg)()", "sig_", "", "sent to all top-level and overlapped windows after the window with the keyboard focus has realized its logical palette, thereby changing the system palette" },
/* 0x0312 */  { WM_HOTKEY, MT_KEYBOARDINPUT, "WM_HOTKEY", "(int=idHotKey)(UINT=fuModifiers,UINT=uVirtKey)", "sig_", "", "" },
/* 0x0317 */  { WM_PRINT, MT_PAINTINGDRAWING, "WM_PRINT", "(HDC=hdc)(=uFlags)", "sig_", "", "" },
/* 0x0318 */  { WM_PRINTCLIENT, MT_PAINTINGDRAWING, "WM_PRINTCLIENT", "(HDC=hdc)(=uFlags)", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0358 */  { WM_HANDHELDFIRST, 0, "WM_HANDHELDFIRST", "", "sig_", "", "" },
/* 0x035F */  { WM_HANDHELDLAST, 0, "WM_HANDHELDLAST", "", "sig_", "", "" },
/* 0x0369 */  { WM_AFXFIRST, 0, "WM_AFXFIRST", "", "sig_", "", "" },
/* 0x037F */  { WM_AFXLAST, 0, "WM_AFXLAST", "", "sig_", "", "" },
/* 0x0380 */  { WM_PENWINFIRST, 0, "WM_PENWINFIRST", "", "sig_", "", "" },
/* 0x038F */  { WM_PENWINLAST, 0, "WM_PENWINLAST", "", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x4000 */  { WM_USER, 0, "WM_USER", "", "sig_", "", "" },
/* 0x8000 */  { WM_APP, 0, "WM_APP", "", "sig_", "", "" },


/* 0x4000 */  { DM_GETDEFID, MT_DIALOGBOX, "DM_GETDEFID", "UINT()()", "sig_", "", "sends to retrieve the identifier of the default push button control for a dialog box" },
/* 0x4001 */  { DM_SETDEFID, MT_DIALOGBOX, "DM_SETDEFID", "TRUE(UINT=idControl)()", "sig_", "", "Change the identifier of the default push button for a dialog box" },
/* 0x4002 */  { DM_REPOSITION, MT_DIALOGBOX, "DM_REPOSITION", "(0)(0)", "sig_", "", "Repositions a top-level dialog box so that it fits within the desktop area" },


/////////////////////////////////////////////////////////////////////////
// Internal AFX Windows Messages (0x0360 - 0x037F are reserved for MFC)
/////////////////////////////////////////////////////////////////////////
/* 0x0360 */  { WM_QUERYAFXWNDPROC,        MTF_MFC, "WM_QUERYAFXWNDPROC",        "()()", "sig_", "", "" },
/* 0x0361 */  { WM_SIZEPARENT,             MTF_MFC, "WM_SIZEPARENT",             "()()", "sig_", "", "" },
/* 0x0362 */  { WM_SETMESSAGESTRING,       MTF_MFC, "WM_SETMESSAGESTRING",       "()()", "sig_", "", "" },
/* 0x0363 */  { WM_IDLEUPDATECMDUI,        MTF_MFC, "WM_IDLEUPDATECMDUI",        "(BOOL=bDisableIfNoHandler)(0)", "sig_", "", "Sent in idle time to implement the idle-time update of update-command UI handlers" },
/* 0x0364 */  { WM_INITIALUPDATE,          MTF_MFC, "WM_INITIALUPDATE",          "(0)(0)", "sig_vv", "Sent by the document template to all descendants of a frame window when it is safe for them to do their initial update" },
/* 0x0365 */  { WM_COMMANDHELP,            MTF_MFC, "WM_COMMANDHELP",            "()()", "sig_", "", "" },
/* 0x0366 */  { WM_HELPHITTEST,            MTF_MFC, "WM_HELPHITTEST",            "()()", "sig_", "", "" },
/* 0x0367 */  { WM_EXITHELPMODE,           MTF_MFC, "WM_EXITHELPMODE",           "()()", "sig_", "", "" },
/* 0x0368 */  { WM_RECALCPARENT,           MTF_MFC, "WM_RECALCPARENT",           "()()", "sig_", "", "" },
/* 0x0369 */  { WM_SIZECHILD,              MTF_MFC, "WM_SIZECHILD",              "()()", "sig_", "", "" },
/* 0x036A */  { WM_KICKIDLE,               MTF_MFC, "WM_KICKIDLE",               "()()", "sig_", "", "" },
/* 0x036B */  { WM_QUERYCENTERWND,         MTF_MFC, "WM_QUERYCENTERWND",         "()()", "sig_", "", "" },
/* 0x036C */  { WM_DISABLEMODAL,           MTF_MFC, "WM_DISABLEMODAL",           "()()", "sig_", "", "" },
/* 0x036D */  { WM_FLOATSTATUS,            MTF_MFC, "WM_FLOATSTATUS",            "()()", "sig_", "", "" },
/* 0x036E */  { WM_ACTIVATETOPLEVEL,       MTF_MFC, "WM_ACTIVATETOPLEVEL",       "()()", "sig_", "", "" },
/* 0x036F */  { WM_QUERY3DCONTROLS,        MTF_MFC, "WM_QUERY3DCONTROLS",        "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x0370 */  { WM_RESERVED_0370,          MTF_MFC, "WM_RESERVED_0370",          "()()", "sig_", "", "" },
/* 0x0371 */  { WM_RESERVED_0371,          MTF_MFC, "WM_RESERVED_0371",          "()()", "sig_", "", "" },
/* 0x0372 */  { WM_RESERVED_0372,          MTF_MFC, "WM_RESERVED_0372",          "()()", "sig_", "", "" },
/* 0x0373 */  { WM_SOCKET_NOTIFY,          MTF_MFC, "WM_SOCKET_NOTIFY",          "()()", "sig_", "", "" },
/* 0x0374 */  { WM_SOCKET_DEAD,            MTF_MFC, "WM_SOCKET_DEAD",            "()()", "sig_", "", "" },
/* 0x0375 */  { WM_POPMESSAGESTRING,       MTF_MFC, "WM_POPMESSAGESTRING",       "()()", "sig_", "", "" },
/* 0x0376 */  { WM_HELPPROMPTADDR,         MTF_MFC, "WM_HELPPROMPTADDR",         "()()", "sig_", "", "" },
/* 0x0376 */  { WM_OCC_LOADFROMSTREAM,     MTF_MFC, "WM_OCC_LOADFROMSTREAM",     "()()", "sig_", "", "" },
/* 0x0377 */  { WM_OCC_LOADFROMSTORAGE,    MTF_MFC, "WM_OCC_LOADFROMSTORAGE",    "()()", "sig_", "", "" },
/* 0x0378 */  { WM_OCC_INITNEW,            MTF_MFC, "WM_OCC_INITNEW",            "()()", "sig_", "", "" },
/* 0x037A */  { WM_OCC_LOADFROMSTREAM_EX,  MTF_MFC, "WM_OCC_LOADFROMSTREAM_EX",  "()()", "sig_", "", "" },
/* 0x037B */  { WM_OCC_LOADFROMSTORAGE_EX, MTF_MFC, "WM_OCC_LOADFROMSTORAGE_EX", "()()", "sig_", "", "" },
/* 0x0379 */  { WM_QUEUE_SENTINEL,         MTF_MFC, "WM_QUEUE_SENTINEL",         "()()", "sig_", "", "" },
/* 0x037C */  { WM_RESERVED_037C,          MTF_MFC, "WM_RESERVED_037C",          "()()", "sig_", "", "" },
/* 0x037D */  { WM_RESERVED_037D,          MTF_MFC, "WM_RESERVED_037D",          "()()", "sig_", "", "" },
/* 0x037E */  { WM_RESERVED_037E,          MTF_MFC, "WM_RESERVED_037E",          "()()", "sig_", "", "" },
/* 0x037F */  { WM_FORWARDMSG,             MTF_MFC, "WM_FORWARDMSG",             "()()", "sig_", "", "" },





/////////////////////////////////////////////////////////////////////////
// DDE Support Messages
/////////////////////////////////////////////////////////////////////////
/* 0x03E0 */  { WM_DDE_INITIATE,  MTF_DDE, "WM_DDE_INITIATE",  "()()", "sig_", "", "" },
/* 0x03E1 */  { WM_DDE_TERMINATE, MTF_DDE, "WM_DDE_TERMINATE", "()()", "sig_", "", "" },
/* 0x03E2 */  { WM_DDE_ADVISE,    MTF_DDE, "WM_DDE_ADVISE",    "()()", "sig_", "", "" },
/* 0x03E3 */  { WM_DDE_UNADVISE,  MTF_DDE, "WM_DDE_UNADVISE",  "()()", "sig_", "", "" },
/* 0x03E4 */  { WM_DDE_ACK,       MTF_DDE, "WM_DDE_ACK",       "()()", "sig_", "", "" },
/* 0x03E5 */  { WM_DDE_DATA,      MTF_DDE, "WM_DDE_DATA",      "()()", "sig_", "", "" },
/* 0x03E6 */  { WM_DDE_REQUEST,   MTF_DDE, "WM_DDE_REQUEST",   "()()", "sig_", "", "" },
/* 0x03E7 */  { WM_DDE_POKE,      MTF_DDE, "WM_DDE_POKE",      "()()", "sig_", "", "" },
/* 0x03E8 */  { WM_DDE_EXECUTE,   MTF_DDE, "WM_DDE_EXECUTE",   "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
// Control Panel Messages (WM_CPL_)
/////////////////////////////////////////////////////////////////////////
/* 0x43E8 */  { WM_CPL_LAUNCH,   0, "WM_CPL_LAUNCH",   "(HWND=hwnd)(LPSTR=lpszAppName)", "sig_", "", "" },
/* 0x43E9 */  { WM_CPL_LAUNCHED, 0, "WM_CPL_LAUNCHED", "(BOOL=fAppStarted)()",           "sig_", "", "" },

};



/////////////////////////////////////////////////////////////////////////
// Window Messages which can be sent to an AVICAP window (WM_CAP_)
/////////////////////////////////////////////////////////////////////////
static MESSAGEDESCRIPTION msgs_cap[] =
{
/* 0x4000 */  { WM_CAP_START,                    0, "WM_CAP_START",                    "()()", "sig_", "", "" },
/* 0x4001 */  { WM_CAP_GET_CAPSTREAMPTR,         0, "WM_CAP_GET_CAPSTREAMPTR",         "()()", "sig_", "", "" },
/* 0x4002 */  { WM_CAP_SET_CALLBACK_ERRORA,      0, "WM_CAP_SET_CALLBACK_ERRORA",      "()()", "sig_", "", "" },
/* 0x4003 */  { WM_CAP_SET_CALLBACK_STATUSA,     0, "WM_CAP_SET_CALLBACK_STATUSA",     "()()", "sig_", "", "" },
/* 0x4004 */  { WM_CAP_SET_CALLBACK_YIELD,       0, "WM_CAP_SET_CALLBACK_YIELD",       "()()", "sig_", "", "" },
/* 0x4005 */  { WM_CAP_SET_CALLBACK_FRAME,       0, "WM_CAP_SET_CALLBACK_FRAME",       "()()", "sig_", "", "" },
/* 0x4006 */  { WM_CAP_SET_CALLBACK_VIDEOSTREAM, 0, "WM_CAP_SET_CALLBACK_VIDEOSTREAM", "()()", "sig_", "", "" },
/* 0x4007 */  { WM_CAP_SET_CALLBACK_WAVESTREAM,  0, "WM_CAP_SET_CALLBACK_WAVESTREAM",  "()()", "sig_", "", "" },
/* 0x4008 */  { WM_CAP_GET_USER_DATA,            0, "WM_CAP_GET_USER_DATA",            "()()", "sig_", "", "" },
/* 0x4009 */  { WM_CAP_SET_USER_DATA,            0, "WM_CAP_SET_USER_DATA",            "()()", "sig_", "", "" },
/* 0x400A */  { WM_CAP_DRIVER_CONNECT,           0, "WM_CAP_DRIVER_CONNECT",           "()()", "sig_", "", "" },
/* 0x400B */  { WM_CAP_DRIVER_DISCONNECT,        0, "WM_CAP_DRIVER_DISCONNECT",        "()()", "sig_", "", "" },
/* 0x400C */  { WM_CAP_DRIVER_GET_NAMEA,         0, "WM_CAP_DRIVER_GET_NAMEA",         "()()", "sig_", "", "" },
/* 0x400D */  { WM_CAP_DRIVER_GET_VERSIONA,      0, "WM_CAP_DRIVER_GET_VERSIONA",      "()()", "sig_", "", "" },
/* 0x400E */  { WM_CAP_DRIVER_GET_CAPS,          0, "WM_CAP_DRIVER_GET_CAPS",          "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x4014 */  { WM_CAP_FILE_SET_CAPTURE_FILEA,   0, "WM_CAP_FILE_SET_CAPTURE_FILEA",   "()()", "sig_", "", "" },
/* 0x4015 */  { WM_CAP_FILE_GET_CAPTURE_FILEA,   0, "WM_CAP_FILE_GET_CAPTURE_FILEA",   "()()", "sig_", "", "" },
/* 0x4016 */  { WM_CAP_FILE_ALLOCATE,            0, "WM_CAP_FILE_ALLOCATE",            "()()", "sig_", "", "" },
/* 0x4017 */  { WM_CAP_FILE_SAVEASA,             0, "WM_CAP_FILE_SAVEASA",             "()()", "sig_", "", "" },
/* 0x4018 */  { WM_CAP_FILE_SET_INFOCHUNK,       0, "WM_CAP_FILE_SET_INFOCHUNK",       "()()", "sig_", "", "" },
/* 0x4019 */  { WM_CAP_FILE_SAVEDIBA,            0, "WM_CAP_FILE_SAVEDIBA",            "()()", "sig_", "", "" },
/* 0x401E */  { WM_CAP_EDIT_COPY,                0, "WM_CAP_EDIT_COPY",                "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x4023 */  { WM_CAP_SET_AUDIOFORMAT,          0, "WM_CAP_SET_AUDIOFORMAT",          "()()", "sig_", "", "" },
/* 0x4024 */  { WM_CAP_GET_AUDIOFORMAT,          0, "WM_CAP_GET_AUDIOFORMAT",          "()()", "sig_", "", "" },
/* 0x4029 */  { WM_CAP_DLG_VIDEOFORMAT,          0, "WM_CAP_DLG_VIDEOFORMAT",          "()()", "sig_", "", "" },
/* 0x402A */  { WM_CAP_DLG_VIDEOSOURCE,          0, "WM_CAP_DLG_VIDEOSOURCE",          "()()", "sig_", "", "" },
/* 0x402B */  { WM_CAP_DLG_VIDEODISPLAY,         0, "WM_CAP_DLG_VIDEODISPLAY",         "()()", "sig_", "", "" },
/* 0x402C */  { WM_CAP_GET_VIDEOFORMAT,          0, "WM_CAP_GET_VIDEOFORMAT",          "()()", "sig_", "", "" },
/* 0x402D */  { WM_CAP_SET_VIDEOFORMAT,          0, "WM_CAP_SET_VIDEOFORMAT",          "()()", "sig_", "", "" },
/* 0x402E */  { WM_CAP_DLG_VIDEOCOMPRESSION,     0, "WM_CAP_DLG_VIDEOCOMPRESSION",     "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////
	
/* 0x4032 */  { WM_CAP_SET_PREVIEW,              0, "WM_CAP_SET_PREVIEW",              "()()", "sig_", "", "" },
/* 0x4033 */  { WM_CAP_SET_OVERLAY,              0, "WM_CAP_SET_OVERLAY",              "()()", "sig_", "", "" },
/* 0x4034 */  { WM_CAP_SET_PREVIEWRATE,          0, "WM_CAP_SET_PREVIEWRATE",          "()()", "sig_", "", "" },
/* 0x4035 */  { WM_CAP_SET_SCALE,                0, "WM_CAP_SET_SCALE",                "()()", "sig_", "", "" },
/* 0x4036 */  { WM_CAP_GET_STATUS,               0, "WM_CAP_GET_STATUS",               "()()", "sig_", "", "" },
/* 0x4037 */  { WM_CAP_SET_SCROLL,               0, "WM_CAP_SET_SCROLL",               "()()", "sig_", "", "" },
/* 0x403C */  { WM_CAP_GRAB_FRAME,               0, "WM_CAP_GRAB_FRAME",               "()()", "sig_", "", "" },
/* 0x403D */  { WM_CAP_GRAB_FRAME_NOSTOP,        0, "WM_CAP_GRAB_FRAME_NOSTOP",        "()()", "sig_", "", "" },
/* 0x403E */  { WM_CAP_SEQUENCE,                 0, "WM_CAP_SEQUENCE",                 "()()", "sig_", "", "" },
/* 0x403F */  { WM_CAP_SEQUENCE_NOFILE,          0, "WM_CAP_SEQUENCE_NOFILE",          "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x4040 */  { WM_CAP_SET_SEQUENCE_SETUP,       0, "WM_CAP_SET_SEQUENCE_SETUP",       "()()", "sig_", "", "" },
/* 0x4041 */  { WM_CAP_GET_SEQUENCE_SETUP,       0, "WM_CAP_GET_SEQUENCE_SETUP",       "()()", "sig_", "", "" },
/* 0x4042 */  { WM_CAP_SET_MCI_DEVICEA,          0, "WM_CAP_SET_MCI_DEVICEA",          "()()", "sig_", "", "" },
/* 0x4043 */  { WM_CAP_GET_MCI_DEVICEA,          0, "WM_CAP_GET_MCI_DEVICEA",          "()()", "sig_", "", "" },
/* 0x4044 */  { WM_CAP_STOP,                     0, "WM_CAP_STOP",                     "()()", "sig_", "", "" },
/* 0x4045 */  { WM_CAP_ABORT,                    0, "WM_CAP_ABORT",                    "()()", "sig_", "", "" },
/* 0x4046 */  { WM_CAP_SINGLE_FRAME_OPEN,        0, "WM_CAP_SINGLE_FRAME_OPEN",        "()()", "sig_", "", "" },
/* 0x4047 */  { WM_CAP_SINGLE_FRAME_CLOSE,       0, "WM_CAP_SINGLE_FRAME_CLOSE",       "()()", "sig_", "", "" },
/* 0x4048 */  { WM_CAP_SINGLE_FRAME,             0, "WM_CAP_SINGLE_FRAME",             "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x4050 */  { WM_CAP_PAL_OPENA,                0, "WM_CAP_PAL_OPENA",                "()()", "sig_", "", "" },
/* 0x4051 */  { WM_CAP_PAL_SAVEA,                0, "WM_CAP_PAL_SAVEA",                "()()", "sig_", "", "" },
/* 0x4052 */  { WM_CAP_PAL_PASTE,                0, "WM_CAP_PAL_PASTE",                "()()", "sig_", "", "" },
/* 0x4053 */  { WM_CAP_PAL_AUTOCREATE,           0, "WM_CAP_PAL_AUTOCREATE",           "()()", "sig_", "", "" },
/* 0x4054 */  { WM_CAP_PAL_MANUALCREATE,         0, "WM_CAP_PAL_MANUALCREATE",         "()()", "sig_", "", "" },
/* 0x4055 */  { WM_CAP_SET_CALLBACK_CAPCONTROL,  0, "WM_CAP_SET_CALLBACK_CAPCONTROL",  "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x4064 */  { WM_CAP_UNICODE_START,            0, "WM_CAP_UNICODE_START",            "()()", "sig_", "", "" },
/* 0x4065 */  { WM_CAP_SET_CALLBACK_ERRORW,      0, "WM_CAP_SET_CALLBACK_ERRORW",      "()()", "sig_", "", "" },
/* 0x4066 */  { WM_CAP_SET_CALLBACK_STATUSW,     0, "WM_CAP_SET_CALLBACK_STATUSW",     "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x4070 */  { WM_CAP_DRIVER_GET_NAMEW,         0, "WM_CAP_DRIVER_GET_NAMEW",         "()()", "sig_", "", "" },
/* 0x4071 */  { WM_CAP_DRIVER_GET_VERSIONW,      0, "WM_CAP_DRIVER_GET_VERSIONW",      "()()", "sig_", "", "" },
/* 0x4078 */  { WM_CAP_FILE_SET_CAPTURE_FILEW,   0, "WM_CAP_FILE_SET_CAPTURE_FILEW",   "()()", "sig_", "", "" },
/* 0x4079 */  { WM_CAP_FILE_GET_CAPTURE_FILEW,   0, "WM_CAP_FILE_GET_CAPTURE_FILEW",   "()()", "sig_", "", "" },
/* 0x407B */  { WM_CAP_FILE_SAVEASW,             0, "WM_CAP_FILE_SAVEASW",             "()()", "sig_", "", "" },
/* 0x407D */  { WM_CAP_FILE_SAVEDIBW,            0, "WM_CAP_FILE_SAVEDIBW",            "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x40A6 */  { WM_CAP_SET_MCI_DEVICEW,          0, "WM_CAP_SET_MCI_DEVICEW",          "()()", "sig_", "", "" },
/* 0x40A7 */  { WM_CAP_GET_MCI_DEVICEW,          0, "WM_CAP_GET_MCI_DEVICEW",          "()()", "sig_", "", "" },

/////////////////////////////////////////////////////////////////////////

/* 0x40B4 */  { WM_CAP_PAL_OPENW,                0, "WM_CAP_PAL_OPENW",                "()()", "sig_", "", "" },
/* 0x40B5 */  { WM_CAP_PAL_SAVEW,                0, "WM_CAP_PAL_SAVEW",                "()()", "sig_", "", "" },
};




/////////////////////////////////////////////////////////////////////////
// USER
/////////////////////////////////////////////////////////////////////////
static MESSAGEDESCRIPTION msgs_user[] =
{

/////////////////////////////////////////////////////////////////////////
// Page Setup Dialog Box Messages (WM_PSD_)
/////////////////////////////////////////////////////////////////////////
/* 0x4000 */  { WM_PSD_PAGESETUPDLG, 0, "WM_PSD_PAGESETUPDLG", "()()", "sig_", "", "" },
/* 0x4001 */  { WM_PSD_FULLPAGERECT, 0, "WM_PSD_FULLPAGERECT", "()()", "sig_", "", "" },
/* 0x4002 */  { WM_PSD_MINMARGINRECT, 0, "WM_PSD_MINMARGINRECT", "()()", "sig_", "", "" },
/* 0x4003 */  { WM_PSD_MARGINRECT, 0, "WM_PSD_MARGINRECT", "()()", "sig_", "", "" },
/* 0x4004 */  { WM_PSD_GREEKTEXTRECT, 0, "WM_PSD_GREEKTEXTRECT", "()()", "sig_", "", "" },
/* 0x4005 */  { WM_PSD_ENVSTAMPRECT, 0, "WM_PSD_ENVSTAMPRECT", "()()", "sig_", "", "" },
/* 0x4006 */  { WM_PSD_YAFULLPAGERECT, 0, "WM_PSD_YAFULLPAGERECT", "()()", "sig_", "", "" },


/////////////////////////////////////////////////////////////////////////
// Common Dialog Messages (CDM_)
/////////////////////////////////////////////////////////////////////////
/* 0x4065 */  { CDM_GETFILEPATH, 0, "CDM_GETFILEPATH", "()()", "sig_", "", "" },
/* 0x4066 */  { CDM_GETFOLDERPATH, 0, "CDM_GETFOLDERPATH", "()()", "sig_", "", "" },
/* 0x4067 */  { CDM_GETFOLDERIDLIST, 0, "CDM_GETFOLDERIDLIST", "()()", "sig_", "", "" },
/* 0x4068 */  { CDM_SETCONTROLTEXT, 0, "CDM_SETCONTROLTEXT", "()()", "sig_", "", "" },
/* 0x4069 */  { CDM_HIDECONTROL, 0, "CDM_HIDECONTROL", "()()", "sig_", "", "" },
/* 0x406A */  { CDM_SETDEFEXT, 0, "CDM_SETDEFEXT", "()()", "sig_", "", "" },


/////////////////////////////////////////////////////////////////////////
// Font Dialog Box Messages (WM_CHOOSEFONT_)
/////////////////////////////////////////////////////////////////////////
/* 0x4001 */  { WM_CHOOSEFONT_GETLOGFONT, 0, "WM_CHOOSEFONT_GETLOGFONT", "()()", "sig_", "", "" },
/* 0x4065 */  { WM_CHOOSEFONT_SETLOGFONT, 0, "WM_CHOOSEFONT_SETLOGFONT", "()()", "sig_", "", "" },
/* 0x4066 */  { WM_CHOOSEFONT_SETFLAGS, 0, "WM_CHOOSEFONT_SETFLAGS", "()()", "sig_", "", "" },
};




/*

REFIID		#
obsolette	!
mark		-
return		0
return		1
unknown		?
int			i
BOOL		b

 No	message                    ret	SIG					function

  1 WM_ACTIVATE                 0	30 sig_vupWb		void OnActivate(UINT nState, EWnd* pWndOther, BOOL bMinimized);
  2 WM_ACTIVATEAPP              0	16 sig_vbu			void OnActivateApp(BOOL bActive, DWORD dwThreadID);
  3 WM_AFXFIRST                 -
  4 WM_AFXLAST                  -
  5 WM_APP                      -
  6 WM_ASKCBFORMATNAME          0	43 sig_vus			void OnAskCbFormatName(UINT nMaxCount, LPTSTR lpszFormatName);
  7 WM_CANCELJOURNAL            v						
  8 WM_CANCELMODE               0	14 sig_vv			void OnCancelMode();
  9 WM_CAPTURECHANGED           0	25 sig_vpW			void OnCaptureChanged(EWnd* pWnd);
 10 WM_CHANGECBCHAIN            0	16 sig_vhh			void OnChangeCbChain(HWND hWndRemove, HWND hWndAfter);
 11 WM_CHAR                     0	18 sig_vuuu			void OnChar(UINT nChar, UINT nRepeatCount, UINT nFlags);
 12 WM_CHARTOITEM               i	08 sig_iupWu		int OnCharToItem(UINT nKey, EListBox* pListBox, UINT nCaretPos);
 13 WM_CHILDACTIVATE            0	14 sig_vv			void OnChildActivate();
 14 WM_CLEAR                    v						
= 15 WM_CLOSE                    0	14 sig_vv			void OnClose();
 16 WM_COMMAND                  0						
 17 WM_COMMNOTIFY               ?
 18 WM_COMPACTING               0	15 sig_vu			void OnCompacting(UINT nCpuTime);
 19 WM_COMPAREITEM              i	35 sig_iis			int OnCompareItem(int nCtrID, LPCOMPAREITEMSTRUCT lpCompareItemStruct);
 20 WM_CONTEXTMENU              v	26 sig_vpWii		void OnContextMenu(EWnd* pWnd, int xPos, int yPos)
 21 WM_CONVERTREQUEST           ?
 22 WM_CONVERTRESULT            ?
 23 WM_COPY                     v						
= 24 WM_COPYDATA                 b	05 sig_bpWCDS		BOOL OnCopyData(EWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
= 25 WM_CREATE                   i	11 sig_is			int OnCreate(LPCREATESTRUCT lpCreateStruct);
 26 WM_CTLCOLORBTN              h						
 27 WM_CTLCOLORDLG              h						
 28 WM_CTLCOLOREDIT             h						
 29 WM_CTLCOLORLISTBOX          h						
 30 WM_CTLCOLORMSGBOX           !
 31 WM_CTLCOLORSCROLLBAR        h						
 32 WM_CTLCOLORSTATIC           h						
 33 WM_CUT                      v						
 34 WM_DDE_ACK                  =
 35 WM_DDE_ADVISE               =
 36 WM_DDE_DATA                 =
 37 WM_DDE_EXECUTE              =
 38 WM_DDE_INITIATE             =
 39 WM_DDE_POKE                 =
 40 WM_DDE_REQUEST              =
 41 WM_DDE_TERMINATE            =
 42 WM_DDE_UNADVISE             =
 43 WM_DEADCHAR                 0	18 sig_vuuu			void OnDeadChar(UINT nChar, UINT nRepeatCount, UINT nFlags);
 44 WM_DELETEITEM               b	34 sig_visx			void OnDeleteItem(int nCtrID, LPDELETEITEMSTRUCT lpDeleteItemStruct);
= 45 WM_DESTROY                  0	14 sig_vv			void OnDestroy();
 46 WM_DESTROYCLIPBOARD         0	14 sig_vv			void OnDestroyClipboard();
 47 WM_DEVICECHANGE             b	12 sig_bwl			BOOL OnDeviceChange(UINT nEventType, DWORD dwData);
 48 WM_DEVMODECHANGE            0	33 sig_vs			void OnDevModeChange(LPTSTR lpDeviceName);
 49 WM_DISPLAYCHANGE            0						
 50 WM_DRAWCLIPBOARD            0	14 sig_vv			void OnDrawClipboard();
 51 WM_DRAWITEM                 1	34 sig_visx			void OnDrawItem(int nCtrID, LPDRAWITEMSTRUCT lpDrawItemStruct);
 52 WM_DROPFILES                0	15 sig_vh			void OnDropFiles(HDROP hDropInfo);
 53 WM_ENABLE                   0	15 sig_vb			void OnEnable(BOOL bEnable);
 54 WM_ENDSESSION               0	15 sig_vb			void OnEndSession(BOOL bEnding);
 55 WM_ENTERIDLE                0	29 sig_vupW			void OnEnterIdle(UINT uSource, EWnd* pWnd);
 56 WM_ENTERMENULOOP            0	15 sig_vb			void OnEnterMenuLoop(BOOL bTrackPopupMenu);
 57 WM_ENTERSIZEMOVE            0						
 58 WM_ERASEBKGND               b	01 sig_bhDC			BOOL OnEraseBkgnd(HDC hDC);
 59 WM_EXITMENULOOP             0	15 sig_vb			void OnExitMenuLoop(BOOL bTrackPopupMenu);
 60 WM_EXITSIZEMOVE             0						
 61 WM_FONTCHANGE               v	14 sig_vv			void OnFontChange();
 62 WM_GETDLGCODE               u	37 sig_uv			UINT OnGetDlgCode();
 63 WM_GETFONT                  h						
 64 WM_GETHOTKEY                u						
 65 WM_GETICON                  h						
 66 WM_GETMINMAXINFO            0	33 sig_vs			void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
 67 WM_GETOBJECT                #						
 68 WM_GETTEXT                  i						
 69 WM_GETTEXTLENGTH            i						
 70 WM_HANDHELDFIRST            -
 71 WM_HANDHELDLAST             -
 72 WM_HELP                     1	04 sig_bHELPINFO	void OnHelp(HELPINFO* lpHelpInfo);
 73 WM_HOTKEY                   0						
 74 WM_HSCROLL                  0						//void OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
 75 WM_HSCROLLCLIPBOARD         0	26 sig_vpWii		void OnHScrollClipboard(EWnd* pClipAppWnd, int nScrollCode, int nPos);
 76 WM_ICONERASEBKGND           1	22 sig_vhDC			void OnIconEraseBkgnd(HDC hDC);
 77 WM_IME_CHAR                 =
 78 WM_IME_COMPOSITION          =
 79 WM_IME_COMPOSITIONFULL      =
 80 WM_IME_CONTROL              =
 81 WM_IME_ENDCOMPOSITION       =
 82 WM_IME_NOTIFY               =
 83 WM_IME_REPORT               =
 84 WM_IME_REQUEST              =
 85 WM_IME_SELECT               =
 86 WM_IME_SETCONTEXT           =
 87 WM_IME_STARTCOMPOSITION     =
 88 WM_IMEKEYDOWN               =
 89 WM_IMEKEYUP                 =
 90 WM_INITDIALOG               b						
 91 WM_INITMENU                 0	23 sig_vhMn			void OnInitMenu(HMENU hMenu);
 92 WM_INITMENUPOPUP            0	24 sig_vhMnub		void OnInitMenuPopup(HMENU hPopupMenu, UINT nIndex, BOOL bSysMenu);
 93 WM_INPUTLANGCHANGE          1						
 94 WM_INPUTLANGCHANGEREQUEST   i						
 95 WM_INTERIM                  ?
 96 WM_KEYDOWN                  0	18 sig_vuuu			void OnKeyDown(UINT nVirtKey, UINT nRepeatCount, UINT nFlags);
 97 WM_KEYLAST                  -
 98 WM_KEYUP                    0	18 sig_vuuu			void OnKeyUp(UINT nVirtKey, UINT nRepeatCount, UINT nFlags);
 99 WM_KILLFOCUS                0	25 sig_vpW			void OnKillFocus(EWnd* pNewWnd);
100 WM_LBUTTONDBLCLK            0	19 sig_vuii			void OnLButtonDblClk(UINT nFlags, int xPos, int yPos);
101 WM_LBUTTONDOWN              0	19 sig_vuii			void OnLButtonDown(UINT nFlags, int xPos, int yPos);
102 WM_LBUTTONUP                0	19 sig_vuii			void OnLButtonUp(UINT nFlags, int xPos, int yPos);
103 WM_MBUTTONDBLCLK            0	19 sig_vuii			void OnMButtonDblClk(UINT nFlags, int xPos, int yPos);
104 WM_MBUTTONDOWN              0	19 sig_vuii			void OnMButtonDown(UINT nFlags, int xPos, int yPos);
105 WM_MBUTTONUP                0	19 sig_vuii			void OnMButtonUp(UINT nFlags, int xPos, int yPos);
106 WM_MDIACTIVATE              0	20 sig_vbpWpW		void OnMDIActivate(BOOL bActivate, EWnd* pActivateWnd, EWnd* pDeactivateWnd);
107 WM_MDICASCADE               b						
108 WM_MDICREATE                h						
109 WM_MDIDESTROY               0						
110 WM_MDIGETACTIVE             h						
111 WM_MDIICONARRANGE           v						
112 WM_MDIMAXIMIZE              0						
113 WM_MDINEXT                  0						
114 WM_MDIREFRESHMENU           h						
115 WM_MDIRESTORE               0						
116 WM_MDISETMENU               h						
117 WM_MDITILE                  b						
118 WM_MEASUREITEM              1	34 sig_visx			void OnMeasureItem(int nCtrID, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
119 WM_MENUCHAR                 r	13 sig_ruuhMn		LRESULT OnMenuChar(UINT nChar, UINT nFlags, EMenu* pMenu);
120 WM_MENUCOMMAND              ?
121 WM_MENUDRAG                 ?
122 WM_MENUGETOBJECT            ?
123 WM_MENURBUTTONUP            ?
124 WM_MENUSELECT               0	41 sig_vuuh			void OnMenuSelect(UINT nItemID, UINT nFlags HMENU hSysMenu);
125 WM_MOUSEACTIVATE            u	10 sig_ipWuu		int OnMouseActivate(EWnd* pWndTopLevel, UINT nHitTest, UINT uMouseMsg);
126 WM_MOUSEHOVER               ?
127 WM_MOUSELEAVE               ?
128 WM_MOUSEMOVE                0	19 sig_vuii			void OnMouseMove(UINT nFlags, int xPos, int yPos);
129 WM_MOUSEWHEEL               u	42 sig_busii		BOOL OnMouseWheel(UINT nFlags, short zDelta, int xPos, int yPos);
=130 WM_MOVE                     0	17 sig_vvii			void OnMove(int xPos, int yPos);
131 WM_MOVING                   1	44 sig_vupRECT		void OnMoving(UINT nSide, LPRECT lpRect);
132 WM_NCACTIVATE               b	02 sig_bb			BOOL OnNcActivate(BOOL bActive);
133 WM_NCCALCSIZE               u	39 sig_vCALC		void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
134 WM_NCCREATE                 b	11 sig_is			BOOL OnNcCreate(LPCREATESTRUCT lpCreateStruct);
135 WM_NCDESTROY                0	14 sig_vv			void OnNcDestroy();
136 WM_NCHITTEST                u	36 sig_uii			UINT OnNcHitTest(int xPos, int yPos);
137 WM_NCLBUTTONDBLCLK          0	19 sig_vuii			void OnNcLButtonDblClk(UINT nHitTest, int xPos, int yPos);
138 WM_NCLBUTTONDOWN            0	19 sig_vuii			void OnNcLButtonDown(UINT nHitTest, int xPos, int yPos);
139 WM_NCLBUTTONUP              0	19 sig_vuii			void OnNcLButtonUp(UINT nHitTest, int xPos, int yPos);
140 WM_NCMBUTTONDBLCLK          0	19 sig_vuii			void OnNcMButtonDblClk(UINT nHitTest, int xPos, int yPos);
141 WM_NCMBUTTONDOWN            0	19 sig_vuii			void OnNcMButtonDown(UINT nHitTest, int xPos, int yPos);
142 WM_NCMBUTTONUP              0	19 sig_vuii			void OnNcMButtonUp(UINT nHitTest, int xPos, int yPos);
143 WM_NCMOUSEMOVE              0	19 sig_vuii			void OnNcMouseMove(UINT nHitTest, int xPos, int yPos);
144 WM_NCPAINT                  0	45 sig_vHRGN		void OnNcPaint(HRGN hRgn);
145 WM_NCRBUTTONDBLCLK          0	19 sig_vuii			void OnNcRButtonDblClk(UINT nHitTest, int xPos, int yPos);
146 WM_NCRBUTTONDOWN            0	19 sig_vuii			void OnNcRButtonDown(UINT nHitTest, int xPos, int yPos);
147 WM_NCRBUTTONUP              0	19 sig_vuii			void OnNcRButtonUp(UINT nHitTest, int xPos, int yPos);
148 WM_NEXTDLGCTL               0						
149 WM_NEXTMENU                 0						
150 WM_NOTIFY                   v						
151 WM_NOTIFYFORMAT             u						
152 WM_NULL                     -
153 WM_PAINT                    0	22 sig_vhDC			void OnPaint(HDC hDC);
154 WM_PAINTCLIPBOARD           0	28 sig_vpWh			void OnPaintClipboard(EWnd* pClipAppWnd, HGLOBAL hPaintStruct);
155 WM_PAINTICON                0						
156 WM_PALETTECHANGED           0	25 sig_vpW			void OnPaletteChanged(EWnd* pFocusWnd);
157 WM_PALETTEISCHANGING        0	25 sig_vpW			void OnPaletteIsChanging(EWnd* pRealizeWnd);
158 WM_PARENTNOTIFY             0	46 sig_vul			void OnParentNotify(UINT uData, LPARAM lParam);
159 WM_PASTE                    v						
160 WM_PENWINFIRST              -
161 WM_PENWINLAST               -
162 WM_POWER                    u						
163 WM_POWERBROADCAST           u						
164 WM_PRINT                    0						
165 WM_PRINTCLIENT              0						
166 WM_QUERYDRAGICON            h	37 sig_hv			HCURSOR OnQueryDragIcon();
167 WM_QUERYENDSESSION          b	37 sig_bv			BOOL OnQueryEndSession();
168 WM_QUERYNEWPALETTE          b	37 sig_bv			BOOL OnQueryNewPalette();
169 WM_QUERYOPEN                b	37 sig_bv			BOOL OnQueryOpen();
170 WM_QUEUESYNC                0						
171 WM_QUIT                     u						
172 WM_RBUTTONDBLCLK            0	19 sig_vuii			void OnRButtonDblClk(UINT nFlags, int xPos, int yPos);
173 WM_RBUTTONDOWN              0	19 sig_vuii			void OnRButtonDown(UINT nFlags, int xPos, int yPos);
174 WM_RBUTTONUP                0	19 sig_vuii			void OnRButtonUp(UINT nFlags, int xPos, int yPos);
175 WM_RENDERALLFORMATS         0	14 sig_vv			void OnRenderAllFormats();
176 WM_RENDERFORMAT             0	15 sig_vu			void OnRenderFormat(UINT nFormat);
177 WM_SETCURSOR                b	03 sig_bpWuu		BOOL OnSetCursor(EWnd* pWnd, UINT nHitTest, UINT uMouseMsg);
178 WM_SETFOCUS                 0	25 sig_vpW			void OnSetFocus(EWnd* pOldWnd);
179 WM_SETFONT                  v						
180 WM_SETHOTKEY                i						
181 WM_SETICON                  h						
182 WM_SETREDRAW                0						
183 WM_SETTEXT                  b						
184 WM_SHOWWINDOW               0	16 sig_vbu			void OnShowWindow(BOOL bShow, UINT nStatus);
=185 WM_SIZE                     0	19 sig_vuii			void OnSize(UINT nType, int cx, int cy);
186 WM_SIZECLIPBOARD            0	28 sig_vpWh			void OnSizeClipboard(EWnd* pClipAppWnd, HGLOBAL hRect);
187 WM_SIZING                   1	44 sig_vupRECT		void OnSizing(UINT nSide, LPRECT lpRect);
188 WM_SPOOLERSTATUS            0	16 sig_vuu			void OnSpoolerStatus(UINT uJobStatus, UINT nJobs);
189 WM_STYLECHANGED             0	46 sig_viSS			void OnStyleChanged(int nStyleType, LPSTYLESTRUCT lpStyleStruct);
190 WM_STYLECHANGING            0	46 sig_viSS			void OnStyleChanging(int nStyleType, LPSTYLESTRUCT lpStyleStruct);
191 WM_SYNCPAINT                0						
192 WM_SYSCHAR                  0	18 sig_vuuu			void OnSysChar(UINT nChar, UINT nRepeatCount, UINT nFlags);
193 WM_SYSCOLORCHANGE           0	14 sig_vv			void OnSysColorChange();
194 WM_SYSCOMMAND               0	46 sig_vul			void OnSysCommand(UINT nID, LPARAM lParam);
195 WM_SYSDEADCHAR              0	18 sig_vuuu			void OnSysDeadChar(UINT nChar, UINT nRepeatCount, UINT nFlags);
196 WM_SYSKEYDOWN               0	18 sig_vuuu			void OnSysKeyDown(UINT nVirtKey, UINT nRepeatCount, UINT nFlags);
197 WM_SYSKEYUP                 0	18 sig_vuuu			void OnSysKeyUp(UINT nVirtKey, UINT nRepeatCount, UINT nFlags);
198 WM_TCARD                    0	46 sig_vul			void OnTCard(UINT idAction, DWORD dwActionData);
199 WM_TIMECHANGE               0	14 sig_vv			void OnTimeChange();
200 WM_TIMER                    0	43 sig_vus			void OnTimer(UINT uTimerID, TIMERPROC ppTimerProc);
201 WM_UNDO                     b						
202 WM_UNINITMENUPOPUP          ?
203 WM_USER                     -
204 WM_USERCHANGED              0						
205 WM_VKEYTOITEM               i	08 sig_iupWu		int OnVKeyToItem(UINT nKey, EListBox* pListBox, UINT nCaretPos);
206 WM_VSCROLL                  0						//void OnVScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
207 WM_VSCROLLCLIPBOARD         0	26 sig_vpWii		void OnVScrollClipboard(EWnd* pClipAppWnd, int nScrollCode, int nPos );
208 WM_WINDOWPOSCHANGED         0	38 sig_vPOS			void OnWindowPosChanged(WINDOWPOS* lpWndPos);
209 WM_WINDOWPOSCHANGING        0	38 sig_vPOS			void OnWindowPosChanging(WINDOWPOS* lpWndPos);
210 WM_WININICHANGE             0	33 sig_vs			void OnWinIniChange(LPTSTR lpszSection);
211 WM_WNT_CONVERTREQUESTEX     ?

212 WM_SETTINGCHANGE            0	43 sig_vus			void OnSettingChange(LPTSTR lpszSection);

*/





/////////////////////////////////////////////////////////////////////////////
#endif // USED_MESSAGES

/////////////////////////////////////////////////////////////////////////////
#endif // __MESSAGES_H__