// MessagesFunc.h : header file
//

#ifndef __MESSAGESFUNC_H__
#define __MESSAGESFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


#include "Messages.h"


/////////////////////////////////////////////////////////////////////////////
//  MessagesFunc.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_MESSAGESFUNC   "08.03.2011"


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
#ifdef USED_MESSAGES



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline MESSAGEINFO* _EcxMessageInfo(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i;
	memset(&g_msginf, 0, sizeof(MESSAGEINFO));
	sprintf(g_strMsgName, "0x%.4X", uMsg);
	g_msginf.lpszMsgName = g_strMsgName;

	if(uMsg <= 0x0400) g_msginf = g_msginfSystem[uMsg];
	

	///////////////////////////////////////////////////////////
	// 0x1100 - 0x1200: TreeView messages
	///////////////////////////////////////////////////////////
	if(__in10(uMsg, 0x1100, 0x1200))
	{
		g_msginf.uType = MT_TREEVIEW;
		for(i=0; i<_array_count(g_msginfTreeView, MESSAGEINFO); i++)
		{
			if(g_msginfTreeView[i].uMsg == uMsg)
			{
				g_msginf = g_msginfTreeView[i];
				break;
			}
		}

	}
	
	return &g_msginf;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline void _EcxSaveMessage(LPCTSTR lpszFileName, HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, int nMode = 0)
{
	FILE* hFile = fopen(lpszFileName, "w+");
	fclose(hFile);
	
	hFile = fopen(lpszFileName, "a+");

	switch(nMode)
	{
		case 0:
		{
			MESSAGEINFO* pMsginf = _EcxMessageInfo(uMsg, wParam, lParam);
			fprintf(hFile, "%s\n", pMsginf->lpszMsgName);
			break;
		}

		case 1:
		{
			sprintf(g_strMsgName, "0x%.4X", uMsg);
			fprintf(hFile, "%s\n", g_strMsgName);
			break;
		}
	}


}

#else

/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline MESSAGEINFO* _EcxMessageInfo(UINT uMsg, WPARAM wParam, LPARAM lParam) { return NULL; }
inline void _EcxSaveMessage(LPCTSTR lpszFileName, HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, int nMode = 0) {}


////////////////////////////////////////////////////////////////////////////
#endif // USED_MESSAGES

////////////////////////////////////////////////////////////////////////////
#endif // __MESSAGESFUNC_H__
