// EWindowPlacement.h : header file
//

#ifndef __EWINDOWPLACEMENT_H__
#define __EWINDOWPLACEMENT_H__
#pragma once


/////////////////////////////////////////////////////////////////////////////
//  EWindowPlacement.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_EWINDOWPLACEMENT   "04.02.2013"


#include "..\..\TextParsing\EConfig.h"

//  WINDOWPLACEMENT       .
// mk:@MSITStore:C:\Program%20Files\Microsoft%20Visual%20Studio\MSDN98\98VS\1033\winui.chm::/devdoc/live/pdui/windows_9lki.htm
// mk:@MSITStore:C:\Program%20Files\Microsoft%20Visual%20Studio\MSDN\2001OCT\1033\winui.chm::/hh/winui/windows_9lki.htm



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
struct EWindowPlacement : public WINDOWPLACEMENT  // wp
{
	EWindowPlacement();
	~EWindowPlacement();

	void Initialize(HWND hWnd, EConfig* pCfg);
	BOOL Load(LPCSTR szCfgFileName, LPCSTR szPath, LPCSTR szName, BOOL isRemove = TRUE);
	void Save(LPCSTR szCfgFileName, LPCSTR szPath, LPCSTR szName);
	void Restore();
	void PosChanged();
	
	
	HWND m_hWnd;
	EConfig* m_pCfg;
	RECT m_rcRestore;
	void _SetRestoreRect();
};


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline EWindowPlacement::EWindowPlacement()
{
	memset(this, 0, sizeof(WINDOWPLACEMENT));
	length = sizeof(WINDOWPLACEMENT);
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
inline EWindowPlacement::~EWindowPlacement()
{
}


/////////////////////////////////////////////////////////////////////////////
//         
//    
/////////////////////////////////////////////////////////////////////////////
inline void EWindowPlacement::Initialize(HWND hWnd, EConfig* pCfg)
{
	m_hWnd = hWnd;
	m_pCfg = pCfg;
}


/////////////////////////////////////////////////////////////////////////////
//   -   
/////////////////////////////////////////////////////////////////////////////
inline void EWindowPlacement::_SetRestoreRect()
{
	::SystemParametersInfo(SPI_GETWORKAREA, 0, &m_rcRestore, 0);
	int dx = 60;
	int dy = 60;
	::InflateRect(&m_rcRestore, -dx, -dy);
	rcNormalPosition = m_rcRestore;
}


/////////////////////////////////////////////////////////////////////////////
//     szCfgFileName   
//    szPath   szName.
/////////////////////////////////////////////////////////////////////////////
inline BOOL EWindowPlacement::Load(LPCSTR szCfgFileName, LPCSTR szPath, LPCSTR szName, BOOL isRemove)
{
//	if(!m_pCfg) return FALSE;
//	if(!m_hWnd) return FALSE;

	BOOL res;
	if(res = (BOOL)m_pCfg->Load(szCfgFileName))
	{
		m_pCfg->Parse();
		res = m_pCfg->ReadWindowPlacement(szPath, szName, this);
	}

	if(!res)
	{
		_SetRestoreRect();
		showCmd = SW_SHOWMAXIMIZED;
	}
	else
	{
		m_rcRestore = rcNormalPosition;
	}

	::SetWindowPlacement(m_hWnd, this);
	if(isRemove) m_pCfg->Remove();
	return res;
}


/////////////////////////////////////////////////////////////////////////////
//     szCfgFileName   
//    szPath   szName.
/////////////////////////////////////////////////////////////////////////////
inline void EWindowPlacement::Save(LPCSTR szCfgFileName, LPCSTR szPath, LPCSTR szName)
{
	::GetWindowPlacement(m_hWnd, this);
	rcNormalPosition = m_rcRestore;

	m_pCfg->WriteWindowPlacement(szPath, szName, this);
	m_pCfg->Save(szCfgFileName, PCT_CLEARED_CONFIG);
}


/////////////////////////////////////////////////////////////////////////////
//      WM_SYSCOMMAND
// ( SC_RESTORE)    .
/////////////////////////////////////////////////////////////////////////////
inline void EWindowPlacement::Restore()
{
	rcNormalPosition = m_rcRestore;
	::SetWindowPlacement(m_hWnd, this);
}


/////////////////////////////////////////////////////////////////////////////
//      WM_WINDOWPOSCHANGED 
//     m_rcRestore (  ).
/////////////////////////////////////////////////////////////////////////////
inline void EWindowPlacement::PosChanged()
{
	::GetWindowPlacement(m_hWnd, this);
	if(showCmd != SW_SHOWMAXIMIZED) m_rcRestore = rcNormalPosition;
}



/////////////////////////////////////////////////////////////////////////////
#endif // __EWINDOWPLACEMENT_H__