// WindowsFunc.h : header file
//

#ifndef __WINDOWSFUNC_H__
#define __WINDOWSFUNC_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  WindowsFunc.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_WINDOWSFUNC   "17.01.2011"



////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////
inline BOOL _EcxSetWindowText(HWND hWnd, LPCTSTR lpRightText, LPCTSTR lpLeftText)
{
	DWORD dwStyle = ::GetWindowLong(hWnd, GWL_STYLE);
	BOOL isMinMax = dwStyle & (WS_MAXIMIZEBOX | WS_MINIMIZEBOX);
	BOOL isSysm = dwStyle & WS_SYSMENU;
	if(!(dwStyle & WS_CAPTION)) return FALSE;

	NONCLIENTMETRICS ncm;
	ncm.cbSize = sizeof(NONCLIENTMETRICS);
	::SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, &ncm, 0);

	HDC hDC = ::GetDC(hWnd);
	HFONT hFont = ::CreateFontIndirect(&ncm.lfCaptionFont);
	HFONT hFontOld = (HFONT)::SelectObject(hDC, hFont);


	int nRightText, nLeftText;
	nRightText = nLeftText = 0;

	if(lpRightText != NULL) nRightText = strlen(lpRightText);
	if(lpLeftText != NULL) nLeftText = strlen(lpLeftText);

	//  
	SIZE size;
	::GetTextExtentPoint32(hDC, lpRightText, nRightText, &size);
	nRightText = size.cx;
	::GetTextExtentPoint32(hDC, lpLeftText, nLeftText, &size);
	nLeftText = size.cx;
	::GetTextExtentPoint32(hDC, "          ", 10, &size);
	int nSpace = size.cx / 10;

	//   ;  
	::SelectObject(hDC, hFontOld);
	::ReleaseDC(hWnd, hDC);
	::DeleteObject(hFont);

	int dx1 = (isSysm) ? 2 * (ncm.iCaptionWidth + ncm.iBorderWidth) + 1 : 0;
	int dx2 = (isMinMax) ? dx1 : 0;

	RECT rc;
	::GetClientRect(hWnd, &rc);
	int nWidth = rc.right - nRightText - nLeftText - dx1 - dx2;
	int nSpaces = nWidth / nSpace - 20;

	char* szSpaces = new char[nSpaces + 1];
	memset(szSpaces, 0x20, nSpaces);
	szSpaces[nSpaces] = '\0';

	int nText = nRightText + nLeftText + nSpaces;
	char* szText = new char[nText + 1];
	szText[0] = '\0';

	if(lpRightText != NULL) strcat(szText, lpRightText);
	if(lpLeftText != NULL) strcat(szText, szSpaces);
	if(lpLeftText != NULL) strcat(szText, lpLeftText);
	
	BOOL res = ::SetWindowText(hWnd, szText);

	delete [] szSpaces;
	delete [] szText;

	return res;
}



////////////////////////////////////////////////////////////////////////////
#endif // __WINDOWSFUNC_H__
